2008-05-14  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (GETPPID): implement
	* modules/syscalls/posix.lisp (getppid): export
	* modules/syscalls/configure.in (getppid): test

2008-05-13  Bruno Haible  <bruno@clisp.org>

	* src/m4/pkg.m4: New file, from pkg-config-0.23.

2008-05-13  Bruno Haible  <bruno@clisp.org>

	* src/m4/bold.m4 (BOLD_MSG): Fix underquoting.

2008-05-13  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (SETREUID, SETREGID, TGAMMA): implement
	* modules/syscalls/configure.in (setreuid, setregid, tgamma): check
	(signgam): fix test
	* modules/syscalls/posix.lisp (setreuid, setregid, tgamma): export

2008-05-13  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (USER-INFO): use I_to_uid instead of
	I_to_uint32; when getlogin() fails, signal an error instead of
	defaulting to getuid()

2008-05-12  Bruno Haible  <bruno@clisp.org>

	Clear spurious error messages on MacOS X 10.5.
	* m4/address.m4 (CL_ADDRESS_RANGE): Remove conftest.dSYM directory
	before conftest* files.
	* m4/eloop.m4 (CL_ELOOP): Likewise.
	* m4/filecharset.m4 (CL_FILECHARSET): Likewise.
	* m4/param.m4 (CL_MACHINE): Likewise.

2008-05-12  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (tp-mail): put clisp version into the subject line

2008-05-12  Sam Steingold  <sds@gnu.org>

	* foreign.d (convert_to_foreign): accept Fpointer as a C-POINTER
	so that POSIX:FOPEN value can actually be used by FFI

2008-05-11  Sam Steingold  <sds@gnu.org>

	* comptran.d (N_log_abs_R): fix a GC-safety bug (R_R_comp -
	comparison! - turned out to maygc)

2008-05-10  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1961475 ]: Hang on read-char-no-hang
	* stream.d (listen_char_buffered): when the next byte is '\n' and
	ChannelStream_ignore_next_LF is true, discard it and retry

2008-05-10  Sam Steingold  <sds@gnu.org>

	* clos-genfun4.lisp (no-next-method): signal
	SYS::SIMPLE-PROGRAM-ERROR instead of PROGRAM-ERROR because only
	the former accepts :FORMAT-CONTROL & :FORMAT-ARGUMENTS

2008-05-10  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/configure.in: when testing for
	XauGetAuthByAddr, must #include <X11/Xauth.h> for g++

2008-05-09  Sam Steingold  <sds@gnu.org>

	* describe.lisp (clisp-data-file): put the error message through i18n

2008-05-09  Sam Steingold  <sds@gnu.org>

	* condition.lisp (coerce-to-condition): use ERROR instead of
	SIGNAL to report TYPE-ERROR so that COERCE-TO-CONDITION never
	returns NIL (http://article.gmane.org/gmane.lisp.clisp.general/12208)

2008-05-09  Sam Steingold  <sds@gnu.org>

	* trace.lisp (trace, untrace): turn comments into doc strings

2008-05-08  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/configure.in: check size of pid_t
	* modules/syscalls/calls.c (GETTER, SETTER): move up in file
	(pid_to_I, I_to_pid): define based on SIZEOF_PID_T
	(GETSID, SETPGRP, SETPGID, KILL): use the above
	(GETTER1): add
	(GETSID): use it
	(SETPGID): replace with POSIX::%SETPGID
	(GETPGID): add
	* modules/syscalls/posix.lisp (GETPGID): add DEFSETF

2008-05-07  Sam Steingold  <sds@gnu.org>

	* version.sh: 2.45 (2008-05-15)

2008-05-07  Sam Steingold  <sds@gnu.org>

	* m4/ffcall.m4 (CL_FFCALL): suggest passing --host=... to the
	FFCALL configure if $ac_cv_build != $ac_cv_host

2008-05-07  Sam Steingold  <sds@gnu.org>

	* configure: accept --cbc to mean Configure/Build/Check and
	--build to mean the build host (the usual autoconf meaning)
	* makemake.in: rely on configure for cross-compilation too
	(EXTRAOBJ) [CROSS]: add gllib/malloc

2008-05-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (MYIMPROOT): use beta pages for the latest id-href.map
	(check-doc): use base, not boot, for better symbol coverage

2008-05-07  Sam Steingold  <sds@gnu.org>

	* describe.lisp (describe-object@symbol) [FFI]:
	print foreign type information

2008-05-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (encflags): ' -E UTF-8 -Epathname 1:1':
	UTF-8 for files, terminal, wildcard test
	1:1 for pathname

2008-05-07  Reini Urban  <rurban@x-ray.at>

	* modules/syscalls/calls.c (FMTID_SummaryInformation)
	(FMTID_UserDefinedProperties): enable also on UNIX_CYGWIN32

2008-05-07  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1959436 ]: Allow ending http_proxy with a slash
	* clhs.lisp (http-proxy): handle the trailing slash

2008-05-07  Reini Urban  <rurban@x-ray.at>

	* modules/syscalls/calls.c (FILE_FUNCTION, CLEARERR): fix g++ and
	cygwin compilation by casting the pointers to (FILE*)

2008-05-06  Bruno Haible  <bruno@clisp.org>

	* clos-specializer2.lisp (reinitialize-instance@specializer): Change
	error message.

2008-05-06  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (FFLUSH): add
	* modules/syscalls/posix.lisp (fflush): export
	(FILENO, FEOF, FERROR, FCLOSE): check return values

2008-05-06  Sam Steingold  <sds@gnu.org>

	* clos-class3.lisp, clos-genfun3.lisp, clos-methcomb2.lisp,
	* describe.lisp, foreign1.lisp, reploop.lisp:
	various small i18n message fixes

2008-05-05  Sam Steingold  <sds@gnu.org>

	* clos-genfun3.lisp (analyze-defgeneric): do not pass through
	gettext messages which contain no text, just format directives
	* clos-method2.lisp (program-error-reporter)
	(analyze-method-description): ditto

2008-05-05  Sam Steingold  <sds@gnu.org>

	* format.lisp (format-not-both-error): replaces format-conditional-error
	(format-parse-cs, format-conditional, formatter-main-1): use it

2008-05-05  Sam Steingold  <sds@gnu.org>

	* clos-slotdef1.lisp, compiler.lisp, lambdalist.lisp, trace.lisp:
	* clos-method1.lisp, clos-methcomb2.lisp: more uniform i18n messages

2008-05-03  Sam Steingold  <sds@gnu.org>

	* foreign.d (check_fvar_alignment): add
	(FOREIGN-VARIABLE, %OFFSET, FOREIGN-ALLOCATE): use it

2008-05-03  Sam Steingold  <sds@gnu.org>

	* charstrg.d, compiler.lisp, debug.d, defmacro.lisp, error.d:
	* funarg.d, record.d, sequence.d: tweak i18n messages

2008-05-02  Sam Steingold  <sds@gnu.org>

	* defs2.lisp (dispatch-reader): fix message
	* io.d (read_macro): ditto
	* pathname.d (SYS::LIB-DIRECTORY): ditto

2008-05-01  Sam Steingold  <sds@gnu.org>

	* utils/fix-perms.sh: *.xsl & *.css are not executable

2008-05-01  Sam Steingold  <sds@gnu.org>

	* macros1.lisp (*suppress-similar-constant-redefinition-warning*):
	new user variable
	(defconstant): pass ,initial-var to constant-warning
	(constant-warning): accept 3rd variable and respect
	*suppress-similar-constant-redefinition-warning*
	* constobj.d (version): bump, because constant-warning is ABI

2008-04-30  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1928759 ]: (format nil "~8e" .999999d0) => " 10.0d-1"
	* format.lisp (format-float-for-e): when format-float-to-string
	rounds up above 1, adjust everything

2008-04-23  Sam Steingold  <sds@gnu.org>

	* fill-out.lisp (stream-start-s-expression@t): return
	*PRINT-RIGHT-MARGIN*, just like in format.lisp

2008-04-23  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (clisp_gettext): the common part of ...
	(clgettext, clgettextl): use it

2008-04-23  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (documentation@symbol@impnotes): look into impnotes
	for CUSTOM symbols too, so that (documentation 'impnotes-root
	'sys::impnotes) works

2008-04-23  Sam Steingold  <sds@gnu.org>

	followup to the 2008-04-08 patch which broke log for very small numbers
	* comptran.d (N_log_abs_R): avoid the log(1 + (x^2 + y^2 - 1))
	trick for small numbers
	* realtran.d (ln2_F_float_F): use F_lnx1_F instead of F_lnx_F
	(F_lnx_F): move most of the calculation from R_ln1_R here
	(R_ln1_R): use either F_lnx1_F (small arg) or F_lnx_F (others)
	(R_ln_R): do not call R_ln1_R, call F_lnx_F directly

2008-04-22  Sam Steingold  <sds@gnu.org>

	* makemake.in (installdirs, install-bin, uninstall): pass DESTDIR
	to make in po
	* po/Makefile.in.in (install-data-yes, installdirs): respect DESTDIR
	* configure: do not try to link po twice

2008-04-22  Sam Steingold  <sds@gnu.org>

	* arilev1.d, hashtabl.d, lisparit.d, lispbibl.d, misc.d:
	* pathname.d, spvw.d, spvw_garcol.d, spvw_memfile.d, time.d, unix.d:
	* xthread.d, modules/berkeley-db/bdb.c:
	"#error" does not need quotes around the message

2008-04-17  Sam Steingold  <sds@gnu.org>

	simplify support for FFI modules which want to use stdio.h
	* lispbibl.d (HAVE_FFI): export to clisp.h
	* foreign.d (init_ffi): register size_t and ssize_t
	* foreign1.lisp (size_t, ssize_t, FILE): add types
	* modules/bindings/glibc/linux.lisp ((size_t, ssize_t): do not redefine
	* modules/pari/pari.lisp (allocatemoremem): use size_t
	* modules/postgresql/postgresql.lisp (size_t): do not redefine
	(PQtrace, PQprint, PQdisplayTuples, PQprintTuples):
	use FILE instead of c-pointer
	* modules/syscalls/calls.c (fopen, fdopen, fclose)
	(clearerr, feof, ferror, fileno) [HAVE_FFI]: implement
	* modules/syscalls/posix.lisp (fopen, fdopen, fclose)
	(clearerr, feof, ferror, fileno) [FFI]: export

2008-04-17  Sam Steingold  <sds@gnu.org>

	* modules/bindings/glibc/linux.lisp (FILE): define to c-pointer,
	use for all FILE functions instead of c-pointer

2008-04-17  Sam Steingold  <sds@gnu.org>

	* modules/postgresql/postgresql.lisp: sync with libpq-fe.h 1.141 (8.3)
	(PQconnectionNeedsPassword, PQconnectionUsedPassword, PQisthreadsafe)
	(PQnparams, PQparamtype, PQdescribePrepared, PQdescribePortal)
	(PQsendDescribePrepared, PQsendDescribePortal, PQescapeStringConn)
	(PQescapeByteaConn, lo_create, lo_truncate, PQencryptPassword)
	(pg_char_to_encoding, pg_encoding_to_char) [commented out for 8.1.4]
	(pg_valid_server_encoding_id): add
	sync with postgres_ext.h 1.17 (8.3)
	(PG_DIAG_SEVERITY, PG_DIAG_SQLSTATE, PG_DIAG_MESSAGE_PRIMARY)
	(PG_DIAG_MESSAGE_DETAIL, PG_DIAG_MESSAGE_HINT)
	(PG_DIAG_STATEMENT_POSITION, PG_DIAG_INTERNAL_POSITION)
	(PG_DIAG_INTERNAL_QUERY, PG_DIAG_CONTEXT, PG_DIAG_SOURCE_FILE)
	(PG_DIAG_SOURCE_LINE, PG_DIAG_SOURCE_FUNCTION): add
	* modules/postgresql/configure.in: check for the new functions

2008-04-16  Sam Steingold  <sds@gnu.org>

	* debug.d (read_form): pass the remainder of the input line to the
	command function
	* reploop.lisp (debug-reset-io, debug-help, debug-unwind, debug-quit)
	(debug-mode, debug-where, debug-up, debug-top, debug-down, bottom)
	(debug-frame-limit, debug-backtrace, debug-trap-on, debug-trap-off)
	(debug-redo, return, debug-continue, debug-print-error)
	(debug-inspect-error): accept the argline argument
	(debug-mode-[12345], get-frame-limit, debug-backtrace-[12345]): remove
	(wrap-user-commands): pass argline to user function
	(commands1, commands4): update
	(break-loop): pass argline to the restart caller

2008-04-16  Sam Steingold  <sds@gnu.org>

	* reploop.lisp (break-loop): bind *saved-debug-package* &
	*saved-debug-readtable* so that only that binding is modified by
	debug-reset-io, not the global sane values

2008-04-14  Sam Steingold  <sds@gnu.org>

	* modules/dirkey/dirkey1.lisp: do not re-export LDAP functions from EXT

2008-04-14  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1942246 ]: (coerce 1 '(double-float 0d0)) fails
	* predtype.d (COERCE): when result_type is a list, pass its CAR to
	coerce_float() instead of the whole list

2008-04-14  Sam Steingold  <sds@gnu.org>

	* stream.d (sec_usec_number): usec should be _divided_ by 1000000,
	not multiplied by it
	* modules/syscalls/calls.c (rusage_to_lisp): add,
	use sec_usec_number() instead of C arithmetics
	(USAGE): use it instead of GETRU

2008-04-09  Sam Steingold  <sds@gnu.org>

	* lispbibl.d: g++ 4.2.* and 4.3.0 are not supported due to g++ bug 35708

2008-04-08  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1934968 ]: log(complex) sometimes inaccurate
	* comptran.d (R_R_norm2_1_R): new function
	(N_log_abs_R): use it together with R_ln1_R
	* realtran.d (F_lnx1_F): converted from F_lnx_F to accept y=x-1
	(F_lnx_F): use F_lnx1_F
	(R_ln1_R): converted from R_ln_R to accept y=x-1
	(R_ln_R): use R_ln1_R

2008-04-07  Sam Steingold  <sds@gnu.org>

	partially fix bug #[ 1934968 ]: log(complex) sometimes inaccurate
	* comptran.d (N_log_abs_R): new function: compute (log (abs z))
	without using hypot, thus avoiding a square root
	(N_log_N, N_N_log_N): use it

2008-04-06  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1936255 ]: COMPILE discards MACRO doc strings
	* compiler.lisp (generatedp): handle lambda lists from macroexpanders

2008-04-06  Sam Steingold  <sds@gnu.org>

	* describe.lisp (describe-object): update slot access of
	FOREIGN-VARIABLE and FOREIGN-FUNCTION for the fv_version/ff_version
	* documentation.lisp (set-function-documentation): ff_properties is 6
	* foreign1.lisp (foreign-function-in-arg-count): ff_argtypes is 4

2008-04-03  Sam Steingold  <sds@gnu.org>

	* lisparit.d, intprint.d (UDS_to_DIGITS): rename to UDS_to_digits
	(DIGITS): rename to digits_t
	(power_table_entry): rename to power_table_entry_t

2008-04-03  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1790496 ]: float format directive ~ve prints spurious digits
	* lisparit.d (FLOAT-SCALE-EXPONENT): implement
	* constsym.d, subr.f (float_scale_exponent): declare
	* format.lisp (format-scale-exponent-aux, format-scale-exponent): remove
	(format-float-for-e, format-general-float): use
	FLOAT-SCALE-EXPONENT instead of FORMAT-SCALE-EXPONENT

2008-04-02  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1928735 ]: BIGNUM failure
	* intread.d (DIGITS_to_I): drop leading 0s; be extra permissive in the
	initial length check, but perform an overflow check on each erg_len
	increment

2008-04-02  Sam Steingold  <sds@gnu.org>

	* makemake.in (interpreted.mem, halfcompiled.mem): work around an
	msys "feature": ":" after "/" is converted to a ";"

2008-04-02  Vladimir Volovich  <vvv2@users.sourceforge.net>
	Sam Steingold  <sds@gnu.org>

	* makemake.in: quote arguments of "test -n" (fix bug #[ 1932548 ])

2008-04-01  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1931097 ]: cross-compile mode tries to execute intparam
	* makemake.in (PARAMS) [CROSS]: use touch, not executables, for
	intparam and floatparam because the constants are defined in config.h
	(UTILCC) [CROSS]: define to cc instead of $(CC) because the
	utilities (gctrigger et al) must run locally

2008-04-01  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1931101 ]: new-clx QUERY-COLORS wants colors not pixels
	* modules/clx/new-clx/clx.f (XLIB:QUERY-COLORS): expect pixel sequence
	(coerce_into_color): just fill pixels

2008-03-31  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1929516 ]: m4:CL_INTPARAM_ALIGNOF loops infinitely when
	cross-compiling
	* m4/intparam.m4 (CL_INTPARAM_ALIGNOF): require CL_OFFSETOF and
	include <stddef.h> so that offsetof is defined
	(CL_INTPARAM_CROSS): disable [void (*)(void)] because compilation
	fails, while the results are never used

2008-03-30  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1929496 ]: cosmetic informational message fix
	* m4/param.m4: set cl_machine_file_h before the cross_compiling test
	so that it is defined in both branches

2008-03-30  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (GETGROUPS, %SETGROUPS): implemented
	* modules/syscalls/posix.lisp (GETGROUPS): export, add DEFSETF
	* modules/syscalls/configure.in: check for getgroups and setgroups
	* src/lispbibl.d (llength1): export to clisp.h

2008-03-29  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1928920 ]: missing quotes in shell code for test invocation
	* m4/intparam.m4: use ac_cv_type_long_long_int
	instead of the obsolete ac_cv_type_long_long

2008-03-28  Yann Dauphin  <yann-nicolas.dauphin@polymtl.ca>
	Sam Steingold  <sds@gnu.org>

	* spvw_gcmark.d (down_sxrecord) [USE_JITC]: when gc_drop_jitc,
	replace cclosure_jitc with NIL

2008-03-27  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1683394 ]: TANH floating point overflow for large floats
	* realtran.d (posF_tanh_posF): new function: 1-exp(-2x)/1+exp(-2x)
	(R_tanh_R): use it instead of R_cosh_sinh_R_R when |x|>=1

2008-03-25  Sam Steingold  <sds@gnu.org>

	* array.d, control.d, debug.d, eval.d, execname.c, hashtabl.d:
	* io.d, lisparit.d, lispbibl.d, list.d, package.d, pathname.d:
	* predtype.d, record.d, sequence.d, spvw.d, spvw_circ.d:
	* spvw_debug.d, spvw_garcol.d, spvw_language.d, spvw_memfile.d:
	* stream.d, weak.d: add extra braces to work around the g++ 4.2
	error "jump to label ... crosses initialization of ..."

2008-03-25  Sam Steingold  <sds@gnu.org>

	* m4/cc-sunpro.m4: new file, define CL_CC_SUNPRO
	* configure.in: call CL_CC_SUNPRO
	* makemake.in: use CC_SUNPRO, set by CL_CC_SUNPRO, to detect
	SUN SUNWspro C compiler (instead of "$CC -flags")
	Reported by Vladimir Volovich <vvv2@users.sourceforge.net>

2008-03-25  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1924501 ]: cannot find gllib include
	* makemake.in (CPPFLAGS): pass -Igllib here, not CFLAGS

2008-03-24  Vladimir Volovich  <vvv2@users.sourceforge.net>
	Sam Steingold  <sds@gnu.org>

	fix bug #[ 1924508 ]: undefined symbol getSP when linking lisp.run
	on Sparc Solaris 2.8 using Sun Studio 11
	* spsparc.d, spsparc64.d: add global getSP

2008-03-24  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1924506 ]: void function cannot return value
	* foreign.d (convert_to_foreign): "return void" does not work on
	Solaris 2.8

2008-03-24  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (NULL): #undef before defining
	to avoid "warning: macro redefined: NULL"

2008-03-24  Sam Steingold  <sds@gnu.org>

	* gray.lisp (stream-read-sequence): define methods for
	fundamental-binary-input-stream & fundamental-character-input-stream
	(stream-write-sequence): define methods for
	fundamental-binary-output-stream & fundamental-character-output-stream

2008-03-23  Sam Steingold  <sds@gnu.org>

	implemented GRAY:STREAM-READ-SEQUENCE and GRAY:STREAM-WRITE-SEQUENCE
	* defs2.lisp (%read-sequence): rename from READ-SEQUENCE
	(read-sequence): call it or GRAY::STREAM-READ-SEQUENCE
	(%write-sequence): renamed from WRITE-SEQUENCE
	(write-sequence): call it or GRAY::STREAM-WRITE-SEQUENCE
	* gray.lisp (stream-read-sequence, stream-write-sequence): implemented
	Suggested by Anton Vodonosov <avodonosov@yandex.ru>.

2008-03-21  Sam Steingold  <sds@gnu.org>

	* lispbibl.d, debug.d (gdb_show_stack): renamed from ext_show_stack
	* lispbibl.d (gdb_disassemble_closure): add protorype
	* debug.d (gdb_disassemble_closure): implement
	* constsym.d (disassemble_closures): add

2008-03-21  Sam Steingold  <sds@gnu.org>

	* eval.d (cclosure_run) [USE_JITC]: new local inline
	(interpret_bytecode) [USE_JITC]: use it instead of explicit code
	* lightning.c: use it instead of interpret_bytecode_()

2008-03-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCFLAGS) [XCC_GCC]: add -falign-functions=4 on all
	CPUs - it cannot hurt and is required at least on AMD64

2008-03-18  Sam Steingold  <sds@gnu.org>

	* lightning.c: use jit_movi_p instead of jit_movi_l for pointers
	to avoid "warning: cast from pointer to integer of different size"

2008-03-18  Sam Steingold  <sds@gnu.org>

	* stream.d (push_ch): extracted from read_line
	(read_line): use it
	* spvw_debug (nobject_out1): handle arrays

2008-03-18  Sam Steingold  <sds@gnu.org>

	* makemake.in, lispbibl.d: USE_JITC requires HEAPCODES

2008-03-18  Drutsa Pavel  <rawlik@users.sourceforge.net>

	fix bug #[ 1918017 ]: new-clx:gcontext-clip-mask does not set rectangles
	* modules/clx/new-clx/clx.f (XLIB:SET-GCONTEXT-CLIP-MASK): do not
	divide n by 4 when passing to XSetClipRectangles - it has already
	been done by get_seq_len()

2008-03-17  Sam Steingold  <sds@gnu.org>

	* lightning.c (jit_compile_): restore the semantics of byteptr_min
	as in interpret_bytecode_() (fixes --with-debug compilation)

2008-03-17  Sam Steingold  <sds@gnu.org>

	drop JITC objects before saving memory
	* debug.d (GC): accept optional argument to invalidate JITC objects;
	return 3 values (same as %ROOM)
	* subr.d (gc): update declaration
	* lightning.c (gc_drop_jitc): add variable
	* spvw_garcol.d (gar_col): accept level argument to invalidate
	JITC objects (when 1, set gc_drop_jitc to true)
	* lispbibl.d (gar_col): update prototype
	(gc_drop_jitc) [USE_JITC]: declare extern
	* pathname.d (SAVEMEM): pass 1 to gar_col()
	* spvw_memfile.d (savemem): pass 1 to gar_col()
	* spvw_allocate.d (make_space_gc, make_space_gc_true)
	(make_space_gc_false): pass 0 to gar_col()
	* spvw_gcmark.d (down_cclosure) [USE_JITC]: do not mark JITC when
	gc_drop_jitc is true

2008-03-17  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (DEF-C-CONST): pass NIL as version to
	FIND-FOREIGN-FUNCTION (finish patch [ 1913831 ])
	* foreign.d (foreign_library_check): when version is non-NIL,
	coerce it to simple-string
	* documentation.lisp (function-documentation): foreign-function
	properties are now in slot 6

2008-03-17  Sam Steingold  <sds@gnu.org>

	* spvw_gcmark.d (down_cclosure) [USE_JITC]: check that the
	cclosure has been already JIT-compiled before gc_mark_jitc_object()
	Reported by Yann Dauphin <yann-nicolas.dauphin@polymtl.ca>
	* lightning.c (next_byte) [FAST_DISPATCH]: undefine to avoid
	error: 'cod_labels' undeclared

2008-03-16  Sam Steingold  <sds@gnu.org>

	* lightning.c (DEBUG_CHECK_BYTEPTR): do not redefine
	(jitc_jmp_cons_): replace with struct jitc_insn_list in a more C style
	* makemake.in [with_jitc=lightning]: compile eval.c with -Wno-unused
	* .gdbinit (build-id-verbose): do not set (not needed
	since gdb-6.6-45.fc8)

2008-03-13  Yann Dauphin  <yann-nicolas.dauphin@polymtl.ca>

	* eval.d, lightning.c: cleanup: avoid using Lisp objects with malloc,
	use jitc_ prefix for macros defined in CLISP to separate from the
	system code

2008-03-15  Sam Steingold  <sds@gnu.org>

	patch #[ 1913831 ]: dlvsym support in FFI
	* lispbibl.d (Fvariable): add field fv_version
	(Ffunction): add field ff_version
	* io.d (pr_orecord): print foreign variable and function version
	* foreign.d (error_version_nonlibrary, find_name_version): add
	(foreign_library_variable, FIND-FOREIGN-VARIABLE)
	(foreign_library_function, FIND-FOREIGN-FUNCTION)
	(object_handle, object_address, foreign_library_check): accept VERSION
	(update_library): handle versioned objects
	* foreign1.lisp (def-call-out, def-c-var): accept :VERSION
	* subr.d (find_foreign_variable): accept 5 arguments
	(find_foreign_function): accept 6 arguments
	* m4/dynload.m4 (CL_DYNLOAD): check for dlvsym
	Suggested by Kaz Kylheku <kkylheku@gmail.com>.

2008-03-14  Sam Steingold  <sds@gnu.org>

	* m4/ffcall.m4 (CL_FFCALL): do not nest AC_CACHE_CHECK

2008-03-13  Sam Steingold  <sds@gnu.org>

	* m4/ffcall.m4 (CL_FFCALL): reinstate AC_CACHE_CHECK,
	restore LIBS after a failed test

2008-03-12  Sam Steingold  <sds@gnu.org>

	* src/glm4/lib-link.m4: updated from gnulib, discarding my changes
	* src/m4/ffcall.m4 (CL_FFCALL): updated for the new AC_LIB_LINKFLAGS

2008-03-12  Sam Steingold  <sds@gnu.org>

	* foreign.d (FOREIGN-POINTER-INFO): add interface to dladdr()
	* constsym.d, subr.d (foreign_pointer_info): declare
	* m4/dynload.m4 (CL_DYNLOAD): check for dladdr()
	* foreign1.lisp (FOREIGN-POINTER-INFO): export

2008-03-12  Sam Steingold  <sds@gnu.org>

	* makemake.in (clean4): also remove ${SUBDIRS} (gllib)

2008-03-12  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/configure.in: fix last patch: cannot nest
	AC_TRY_LINK; fail if XauGetAuthByAddr was not found
	also define HAVE_XGETATOMNAMES when XGetAtomNames is present (4y late!)

2008-03-12  Reini Urban  <rurban@x-ray.at>

	* modules/clx/new-clx/configure.in: explicit check for -lXau,
	needed at least for cygwin

2008-03-11  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (TAGS, tags): new targets

2008-03-11  Sam Steingold  <sds@gnu.org>

	* version.sh: 2.45 (2008-04-04)

2008-03-11  Sam Steingold  <sds@gnu.org>

	keep in our cvs some externally maintained files - because
	requiring ./autogen.sh after cvs co is outrageous
	* autogen.sh: remove
	* Makefile.devel (build-aux-update): update ltmain.sh,
	libtool.m4 (from libtool 2.2) and gtk-2.0.m4 (from gtk2 svn) here
	(gnulib-imported): decouple from build-aux-update

2008-03-10  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-form-table): SORT & STABLE-SORT -> c-SORT
	(c-SORT): new function (check arg order, map STABLE-SORT to SORT)
	* eval.d (FUNTAB): remove stable_sort, add symbol_macro_expand
	* constobj.d (version): bump

2008-03-10  Sam Steingold  <sds@gnu.org>

	thread safety: remove static variables
	* pathname.d (struct file_status): new struct type
	(file_status_init): new function
	(assure_dir_exists): accept a pointer to struct file_status
	instead of using STACK_0; return the value in struct file_status
	(assume_dir_exists): remove
	(file_exists): use struct file_status instead of a global static
	(true_namestring): accept struct file_status, do not modify STACK
	(TRUENAME, PROBE-FILE, DELETE-FILE, rename_file, open_file, CD)
	(FILE-WRITE-DATE, EXECUTE): update true_namestring invocations
	(open_input_file, with_stat_info_computed): accept struct file_status
	(get_time_size): accept pathname directly without STACK
	(with_stat_info): remove
	(with_stat_info_arg): rename to with_stat_info
	(directory_search_scandir, directory_search, shorter_directory):
	update the assure_dir_exists invocations

2008-03-09  Sam Steingold  <sds@gnu.org>

	* pathname.d (assure_dir_exists) [WIN32_NATIVE]:
	move some code outside of with_sstring_0()
	(assume_dir_exists): local, not global
	* lispbibl.d (assume_dir_exists): remove prototype
	* stream.d (finish_output_buffered): remove "#if 0" code which used
	assume_dir_exists()

2008-03-06  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-GLOBAL-FUNCTION-CALL): treat SYS::%UNBOUND using ...
	(function-code-list): SYS::%UNBOUND --> ((PUSH-UNBOUND 1) (POP))
	* clos-class6.lisp, clos-genfun1.lisp, clos-method1.lisp:
	pass (SYS::%UNBOUND) as the first argument to EQ so save one
	bytecode instruction (since this involves an internal CLISP
	function, it does not warrant a general optimization in c-EQ)

2008-03-05  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (l-constantp, c-constantp): hash tables are constants
	(c-constant-value): handle hash tables; check for unhandled types

2008-03-05  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-VAR): when the variable is a constant,
	make anode foldable
	(c-GLOBAL-FUNCTION-CALL): fold some calls (NULL/CONSP/XOR...)

2008-03-03  Sam Steingold  <sds@gnu.org>

	c-NORMAL-FUNCTION-CALL can now fold calls
	* compiler.lisp (try-constant-fold): extracted from
	c-DIRECT-FUNCTION-CALL
	(return-if-foldable): new macro, uses try-constant-fold
	(c-NORMAL-FUNCTION-CALL, c-DIRECT-FUNCTION-CALL): use it
	(function-code-list): extracted from c-GLOBAL-FUNCTION-CALL
	(c-GLOBAL-FUNCTION-CALL): use it
	(collect-arg, collect-args): add
	(c-NORMAL-FUNCTION-CALL, c-DIRECT-FUNCTION-CALL)
	(c-GLOBAL-FUNCTION-CALL): use them
	* record.d, subr.d (%UNBOUND): seclass_read, not seclass_foldable,
	because (const-value (new-const #<unbound>)) is NIL

2008-03-03  Sam Steingold  <sds@gnu.org>

	* hashtabl.d, subr.d (GETHASH): seclass_read, not seclass_default

2008-03-02  Sam Steingold  <sds@gnu.org>

	* defs2.lisp (define-hash-table-test): use check-symbol

2008-03-02  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-recompile): do not specify file name in "-o",
	just the directory

2008-03-02  Sam Steingold  <sds@gnu.org>

	* .gdbinit (build-id-verbose): set to 0 to avoid fedora yum messages
	(main_actions): silent break to call check_funtab()

2008-03-01  Sam Steingold  <sds@gnu.org>

	* clos-genfun4.lisp (check-gf-lambda-list): new function
	(generic-function-argument-precedence-order, generic-function-argorder)
	(generic-function-lambda-list, generic-function-signature): use it

2008-02-29  Sam Steingold  <sds@gnu.org>

	* analyse-funtab.lisp: new file: study which functions should be
	added to eval.d:FUNTAB
	* eval.d (FUNTAB): add check_function_name, typep_class,
	defined_class_p, proper_list_p, pcompiled_function_p, make_macro,
	macrop, macro_expander, symbol_macro_p, standard_instance_access,
	set_standard_instance_access, encodingp
	(FUNTABR): add mapcap
	* constobj.d (version): bump

2008-03-01  Sam Steingold  <sds@gnu.org>

	* record.d (CONSTANT_INITFUNCTION_P): new define
	(CONSTANT-INITFUNCTION-P, %SHARED-INITIALIZE, do_initialize_instance):
	(%MAKE-INSTANCE): use it

2008-02-29  Sam Steingold  <sds@gnu.org>

	* record.d (CLOSURE-CONSTS): fix for the jitc addition

2008-02-29  Sam Steingold  <sds@gnu.org>

	* io.d (pr_cclosure_lang): fix printing of lalist & docstring yet again

2008-02-27  Sam Steingold  <sds@gnu.org>

	use keyword symbols from the core when possible
	* utils/modprep.lisp (mk-objdef, objdef-object, objdef-local): add
	(parse-signature, new-checker): use mk-objdef instead of init-to-objdef
	(check-signature, lexical-analysis, print-tables-1): use
	objdef-object & objdef-local instead of objdef-tag
	NB: this feature is actually disabled because
	&S(...) is invalid (S() is not an lvalue) in non-debug builds
	* modules/berkeley-db/bdb.c, modules/gdbm/gdbm.c, modules/pcre/cpcre.c:
	* modules/syscalls/calls.c, modules/regexp/regexi.c:
	* modules/rawsock/rawsock.c, modules/clx/new-clx/clx.f:
	use #\: in DEFUN to denote core keywords
	* constsym.d (Kcopy): always define
	(Kpreserve, Kinvert): add
	* spvw_debug.d (get_symbol_count, get_constsym) [DEBUG_SPVW]: add
	* modules/syscalls/calls.c (CONSTSYM) [DEBUG_SPVW]: use them

2008-02-27  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c use S(K...) instead of `...` for
	common keywords
	(copy_method_t): move before DEFMODULE for DEFCHECKER to work
	(check_copy_method): replace with a DEFCHECKER
	(copy_method_object): remove

2008-02-26  Sam Steingold  <sds@gnu.org>

	* modules/wildcard/Makefile.in (all): depend on wildcard.fas
	* modules/oracle/Makefile.in (all): depend on oracle.fas
	* modules/fastcgi/Makefile.in (all): depend on fastcgi.fas
	* modules/bindings/glibc/Makefile (all): depend on linux.fas
	* modules/postgresql/Makefile.in (all): depend on postgresql.fas

2008-02-26  Sam Steingold  <sds@gnu.org>

	a less invasive work-around for bug #[ 1413016 ]:
	it is not amd64 which is at fault, but TYPECODES
	* makemake.in (XCFLAGS): revert the 2007-10-15 patch
	* spvw_garcol.d (update) [TYPECODES]: comment out DEBUG_SPVW_ASSERT
	(gc_unmarkcheck) [TYPECODES]: disable

2008-02-26  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (DEBUG_SPVW_ASSERT): print the failed assertion
	before abort() both as is and with expanded macros

2008-02-25  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (src/m4/gtk-2.0.m4): use wget instead of svn
	* autogen.sh: svn is no longer required, let us keep it this way!

2008-02-24  Sam Steingold  <sds@gnu.org>

	* configure (info_help): use ./src/configure to get the list
	of options which specify location of dependencies

2008-02-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CHECKOUT): do not specialize
	on a specific user, one can always use a symlink

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* configure (info_help): Mention the --with[out]-lib*-prefix options.
	Sort the other options like autoconf does.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* autogen.sh: New file.
	* Makefile.devel (build-prerequisites): New target.
	(all): Depend on it.
	(EXCLUDE): Exclude autogen.sh.
	* utils/fix-perms.sh: Ensure autogen.sh is executable.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* Makefile.devel (GTK2_SVN_ROOT): New variable.
	(src/m4/gtk-2.0.m4): New rule.
	(src/aclocal.m4): Depend on it.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* makemake.in (COPYRIGHT.rtf): Fix escaping.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	Make it easier to update the gnulib imported files.
	* Makefile.devel (GNULIB_CVS_ROOT, GNULIB_CVS_REPOSITORY): New
	variables.
	(GNULIB_CHECKOUT): Renamed from GNULIB_HOME. Make it normally a
	subdirectory of the current directory.
	(update-gnulib): New rule.
	(build-aux-update): Depend on it.
	(gnulib-imported): Rename from gnulib-update.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* Makefile.devel (build-aux-update): Pass option -d to 'cvs update'.
	Remove unportable 'cd -' command.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	Add rule for fetching a working libtool.m4.
	* build-aux/ltmain.sh: Remove file.
	* Makefile.devel (src/aclocal.m4): Depend on src/m4/libtool.m4.
	(build-aux-update): Depend on src/build-aux/ltmain.sh.
	(LIBTOOL_VERSION, LIBTOOL_SOURCE_FILE, LIBTOOL_SOURCE_URL): New
	variables.
	(src/build-aux/ltmain.sh src/m4/libtool.m4): New rule.
	(EXCLUDE): Also exclude the LIBTOOL_SOURCE_FILE and its predecessors.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	fix bug #[ 1836142 ] part 2.
	* lispbibl.d (STACK_register, mv_count_register, value1_register)
	(back_trace_register): Don't define for gcc-4.2 and newer when
	USE_GCC_REGISTER_VARIABLES is not defined.

2008-02-24  Bruno Haible  <bruno@clisp.org>

	* lispbibl.d (STACK_register, mv_count_register, value1_register)
	(back_trace_register): Define for gcc-3.3.[4-6].

2008-02-23  Bruno Haible  <bruno@clisp.org>

	fix bug #[ 1836142 ] part 1.
	* floatparam.c (check): Change argument types to 'volatile type*'.
	This defeats optimizations of gcc 4.3.0 snapshots.

2008-02-16  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (create-fun-obj): jitc-p is true when either SPACE is 0
	or SPEED is at least 1
	* clos-genfun2b.lisp (*compile-no-jitc*): new constant
	(compute-discriminating-function-<generic-function>)
	(prototype-factory-table, finalize-fast-gf):
	use it in generated lambda declarations instead of (COMPILE)

2008-02-15  Sam Steingold  <sds@gnu.org>

	* lightning.c (jit_run): use !fpointerp instead of nullp
	to test cclosure_jitc
	(jit_compile_) [DEBUG_BYTECODE]: declare byteptr_bad_jump

2008-02-22  Sam Steingold  <sds@gnu.org>

	* io.d (pr_cclosure_lang): fix printing of lalist & docstring

2008-02-22  Sam Steingold  <sds@gnu.org>

	make sure that CREATE-FUN-OBJ uses the correct OPTIMIZE settings
	* compiler.lisp (fnode): add DENV slot
	(c-LAMBDABODY): (SETF (FNODE-DENV *FUNC*) *DENV*)
	(create-fun-obj): pass (FNODE-DENV FNODE) to DECLARED-OPTIMIZE
	(make-trampoline): revert last patch: do not bind *DENV*; instead,
	pass :DENV '((OPTIMIZE (SPACE 3) (SPEED 0))) to MAKE-FNODE

2008-02-19  Sam Steingold  <sds@gnu.org>

	* utils/fix-perms.sh: all *.d are non-executable

2008-02-19  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (make-trampoline): use backquote for readability;
	bind *DENV* for DECLARED-OPTIMIZE in CREATE-FUN-OBJ
	(create-fun-obj): compute (DECLARED-OPTIMIZE 'SPACE) just once,
	not 3 times
	(c-REQUIRE): do not suppress load libfile message completely

2008-02-19  Sam Steingold  <sds@gnu.org>

	* macros3.lisp (compile-time-value): new exported user macro
	* init.lisp (compile-time-value): export from EXT
	* compiler.lisp (c-COMPILE-TIME-VALUE): compile it
	(c-form-table): use c-COMPILE-TIME-VALUE for COMPILE-TIME-VALUE
	* foreign1.lisp (compile-time-value): remove broken definition

2008-02-15  Sam Steingold  <sds@gnu.org>

	* spvw.d, _clisp.c: remove the last vestiges of the -s command
	line option, removed on 2004-08-31

2008-02-14  Sam Steingold  <sds@gnu.org>

	* record.d (make_code_vector): converted from MAKE-CODE-VECTOR
	(make_closure): accept 7 keywords instead of 6 positional arguments;
	call make_code_vector on :CODE
	(make_constant_initfunction): update
	* subr.d, constsym.d (make_code_vector): remove
	* constsym.d (make_closure): rename from %MAKE-CLOSURE to MAKE-CLOSURE
	(Kcode, Kconstants, Kseclass, Klambda_list, Kdocumentation, Kjitc_p):
	add
	* subrkw.d (make_closure): add
	* eval.d (FUNTAB): remove make_code_vector
	* io.d (CLOSURE-READER): update the C_make_closure() call
	* compiler.lisp (make-closure): remove defun
	(create-fun-obj): update make-closure call

2008-02-14  Sam Steingold  <sds@gnu.org>

	* constobj.d (version): bump
	* constsym.d, subr.d, foreign.d (lookup_foreign_variable)
	(lookup_foreign_function, foreign_library_variable): remove legacy ABI
	* constsym.d, subr.d, foreign.d (open_foreign_library): renamed
	from foreign_library
	* foreign.d (open_library, update_library, check_library):
	remove legacy version argument
	* eval.d (FUNTAB): add cs_string_eq, cs_string_noteq, cs_string_less,
	cs_string_greater, cs_string_ltequal, cs_string_gtequal, cs_string,
	fdefinition, whitespacep, elastic_newline, cs_intern, cs_find_symbol,
	cs_shadow, cs_make_package, cs_find_all_symbols, cs_symbol_name,
	map_into, xgcd
	* foreign1.lisp (open-foreign-library): export
	* macros2.lisp (check-not-special-variable-p): remove legacy ABI
	* record.d, subr.d (MAKE-MACRO): both arguments are required

2008-02-13  Sam Steingold  <sds@gnu.org>

	first stab at keeping JITC code in the closure
	* compiler.lisp (make-closure): accept :jitc-p and pass it on to
	%make-closure in a cons cell together with seclass
	* eval.d (interpret_bytecode) [USE_JITC]: check cclosure_jitc_p
	and use jit_run instead of jit_compile_
	* io.d (CLOSURE-READER): pass jitc_p to make_closure
	(pr_cclosure_lang): write jitc_p
	* lightning.c (jitc_object): new struct
	(all_jitc_objects): new static
	(gc_mark_jitc_object): mark jitc_object
	(gc_scan_jitc_objects): scan all_jitc_objects
	(jit_compile_): save jitc_object in cclosure_jitc(closure)
	(jit_run): add
	* lispbibl.d (Codevec.ccv_flags): use bit(5) for jitc_p
	(ccv_flags_jitc_p, cclosure_jitc, cclosure_jitc_p): define
	(gc_mark_jitc_object, gc_scan_jitc_objects) [USE_JITC]: declare
	* record.d (%MAKE-CLOSURE): accept jitc_p in a cons cell with seclass
	(MAKE-CONSTANT-INITFUNCTION): pass (seclass . jitc_p)
	(CLOSURE-DOCUMENTATION, (SETF CLOSURE-DOCUMENTATION))
	(CLOSURE-LAMBDA-LIST): update for jitc_p
	* spvw_garcol.d (gar_col_normal) [USE_JITC]: call gc_scan_jitc_objects
	* spvw_gcmark.d (down_cclosure): define

2008-02-11  Sam Steingold  <sds@gnu.org>

	* io.d (pr_symbol_part): use pr_fasl_special only on fasl_streams

2008-02-11  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-sources): grep ${SRCDIR}*.d, not *.d
	* subrkw.d (make_thread): fix a typo

2008-02-11  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1890854 ]: read-preserving-whitespace eats whitespace
	after quoted object
	* io.d (list2_reader): bind *READ-RECURSIVE-P* around
	read_recursive_no_dot() to avoid *READ-PRESERVE-WHITESPACE* being
	re-bound to NIL in read_recursive()

2008-02-10  Sam Steingold  <sds@gnu.org>

	* clos-genfun2b.lisp (finalize-fast-gf): avoid calling
	prototype-factory twice on the same argument
	* record.d (%COPY-GENERIC-FUNCTION): use clos_venv instead of
	clos_consts[0]

2008-02-07  Sam Steingold  <sds@gnu.org>

	finally fix def-c-const
	* foreign1.lisp (compile-time-value): new macro
	(def-c-const): use it; do not use def-call-out for the constant
	function to avoid clutter
	(finalize-coutput-file): keep cftype in *constant-table*

2008-02-07  Sam Steingold  <sds@gnu.org>

	prepare for keeping jitc code in cclosure by not assuming that
	cclosure constants start at position 2 inside the record
	* constsym.d, subr.d (closure_const, set_closure_const): declare
	* record.d (CLOSURE-CONST, SET-CLOSURE-CONST): implement
	* pleces.lisp ((SETF CLOSURE-CONST)): define
	* compiler.lisp (pass3): use CLOSURE-CONST instead of SYS::%RECORD-REF
	(make-trampoline): use CLOSURE-CODEVEC instead of SYS::%RECORD-REF
	* defs2.lisp (dispatch-reader): use CLOSURE-CONST instead of %RECORD-REF
	and return constant number instead of record position in VECTOR-INDEX
	* io.d (SET-MACRO-CHARACTER, GET-MACRO-CHARACTER):
	O(dispatch_reader_index) contains position in
	TheCclosure(newclos)->clos_consts, not in
	((Srecord)TheCclosure(newclos))->recdata
	* trace.lisp (subclosure-pos, %local-get, %local-set): use
	CLOSURE-CONST instead of %RECORD-REF & %RECORD-STORE

2008-02-06  Sam Steingold  <sds@gnu.org>

	* .gdbinit (run_test, run_all_tests, ansi_tests, ansi_tests_compiled):
	pass -E utf-8 because all our files are in unicode

2008-02-06  Sam Steingold  <sds@gnu.org>

	accept "-lp" to add to *LOAD-PATHS*
	(and fix mingw separate directory build, see
	http://article.gmane.org/gmane.lisp.clisp.devel/17375
	http://article.gmane.org/gmane.lisp.clisp.devel/17388)
	* init.lisp (*load-paths*): do not reset
	* constsym.d (*load-paths*): add
	* spvw.d (init_symbol_values): init *LOAD-PATHS*
	(struct argv_actions): add argv_load_paths_count & argv_load_paths
	(parse_options): init p2->argv_load_paths_count & p2->argv_load_paths;
	argv_for now has an additional value: for_load_path;
	accept "-lp" and set argv_for to for_load_path for adding the
	argument o p2->argv_load_paths
	(main_actions): push -lp arguments to *LOAD-PATHS*
	* makemake.in: use -lp instead of setting *LOAD-PATHS* in -x

2008-02-06  Sam Steingold  <sds@gnu.org>

	the final fix for bug #[ 1578179 ]: Compile-file: non-similarity of
	strings with cr/lf (also treated on 2006-11-17 & 2008-02-04)
	* io.d (read_token_1): when reading from a FASL stream,
	read \r & \n as #\Return and #\Newline respectively
	(pr_symbol_part): when printing to a FASL stream,
	print #\Newline & #\Return as \r and \n respectively

2008-02-06  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1887934 ]: make clean removes Lisp source files
	* makemake.in (clean5): do not remove LISPFILES, they are not
	linked over since 2007-12-10

2008-02-04  Sam Steingold  <sds@gnu.org>

	* pathname.d (assure_dir_exists) [WIN32_NATIVE]: for consistency
	with UNIX, do NOT call MERGE-PATHNAMES on directories

2008-02-04  Sam Steingold  <sds@gnu.org>

	extend the meaning of the REVAL stream flag to mean a FASL stream:
	in addition to ignoring *READ-EVAL*, use \n for #\Newline and #\r
	for #\Return inside strings (replaces the 2006-11-17 patch #0Y"")
	* compiler.lisp (set-output-stream-fasl): extract from compile-file
	(compile-file): use it to mark *fasoutput-stream* & *liboutput-stream*
	as FASL streams with UTF-8 encoding
	* constsym.d, subr.d, stream.d (ALLOW-READ-EVAL): -> STREAM-FASL-P
	* constsym.d, gray.lisp, stream.d ($REVAL): rename to $FASL
	* init.lisp (load): do not mark input-stream as a FASL stream: a
	FAS file is marked as such with #0Y_; a lisp file is just a text file
	* lispbibl.d (strmflags_fasl_bit_B): rename from strmflags_reval_bit_B
	* lispbibl.d, stream.d (stream_get_read_eval): rename to stream_get_fasl
	(stream_set_read_eval): rename to stream_set_fasl
	* io.d (STRING-READER): when reading from a FASL stream, recognize \n\r
	(CLOSURE-READER): accept #0Y_ to set FASL flag, #0Y^ to clear it,
	do not accept #0Y""
	(pr_fasl_special): new function
	(pr_sstring_ab): use it; do not print #0Y to FASL streams
	(pr_instance, pr_orecord): use FASL stream flag instead of *COMPILING*

2008-02-04  Sam Steingold  <sds@gnu.org>

	* makemake.in: fix distrib on win32 when building in src

2008-02-04  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (DEF-C-CONST): use get-assoc & note-c-const
	(note-c-const): new ABI function; make the requirement that
	def-c-const must be compiled to C explicit for better error reporting

2008-02-03  Yann Dauphin  <yann-nicolas.dauphin@polymtl.ca>

	* lightning.c: new file, implements JITC via GNU lightning

2008-02-03  Sam Steingold  <sds@gnu.org>

	add JITC harness
	* configure: accept --with-jitc=FLAVOR
	* eval.d (interpret_bytecode) [USE_JITC]: use jit_run
	[USE_JITC]: load the appropriate jit implementation
	* configure.in: call CL_LIGHTNING
	* m4/lightning.m4: implement CL_LIGHTNING
	* lispbibl.d [USE_JITC]: disable registers when using JITC
	* makemake.in: accept --with-jitc=FLAVOR
	(XCFLAGS) [--with-jitc=FLAVOR]: add -DUSE_JITC -D${with_jitc}
	link over ${with_jitc}.c into the build directory
	(eval.o): depend on ${with_jitc}.c
	(clean5): remove ${with_jitc}.c

2008-01-30  Sam Steingold  <sds@gnu.org>

	* pprint.lisp (copy-pprint-dispatch): distinguish the 3 cases:
	no argument, NIL argument, table argument
	Reported by "Hoehle, Joerg-Cyril" <Joerg-Cyril.Hoehle@t-systems.com>

2008-01-30  Sam Steingold  <sds@gnu.org>

	* makemake.in: libsvm requires FFI
	* modules/fastcgi/configure.in, modules/oracle/configure.in:
	* modules/pari/configure.in, modules/postgresql/configure.in:
	* modules/wildcard/configure.in, modules/zlib/configure.in:
	fail if ffcall is not present

2008-01-29  Sam Steingold  <sds@gnu.org>

	* po/Makefile.devel (LISPSOURCES): remove affi1
	(DSOURCES): remove affi, add funarg

2008-01-29  Sam Steingold  <sds@gnu.org>

	* version.sh: 2.44 (2008-02-02)

2008-01-27  Sam Steingold  <sds@gnu.org>

	* comptran.d (C_rationalp): new macro
	(N_N_log_N, N_N_expt_N): use it

2008-01-27  Reini Urban  <rurban@x-ray.at>

	<35_trans4>
	* places.lisp, comptran.d, realrand.d, realtran.d:
	Translate comments to English. Convert # to /* */.

2008-01-27  Sam Steingold  <sds@gnu.org>

	* pathname.d (get_time_size) [WIN32_NATIVE]: strip trailing
	backslash from resolved_asciz and close search_handle.
	This actually fixes 2007-12-31 & 2008-01-25 patches.
	Thanks to Michael Kappert <michael.kappert@gmx.net> for testing.

2008-01-25  Sam Steingold  <sds@gnu.org>

	* pathname.d (get_time_size) [WIN32_NATIVE]: accept directories;
	this should fix the 2007-12-31 patch for woe32
	Thanks to Michael Kappert <michael.kappert@gmx.net> for testing.

2008-01-24  Sam Steingold  <sds@gnu.org>

	* lndir: do not link over CVS directories

2008-01-23  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1781476 ]: signal handling examples in glibc fail
	* modules/bindings/glibc/linux.lisp (sigaction): sa_restorer is
	now a generic pointer, not a pointer to a function, because...
	  The sa_restorer element is obsolete and should not be used.
	  POSIX does not specify a sa_restorer element.
	On Linux 2.6.22.7-57.fc6, sigaction(SIGINT) returns invalid
	pointers as sa_restorer

2008-01-23  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (finalize-coutput-file): constants
	*CONSTANT-TABLE* are now (const . guard)
	(DEF-C-CONST): accept :GUARD

2008-01-22  Sam Steingold  <sds@gnu.org>

	* modules/bindings/glibc/linux.lisp (SIGSET_NWORDS): compute using
	ffi:ulong, as specified in <bits/sigset.h>
	(sigset_t): array of ulong, as specified in <bits/sigset.h>

2008-01-22  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1407486 ]: FFI revalidates too many library functions
	in new session
	* foreign.d (check_faddress_valid): check that validate_fpointer()
	actually did make the pointer valid
	(update_library): make sure that the non-validatable object
	remains marked as invalid

2008-01-22  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (nobject_out1): print INVALID for invalid foreign
	functions and foreign addresses

2008-01-22  Sam Steingold  <sds@gnu.org>

	* control.d (APPLY, specdecled_): avoid GCC "warning: value
	computed is not used"

2008-01-22  Sam Steingold  <sds@gnu.org>

	* savemem.lisp (*saveinitmem-verbose*): add defvar
	(saveinitmem): :verbose defaults to *saveinitmem-verbose*
	* spvw.d (init_symbol_values): define *SAVEINITMEM-VERBOSE*
	(main_actions): set it to NIL when argv_verbose < 1
	* init.lisp (*saveinitmem-verbose*): export from CUSTOM
	(loading-message): permit more than 1 format argument
	* constsym.d (*saveinitmem-verbose*): add symbol

2008-01-22  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (savemem): return file length
	* lispbibl.d (savemem): update prototype
	* pathname.d (SAVEMEM): return file length

2008-01-21  Sam Steingold  <sds@gnu.org>

	* spvw.d (run_hooks): establish a DRIVER frame around the loop to
	enable reset() on errors in user code
	(main_actions): ditto around loading RC file, init files,
	compiling files, executing scripts (but not expression, they go
	through SYS::DRIVER)

2008-01-22  Sam Steingold  <sds@gnu.org>

	* reploop.lisp (with-abort-restart): new macro: establish the
	DEBUG catcher and the ABORT restart with a useful report function
	(main-loop, break-loop, step-hook-fn): use it

2008-01-22  Sam Steingold  <sds@gnu.org>

	fix bugs #[ 1877497 ]: the set of restarts grows with each image save
	and #[ 1714737 ]: Bad restarts when .clisprc signals errors.
	* savemem.lisp (saveinitmem): bind *ACTIVE-RESTARTS* &
	*CONDITION-RESTARTS* to NIL around SAVEMEM instead of setting them
	to NIL in the *DRIVER* to avoid multiple ABORT restarts in saved images

2008-01-21  Sam Steingold  <sds@gnu.org>

	* eval.d (reset): set unwind_protect_to_save.upto_frame;
	print a useful(?) error message on abort
	(CHECK_STACK, CHECK_STACK_S, CHECK_STACK_C): new macros
	(eval_fsubr, eval_subr, apply_subr, funcall_subr): use CHECK_STACK_S
	(eval_closure, apply_closure, funcall_closure): use CHECK_STACK_C
	(find_keyword_value, match_subr_key, match_cclosure_key): avoid
	GCC "warning: value computed is not used"

2008-01-19  Sam Steingold  <sds@gnu.org>

	* control.d (THE): raise TYPE-ERROR on failure

2008-01-18  Sam Steingold  <sds@gnu.org>

	* debug.d (print_back_trace, print_stackitem):
	also print FRAME offset from STACK_start
	(show_stack): use STACK_start instead of nullobj to check for stack end;
	print bt & FRAME _before_ testing for loop termination

2008-01-17  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1506316 ]: segfault in framep() debug.d:644
	* debug.d (stack_upend_p): use "STACK_start cmpSTACKop FRAME"
	instead of "eq(FRAME_(0),nullobj)" to check for STACK start
	(stack_downend_p): use "FRAME cmpSTACKop STACK" to check for STACK end

2008-01-17  Sam Steingold  <sds@gnu.org>

	* pathname.d (open_file): fix a gc-safety bug in (open
	... :direction :output :if-exists :rename-and-delete)
	by keeping namestring on the STACK all along

2008-01-16  Sam Steingold  <sds@gnu.org>

	* pathname.d (open_file): fix G++ compilation
	* charstrg.d (uc_width): remove the global inline declaration of
	the gnulib function to avoid a G++ warning

2008-01-16  Sam Steingold  <sds@gnu.org>

	* ariarm.d, lispbibl.d: convert comments from "# " to "/**/"

2008-01-16  Sam Steingold  <sds@gnu.org>

	* foreign.d (convert_function_to_foreign, convert_from_foreign)
	(convert_from_foreign_array_fill, convert_to_foreign, %ELEMENT):
	use while instead of dotimes and do/while instead of dotimesp
	(%ELEMENT): avoid GCC "warning: value computed is not used"

2008-01-16  Sam Steingold  <sds@gnu.org>

	* list.d (make_list, NTHCDR, listof, LIST*, APPEND, NCONC, NBUTLAST):
	use while instead of dotimes and do/while instead of dotimesp

2008-01-16  Sam Steingold  <sds@gnu.org>

	* sequence.d (REDUCE): use missingp
	(CONCATENATE, seq_boolop, MAP, MAP-INTO, delete_help, substitute_help):
	use while instead of dotimes and do/while instead of dotimesp
	(verify_return_value, VERIFY_RETURN_VALUE): add function & macro
	(MAKE-SEQUENCE, coerce_sequence, COERCED-SUBSEQ, CONCATENATE, MAP)
	(MERGE): use them
	(CONCATENATE, seq_boolop, MAP): avoid GCC
	"warning: value computed is not used"

2008-01-16  Reini Urban  <rurban@x-ray.at>

	<34_trans3>
	* sequence.d, list.d: translate all comments and convert them to /**/

2008-01-15  Sam Steingold  <sds@gnu.org>

	* debug.d (climb_stack_once, climb_stack_repeat): merge into climb_stack
	(FRAME-UP-1, FRAME-DOWN-1): remove
	(FRAME-UP, FRAME-DOWN): accept an additional REPEAT argument
	* reploop.lisp (frame-limit-down, frame-limit-up, debug-up)
	(debug-top, debug-down, debug-bottom, frame-up-down):
	use (frame-up 1 ...) instead of (frame-up-1 ...)
	and (frame-down 1 ...) instead of (frame-down-1 ...)
	and (frame-up t ...) instead of (frame-up ...)
	and (frame-down t ...) instead of (frame-down ...)
	(print-backtrace): use ~:P in message
	* constsym.d, subr.d (frame_up_1, frame_down_1): remove

2008-01-15  Bruno Haible  <bruno@clisp.org>

	* lispbibl.d (quit): Note the meaning of a negative final_exitcode.
	* spvw.d (quit_instantly): Likewise.
	(main): If exitcode is negative, quit the program through a signal
	rather than through exit().
	* spvw_sigterm.d (quit_on_signal): Set final_exitcode.

2008-01-14  Bruno Haible  <bruno@clisp.org>

	* spvw_sigterm.d (set_sigterm_handler): New function.
	(uninstall_sigterm_handler, install_sigterm_handler): Use it.
	(quit_on_signal): After raising the signal, return from the function.

2008-01-14  Bruno Haible  <bruno@clisp.org>

	* Makefile.devel: Use CONFIGURES instead of CLISP_CONFIGURES. Fixes
	problem introduced on 2008-01-05.

2008-01-14  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1871205 ]: how to quit upon SIGTERM, SIGKILL, or SIGQUIT
	* spvw_sigterm.d (quit_on_signal_in_progress): new static boolean
	(uninstall_sigterm_handler): undo the effects of install_sigterm_handler
	(quit_on_signal): call uninstall_sigterm_handler first thing so
	that the repeated signals bypass the handler and kill CLISP instantly

2008-01-13  Bruno Haible  <bruno@clisp.org>

	Make it work on OpenBSD 4.0 x86 with address space randomization.
	* lispbibl.d (ADDRESS_RANGE_RANDOMIZED): New macro.
	(LINUX_NOEXEC_HEAPCODES/STANDARD_HEAPCODES, TRIVIALMAP_MEMORY): Depend
	on it.

2008-01-13  Bruno Haible  <bruno@clisp.org>

	* spvw_memfile.d (loadmem_from_handle) [SPVW_MIXED_BLOCKS_OPPOSITE]:
	Fix the test whether there's enough room.

2008-01-13  Bruno Haible  <bruno@clisp.org>

	* makemake.in: Don't use $(MAKE) -C.

2008-01-13  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (STACK_start): declare new per_thread
	* spvw.d (STACK_start): create and ...
	(init_memory): init to the initial value of STACK
	* spvw_debug.d (nobject_out1): use STACK_start to print
	framepointers and framepointerp to check for them
	* io.d (pr_framepointer_1): new function: print frame offset from
	STACK_start instead of its address
	(pr_framepointer): use it instead of pr_hex6

2008-01-13  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (per_thread): per-thread storage class
	* spvw.d, lispbibl.d (STACK, callback_saved_registers)
	(saved_mv_count, saved_value1, saved_back_trace, saved_STACK)
	(SP_bound, STACK_bound, mv_count, mv_space, temp_mv_count)
	(temp_value1, back_trace, aktenv, unwind_protect_to_save)
	(handler_args, inactive_handlers): use per-thread instead of
	current_thread() fields

2008-01-12  Sam Steingold  <sds@gnu.org>

	* makemake.in: use add traling #\/ to gllib in "find" so that
	gllib can be a symlink

2008-01-12  Sam Steingold  <sds@gnu.org>

	* xthread.d: disable spin locks (gcc barfs)
	* constsym.d, subr.d, subrkw.d, threads.lisp, zthread.d:
	rename thread functions from PROCESS to THREAD
	* lispbibl.d (Rectype_Thread, Rectype_Mutex, Rectype_Exemption)
	[MULTITHREAD]: add Rectypes
	(Thread, Mutex, Exemption) [MULTITHREAD]: add types
	(TheThread, TheMutex, TheExemption) [MULTITHREAD]: add macros
	(allocate_thread, allocate_mutex, allocate_exemption)
	[MULTITHREAD]: add declarations
	* spvw_typealloc.d (allocate_thread, allocate_mutex)
	(allocate_exemption) [MULTITHREAD]: add
	* io.d (pr_orecord) [MULTITHREAD]: handle Rectype_Thread,
	Rectype_Mutex, and Rectype_Exemption
	* constobj.d (printstring_thread, printstring_mutex)
	(printstring_exemption) [MULTITHREAD]: add strings

2008-01-10  Sam Steingold  <sds@gnu.org>

	* reploop.lisp (frame-up-down): add
	(print-backtrace, break-loop, step-hook-fn): use it
	(*frame-limit1*): rename to *frame-limit-down*
	(frame-limit1): rename to frame-limit-down
	(*frame-limit2*): rename to *frame-limit-up*
	(frame-limit2): rename to frame-limit-up
	* debug.d (test_framepointer_arg): report a TYPE-ERROR
	(climb_stack_once, climb_stack_repeat): add
	(FRAME-UP-1, FRAME-DOWN-1): use climb_stack_once
	(FRAME-UP, FRAME-DOWN): use climb_stack_repeat
	(stack_upend_p): use frame_limit_up instead of frame_limit2
	(stack_downend_p): use frame_limit_down instead of frame_limit1
	* constsym.d (frame_limit1): rename to frame_limit_down
	(frame_limit2): rename to frame_limit_up

2008-01-09  Sam Steingold  <sds@gnu.org>

	* eval.d (reset): replace NOTREACHED with abort

2008-01-09  Sam Steingold  <sds@gnu.org>

	* debug.d (print_back_trace): index is uintL, not int
	(print_bt_to_frame): add
	(DESCRIBE-FRAME, show_stack): use it

2008-01-07  Sam Steingold  <sds@gnu.org>

	* eval.d (interpret_bytecode_): translated labels:
	svref_kein_svector --> svref_not_a_svector
	svref_kein_index --> svref_not_an_index
	* init.lisp (load): translated label: weiter --> proceed
	* condition.lisp (check-type-failed, assert-failed)
	(simple-assert-failed, eval-loaded-form, ctypecase-failed):
	format RESTART-CASE clauses in a more traditional way (lalist
	first)
	* spvw_garcol.d (gc_unmarkcheck): better error reporting
	* spvw.d (init_memory) [DEBUG_SPVW]: print STACK bounds too

2008-01-07  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1448744 ]: :q debugger command does not reset program stack
	* eval.d (reset): save last driver frame and use it instead of
	starting a new driver when the STACK is exhausted

2008-01-06  Sam Steingold  <sds@gnu.org>

	* reploop.lisp (break-loop): remove #\. from the end of a message
	(safe-wr-st): new function, use instead of WRITE-STRING whenever
	it is used with TEXT in this file to
	fix bug #[ 1865636 ]: infinite recursive error reporting

2008-01-06  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1865567 ]: hangs at the end of input script
	* reploop.lisp (main-loop): revert the 2003-12-18 patch: exit on
	EOF on all streams to avoid CLISP hanging at the end of script on
	"clisp < script" and "cat script | clisp"

2008-01-05  Sam Steingold  <sds@gnu.org>

	* Makefile.devel: remove all ffcall-related targets (libffcall is
	now hosted on savannah)
	* ffcall/: remove the tree

2008-01-03  Sam Steingold  <sds@gnu.org>

	* spvw.d (size_arg): turn into a function from macro SIZE_ARG;
	accept Tera and Peta on 64-bit platforms
	(parse_options): fix limit_low argument to size_arg()

2008-01-03  Sam Steingold  <sds@gnu.org>

	* makemake.in: pass "-o ./" to "clisp -c" uniformly
	(MEMOPT): new variable: -m 2MW for compilation

2007-12-31  Sam Steingold  <sds@gnu.org>

	* pathname.d, win32aux.d: use true/false instead of TRUE/FALSE
	* pathname.d (error_delete_open, error_rename_open): print subr name
	(check_rename_open): add
	(rename_file, create_backup_file): use it

2007-12-31  Sam Steingold  <sds@gnu.org>

	Rename EXT:DELETE-DIR, EXT:MAKE-DIR, and EXT:RENAME-DIR to
	EXT:DELETE-DIRECTORY, EXT:MAKE-DIRECTORY, and EXT:RENAME-DIRECTORY,
	respectively, for consistency with EXT:PROBE-DIRECTORY,
	EXT:DEFAULT-DIRECTORY and CL:PATHNAME-DIRECTORY.
	* constsym.d, eval.d, init.lisp, pathname.d, subr.d: do the renaming
	* deprecated.lisp (delete-dir, make-dir, rename-dir): deprecate
	* modules/syscalls/calls.c (COPY-FILE): use L(make_directory)

2007-12-31  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1860677 ]: DIRECTORY of dirs ignores :FULL
	* pathname.d (pack_full_info, with_stat_info_computed): add
	(get_time_size) [WIN32_NATIVE]: add
	(with_stat_info_arg) [UNIX]: add
	(directory_search_scandir) [WIN32_NATIVE]: use get_time_size()
	and pack_full_info()
	(directory_search): use with_stat_info_computed() for directories

2007-12-31  Sam Steingold  <sds@gnu.org>

	* pathname.d (push, PUSH_ON_STACK): add inline & macro wrapper
	(copy_pathname_and_add_subdir, directory_search_scandir)
	(directory_search): use it
	(pathname_add_subdir): do not pass arguments on the STACK

2007-12-30  Sam Steingold  <sds@gnu.org>

	avoid goto and return from inside with_string_0
	* pathname.d (delete_file_if_exists_obj, realpath_obj, stat_obj)
	(open_output_file_obj, create_backup_file_obj): add
	(assure_dir_exists): use realpath_obj()
	(directory_exists, directory_search_hash): use stat_obj()
	(DELETE-FILE): use delete_file_if_exists_obj()
	(open_file): use open_output_file_obj() & create_backup_file_obj()

2007-12-30  Sam Steingold  <sds@gnu.org>

	fix bug [ 1860489 ]: deletion of symlinks into non-existent dirs fails
	* pathname.d (DELETE-FILE): when the directory does not exist,
	still remove the link, just skip check_delete_open()

2007-12-30  Sam Steingold  <sds@gnu.org>

	additional 5% speedup in simple sequence tests: switch instead of if
	* lispbibl.d (fastcmp_t): new type
	(subr_t): split uintW seclass into uintB seclass and uintB fastcmp
	* funarg.d (check_test_args): use fastcmp subr field in switch
	instead of a sequence of if statements
	* subr.d (SECFC_BITS, SECFC_MASK, SECFC, SECFC_SEC, SECFC_FC):
	macros to allow passing both seclass and fastcmp in one LISPFUN
	macro argument
	(LISPFUN_D, LISPFUN_F, LISPFUN_G): set fastcmp
	(eq, eql, equal, equalp): set fastcmp
	* predtype.d (eq, eql, equal, equalp): ditto
	* genclisph.d (LISPFUN_F): set fastcmp to 0

2007-12-27  Sam Steingold  <sds@gnu.org>

	* funarg.d: new file, extracted from list.d, sequence.d, weak.d
	* list.d, sequence.d, weak.d: use funarg.d
	replace up_function_t and up2_function_t with funarg_t
	extend the 2001-06-16 patch (do not go through FUNCALL for simple tests)
	by selecting the test function once, not testing on each comparison
	* makemake.in (CPARTS): add funarg
	* lispbibl.d (check_key_arg, funcall_key, check_test_args): add
	(error_both_tests): remove

2007-12-26  Sam Steingold  <sds@gnu.org>

	* lispbibl.d, spvw_gcstat.d, time.d (TIME_1, TIME_2): replace with
	TIME_METHOD which takes values 1 or 2 which ensures that one and
	only one code path is always taken

2007-12-26  Sam Steingold  <sds@gnu.org>

	* symbol.d (GENSYM): use check_pos_integer & error_string_integer

2007-12-26  Reini Urban  <rurban@x-ray.at>

	<33_trans2>
	* misc.d, sort.d, symbol.d, time.d, weak.d, win32.d:
	translate comments and convert them from "# " to "/**/"

2007-12-20  Sam Steingold  <sds@gnu.org>

	* type.lisp (SIGNED-BYTE, UNSIGNED-BYTE): unify error messages

2007-12-20  Sam Steingold  <sds@gnu.org>

	fix bug [ 1779490 ]: linux:dirent definition error
	* modules/bindings/glibc/linux.lisp (clisp_dirent_ino_t)
	(clisp_dirent_off_t): define depending on __USE_FILE_OFFSET64

2007-12-20  Sam Steingold  <sds@gnu.org>

	fix bug [ 1854698 ]: BYTE is a type, but is unacceptable input to TYPEP
	* type.lisp (BYTE): add atomic type
	* predtype.d (bytep): implement
	* subr.d, constsym.d (bytep): add

2007-12-19  Sam Steingold  <sds@gnu.org>

	* io.d (pr_stream) [0]: print contents of a STRING-INPUT-STREAM
	for bootstrap debugging only

2007-12-18  Sam Steingold  <sds@gnu.org>

	DESCRIBE shows contents of STRING-STREAMs
	* stream.d (error_string_stream): add
	(STRING-INPUT-STREAM-INDEX, GET-OUTPUT-STREAM-STRING): use it
	(STRING-STREAM-STRING): add
	* constsym.d, subr.d (string_stream_string): add
	* describe.lisp (*squeeze-string-max*, *squeeze-string-section*)
	(squeeze-string): add
	(describe-object): use squeeze-string and string-stream-string to
	describe string streams

2007-12-18  Sam Steingold  <sds@gnu.org>

	* record.d (error_closure): add
	(SYS::CLOSURE-NAME, (SETF SYS::CLOSURE-NAME)): use it
	(slot_in_arglist, SYS::%MAKE-INSTANCE): add a cast to avoid
	the "value computed is not used" warning

2007-12-17  Sam Steingold  <sds@gnu.org>

	* lispbibl.d, pathname.d, spvw_memfile.d, time.d (decoded_time_t):
	translate field name from German to English

2007-12-16  Sam Steingold  <sds@gnu.org>

	* spvw.d, spvw_memfile.d (quit_instantly): renamed from quit_sofort
	* io.d (spaces): rename argument anzahl to scount
	(paren_open): rename from klammer_auf
	(paren_close): rename from klammer_zu
	* intelem.d (set_max32_Dptr): use if instead of (?:) to avoid three
	"value computed is not used" warnings
	* makemake.in (LIBS): do not add FFCALL_LIBS, it is done by configure

2007-12-08  Reini Urban  <rurban@x-ray.at>

	* makemake.in: rename --list-modules to --help-modules,
	add gtk2 to the list of suggested modules in the comments
	<32_trans1>
	* aridecl.d, compelem.d, flo_konv.d, realelem.d: translate comments

2007-12-15  Sam Steingold  <sds@gnu.org>

	* foreign.d: #include <avcall.h> & <callback.h> as "<>" and not '""'
	and wrap then in extern "C" to restore C++ compilation

2007-12-15  Sam Steingold  <sds@gnu.org>

	* error.d (MAKE_CHECK_REPLACEMENT): new macro
	(check_list_replacement, check_array_replacement)
	(check_vector_replacement, check_posfixnum_replacement)
	(check_integer_replacement, check_char_replacement)
	(check_string_replacement, check_stream_replacement)
	(check_uint_replacement, check_sint_replacement)
	(check_ulong_replacement, check_slong_replacement)
	(check_ffloat_replacement, check_dfloat_replacement): use it
	(error_uint8, error_sint8, error_uint16, error_sint16, error_uint32)
	(error_sint32, error_uint64, error_sint64): remove
	(error_c_integer): add
	(check_uint8_replacement, check_sint8_replacement)
	(check_uint16_replacement, check_sint16_replacement)
	(check_uint32_replacement, check_sint32_replacement)
	(check_uint64_replacement, check_sint64_replacement): remove
	(check_c_integer_replacement): add
	* lispbibl.d (error_uint8, error_sint8, error_uint16, error_sint16)
	(error_uint32, error_sint32, error_uint64, error_sint64): define
	as macros, expanding to error_c_integer()
	(check_uint8_replacement, check_sint8_replacement)
	(check_uint16_replacement, check_sint16_replacement)
	(check_uint32_replacement, check_sint32_replacement)
	(check_uint64_replacement, check_sint64_replacement): define
	as macros, expanding to check_c_integer_replacement()

2007-12-14  Sam Steingold  <sds@gnu.org>

	* avl.d, control.d, debug.d, eval.d, hashtabl.d, intprint.d, io.d:
	* lispbibl.d, pathname.d, predtype.d: rename label fertig to done;
	convert comments from "# " to "/**/"

2007-12-13  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (elif, loop, until): drop; update all D files
	* compelem.d, realelem.d (I_I_equal, R_R_equal): renamed from *_gleich
	* compelem.d (N_N_equal): rewrote as a single return
	* spvw_circ.d (abort_context, abort_STACK): renamed from abbruch_*

2007-12-12  Sam Steingold  <sds@gnu.org>

	* spvw_typealloc.d (NIL_FILL): add
	(allocate_vector, allocate_lrecord, allocate_lrecord_)
	(allocate_srecord_): use it
	* spvw*.d: convert comments from "# " to "/**/"

2007-12-12  Sam Steingold  <sds@gnu.org>

	expect FFCALL to be installed externally
	* configure: accept --with-ffcall and --with-libffcall-prefix
	* Makefile.devel (SOURCES): remove ffcall (not distributed with CLISP)
	* m4/ffcall.m4: add
	* configure.in: call CL_FFCALL
	* makemake.in (FFCALL_LIBS): init from '@LIBAVCALL@ @LIBCALLBACK@'
	(LIBS): add FFCALL_LIBS when --with-dynamic-ffi was supplied
	(avcall, callback): remove targets
	* glm4/lib-link.m4 (AC_LIB_LINKFLAGS_BODY): split into
	AC_LIB_LINKFLAGS_ADD and AC_LIB_LINKFLAGS_SEARCH (used by CL_FFCALL)

2007-12-11  Sam Steingold  <sds@gnu.org>

	* stream.d: convert comments from "# " to "/**/"
	(ELTYPE_FLAFS): new macro
	(make_unbuffered_stream, make_buffered_stream): use it
	(NON_WHOLE_BYTE_P): new macro
	(check_unbuffered_eltype, make_buffered_stream): use it

2007-12-06  Sam Steingold  <sds@gnu.org>

	* configure (--localedir, --docdir, --htmldir, --dvidir, --psdir)
	(--pdfdir, --elispdir, --vimdir): enable (autoconf-2.60 is here)

2007-12-10  Sam Steingold  <sds@gnu.org>

	do not link over LISP files into the build directory
	* makemake.in (LPARTS): remove config
	(LISPFILES): prefix with ${SRCDIR}
	(alllisp): remove target
	(*.fas): pass "-o" to clisp
	(images): set *load-paths* before load init
	(TESTLISPFILES): remove make variable
	(check-recompile): do not link lisp sources over to stage
	* init.lisp (*load-paths*): reset only is not yet set
	(search-file): respect it even in the first definition

2007-12-10  Sam Steingold  <sds@gnu.org>

	do not link over D files into the build directory
	* makemake.in (DFILES): remove modules; remove Makefile variable;
	(init): do not depend on DFILES
	(LINKKIT): remove modules.d
	(clean5): do not delete DFILES
	* modules.d: rename to modules.c
	* clisp-link.in: do not require modules.d for linkkitdir

2007-12-10  Sam Steingold  <sds@gnu.org>

	* makemake.in (UTILS): treat gctrigger & varbrace just like the
	other C utilities
	* gctrigger.d, varbrace.d: convert to ANSI C and rename to *.c

2007-12-05  Sam Steingold  <sds@gnu.org>

	* m4/general.m4 (CL_CC_WORKS): use "return 0" instead of "exit(0)"
	because C++ fails on an undefined function

2007-12-05  Sam Steingold  <sds@gnu.org>

	Assume that "mkdir -p" is POSIX-compliant
	* makemake.in (echotab_mkdir_maybe): remove,
	use plain "mkdir -p" instead
	* ffcall/callback/Makefile.in, ffcall/callback/trampoline_r/Makefile.in:
	* ffcall/callback/vacall_r/Makefile.in, ffcall/trampoline/Makefile.in:
	* ffcall/vacall/Makefile.in, ffcall/avcall/Makefile.in:
	use "mkdir -p" instead of "if [ ! -d % ]; then mkdir %; fi"
	because the latter breaks down with non-trivial DESTDIR

2007-12-05  Sam Steingold  <sds@gnu.org>

	remove AFFI
	* affi.d, affi1.lisp: remove
	* charstrg.d (unpack_string_rw): unused now, surround with #if 0
	* lispbibl.d (unpack_string_rw): remove prototype
	* encoding.d, constobj.d: remove AFFI CPP conditions
	* clhs.lisp: do not set AFFI package documentation
	* defs1.lisp (*system-package-list*): remove "AFFI"
	* foreign1.lisp, exporting.lisp (def-lib-call-out): remove
	* constsym.d, subr.d: remove AFFI functions
	* type.lisp (foreign-pointer): remove affi read conditional

2007-12-04  Reini Urban  <rurban@x-ray.at>

	<31_ergebnis>
	* arilev0.d, arisparc.d, arisparc64.d, charstrg.d, encoding.d:
	* eval.d, ffloat.d, int2adic.d, intdiv.d, intgcd.d, intprint.d:
	* intread.d, intsqrt.d, io.d, list.d, package.d, pathname.d:
	* rational.d, realrand.d, record.d, sequence.d, sfloat.d:
	* spvw_allocate.d, spvw_memfile.d, stream.d, time.d, unixaux.d:
	* weak.d: ergebnis -> result
	<30_wert>
	* intelem.d: rename local var and arg wert,_wert,wert_*
	to value,_value,value_*
	* arilev0.d: rename macro arg wert,__wert to
	tvalue,__value
	* array.d (storagevector_store): rename local var wert to value
	* intlog.d (I_to_DS_n): rename local var wert to value
	* intserial.d (LESbvector_to_UI): rename local var wert to value
	* io.d (get_base): rename local var wert to intvalue,
	(test_number_syntax): rename local var wert to value,
	(feature): rename arg sollwert to demandvalue
	* lispbibl.d: rename local var wert to val (analog to the other
	intconv argnames)
	<29_zuweisung>
	* aridecl.d, arilev0.d, arilev1.d, dfloat.d, eval.d, ffloat.d:
	* intbyte.d, intelem.d, intlog.d, intmal.d, intsqrt.d, lfloat.d:
	* rational.d, sfloat.d: rename macro args *_zuweisung to *_assignment
	<28_more_anz>
	* io.d (print_vars_anz): rename to print_vars_count
	* lispbibl.d, spvw.d (thread_objects_anz): -> thread_objects_count
	* spvw.d (package_anz): rename to package_count
	* spvw_memfile.d (offset_subrs_anz): rename to offset_subrs_count
	<27_error_anzahl>
	* eval.d (funcall_subr, funcall_closure): rename label
	error_anzahl to error_count
	<26_spvw_anz>
	* spvw.d, spvw_space.d, spvw_memfile.d:
	(symbol_anz): rename to symbol_count
	(pseudocode_anz): rename to pseudocode_count
	(pseudodata_anz): rename to pseudodata_count
	(pseudofun_anz): rename to pseudofun_count
	(object_anz): rename to object_count
	* spvw_memfile.d (loadmem_from_handle): rename local var
	old_object_anz to old_object_count
	* spvw_memfile.d (struct memdump_header_t): rename members
	_pseudofun_anz to _pseudofun_count; _symbol_anz to _symbol_count

2007-12-05  Sam Steingold  <sds@gnu.org>

	* foreign.d (dlerror_string): use safe_to_string

2007-12-03  Reini Urban	 <rurban@x-ray.at>

	<24_more_anz>
	* control.d, lispbibl.d (specdecled_, make_variable_frame): rename
	arg and local spec_anz to spec_count
	* control.d (make_variable_frame): rename local var_anz to var_count
	* eval.d, lispbibl.d (frame_anz): rename to frame_count
	<23_clos_reqoptkey_anz>
	* eval.d, lispbibl.d: rename global members
	(clos_spec_anz): -> clos_spec_count
	(clos_req_anz): -> clos_req_count
	(clos_opt_anz): -> clos_opt_count
	(clos_key_anz): -> clos_key_count
	(clos_aux_anz): -> clos_aux_count
	<22_reqoptkey_anz>
	* debug.d, eval.d, fsubr.d, genclisph.d, lispbibl.d, spvw.d:
	* spvw_memfile.d, subr.d: rename global members and macro args
	(req_anz): -> req_count
	(opt_anz): -> opt_count
	(key_anz): -> key_count
	* clos-genfun2b.lisp (COMPUTE-DISPATCH): remove REQ-ANZ
	* compiler.lisp (struct fnode): rename
	(REQ-ANZ): -> REQ-NUM
	(OPT-ANZ): -> OPT-NUM
	* subr.d: rename macro args req_anz_, opt_anz_, key_anz_ to *_count_
	<21-xcharin-fehler>
	* xcharin.lisp (FEHLER-CHAR-ARG): rename to ERROR-CHAR-ARG
	<20_subr_anz>
	* affi.d, spvw.d, spvw_memfile.d, spvw_space.d:
	translate local variables *subr_anz => *subr_count:
	(subr_anz): subr_count
	(fsubr_anz): fsubr_count
	(total_subr_anz): total_subr_count
	(old_subr_a): old_subr_count
	<19_gcmark_vars>
	* spvw_gcmark.d: translate local variables:
	(dies): curr
	(dies_): curr_
	(nachf): succ
	(vorg): pred
	(vorvorg): prepred
	<18_test_index_macro>
	* charstrg.d (test_index): translate the macro arguments:
	(woher): from
	(wohin_zuweisung): to_setter
	(grenze): upper_limit
	(vergleich): uplimit_cmp
	<17_liststern>
	* bytecode.d, constsym.d, eval.d, foreign.d, list.d, stream.d, subr.d:
	(liststern): rename to liststar
	* bytecode.d, eval.d (cod_unliststern): rename to cod_unliststar
	(cod_liststern_push): rename bytecode to cod_liststar_push (LIST*&PUSH)
	* eval.d: rename label unliststern_unbound to unliststar_unbound

2007-12-03  Sam Steingold  <sds@gnu.org>

	* configure, makemake.in: support spaces in the build directory name

2007-12-02  Reini Urban  <rurban@x-ray.at>

	<16_strcmp3>
	* charstrg.d, constsym.d, eval.d, subr.d, subrkw.d:
	(string_grgleich): rename to string_gtequal
	(cs_string_grgleich): rename to cs_string_gtequal
	* charstrg.d, constsym.d, eval.d, sequence.d, subr.d, subrkw.d:
	(search_string_gleich): rename to search_string_eq
	<15_strcmp2>
	* charstrg.d, constsym.d, eval.d, subr.d, subrkw.d:
	(string_groesser): rename to string_greater
	(cs_string_groesser): rename to cs_string_greater
	(string_klgleich): rename to string_ltequal
	(cs_string_klgleich): rename to cs_string_ltequal
	<14_strcmp1>
	* charstrg.d, constsym.d, eval.d, subr.d, subrkw.d:
	(string_ungleich): rename to string_noteq
	(cs_string_ungleich): rename to cs_string_noteq
	(string_kleiner): rename to string_less
	(cs_string_kleiner): rename to cs_string_less

2007-12-01  Reini Urban	 <rurban@x-ray.at>

	<13_charcmp2>
	* constsym.d, eval.d, charstrg.d, subr.d:
	(char_groesser): rename to char_greater
	(char_klgleich): rename to char_ltequal
	(char_grgleich): rename to char_gtequal
	<12_charcmp1>
	* constsym.d, eval.d, charstrg.d, subr.d, sequence.d:
	(char_gleich): rename to char_eq
	* constsym.d, eval.d, charstrg.d, subr.d:
	(char_ungleich): rename to char_noteq
	(char_kleiner): rename to char_less
	<11_aritcmp2>
	* compelem.d, lisparit.d (N_N_gleich): rename to N_N_equal
	* constsym.d, eval.d, subr.d (klgleich): rename to ltequal
	(grgleich): rename to gtequal
	<10_aritcmp>
	* constsym.d, eval.d, lisparit.d, subr.d (ungleich): -> numunequal
	* constsym.d, eval.d, lisparit.d, subr.d, modules/clx/new-clx/clx.f:
	(kleiner): rename to smaller
	* constsym.d, eval.d, lisparit.d, subr.d, hashtabl.d:
	(groesser): rename to greater
	<09_einsplus_minus>
	* array.d, constsym.d, eval.d, hashtabl.d, lisparit.d, subr.d:
	(einsplus, einsminus): rename to plus_one, minus_one
	<08_morearit>
	* constsym.d, debug.d, spvw.d (driverstern): rename to driverstar
	* constsym.d, eval.d, lisparit.d, subr.d (fakultaet): -> factorial

2007-11-30  Reini Urban  <rurban@x-ray.at>

	<07_mal_durch>
	* eval.d, lisparit.d, subr.d, hashtabl.d, time.d, affi.d:
	* constsym.d, debug.d, predtype.d, sequence.d, spvw.d:
	* modules/clx/new-clx/clx.f (mal): renamed to star
	(durch): renamed to slash
	* constsym.d, debug.d, spvw.d (mal2): renamed to star2
	(mal3): renamed to star3
	(durch2): renamed to slash2
	(durch3): renamed to slash3
	* int2adic.d, intsqrt.d (D_D_mal2adic_D) renamed to D_D_mult2adic_D
	(D_D_durch2adic_D, UDS_UDS_durch2adic_UDS): renamed to *_div2adic_*

2007-11-29  Reini Urban <rurban@x-ray.at>

	<06_gleich2>
	* charstrg.d, lispbibl.d, package.d (string_gleich_inverted):
	rename to string_eq_inverted
	* lisparit.d, lispbibl.d, predtype.d (number_gleich):
	rename to number_equal

2007-11-29  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f, modules/clx/new-clx/clx.lisp:
	rename DISPLAY-NOOP to the standard NO-OPERATION

2007-11-28  Reini Urban  <rurban@x-ray.at>

	<05_gleich>
	* constsym.d, eval.d, lisparit.d, subr.d, modules/clx/new-clx/clx.f:
	(gleich): rename to numequal
	* charstrg.d, constsym.d, eval.d, lispbibl.d, package.d, io.d:
	* subr.d, subrkw.d (string_gleich): rename to string_eq
	* charstrg.d, constsym.d, subr.d, subrkw.d (cs_string_gleich):
	rename to cs_string_eq

2007-11-28  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (get_display): add
	(find_display, get_font, SET-GCONTEXT-DISPLAY, CLOSE-DISPLAY)
	(SET-DISPLAY-AFTER-FUNCTION, DISPLAY-DEFAULT-SCREEN)
	(SET-DISPLAY-DEFAULT-SCREEN, VISUAL-INFO, OPEN-FONT, FONT-PATH)
	(SET-FONT-PATH, LIST-FONT-NAMES, LIST-FONTS, FIND-ATOM)
	(INTERN-ATOM, SELECTION-OWNER, SET-SELECTION-OWNER)
	(disassemble_event_on_stack, PROCESS-EVENT, GLOBAL-POINTER-POSITION)
	(INPUT-FOCUS, CHANGE-ACTIVE-POINTER-GRAB, SET-DISPLAY-XDEFAULTS)
	(POINTER-MAPPING, SET-POINTER-MAPPING, QUERY-KEYMAP)
	(CHANGE-KEYBOARD-MAPPING, KEYBOARD-MAPPING, KEYCODE->CHARACTER)
	(SET-ACCESS-CONTROL, ACCESS-HOSTS, LIST-EXTENSIONS, QUERY-EXTENSION)
	(SHAPE-VERSION): use it
	(CHANGE-PROPERTY): use get_client_message_format()
	(check_mapping_request): add DEFCHECKER
	(MAPPING-NOTIFY): use it, return no values
	(XLIB:ACCESS-HOSTS): check for FamilyServerInterpreted (bug 1840594)

007-11-27  Reini Urban  <rurban@x-ray.at>

	<04_divmult>
	* compelem.d, comptran.d, dfloat.d, ffloat.d, flo_rest.d, intdiv.d:
	* intmal.d, intgcd.d, intsqrt.d, lfloat.d, lisparit.d, rational.d:
	* realelem.d, realrand.d, realtran.d, sfloat.d:
	rename *_durch_* to *_div_*, rename *_mal_* to *_mult_*,
	rename GEN_*_op*(durch) to GEN_*_op*(div)
	* lisparit.d, lispbibl.d, io.d (mal_10_plus_x): rename to mult_10_plus_x

2007-11-26  Reini Urban  <rurban@x-ray.at>

	<03_fehler_label>
	* io.d: rename labels fehler_nur01 to error_nur01,
	fehler_dopp to error_colon,
	remove english function translations in comments
	* eval.d: rename labels fehler_zuwenig to error_toofew,
	fehler_zuviele_werte to error_toomany_values,
	fehler_zuviel to error_toomany
	* affi.d, array.d, control.d, eval.d, intmal.d, io.d, lispbibl.d:
	* list.d, pathname.d, predtype.d, record.d, stream.d:
	rename labels fehler* to error*

2007-11-27  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp (make-xterm-io-stream): use
	*ENABLE-CLOS-WARNINGS* instead of *WARN-IF-GF-ALREADY-CALLED*

2007-11-26  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f, modules/clx/new-clx/clx.lisp:
	implemented most of Chapter 13 Resources in C,
	but commented it out because there is no way to remove a resource

2007-11-25  Reini Urban <rurban@x-ray.at>

	<02_fehler__fun>
	* eval.d: rename fehler_(eval|closure|apply|subr)_zuviel to
	error_*_toomany
	* control.d, eval.d, foreign.d, lisparit.d, lispbibl.d:
	rename fehler_mv_zuviel to error_mv_toomany
	* array.d: rename fehler_subscript_anz to error_subscript_count
	* io.d: rename fehler_dispatch_zahl to error_dispatch_number,
	fehler_eof_aussen to error_eof_outside,
	fehler_eof_innen to error_eof_inside
	* spvw_allocate.d: fehler_speicher_voll to error_memory_full
	* modules/clx/new-clx/clx.f, modules/rawsock/rawsock.c:
	* modules/syscalls/calls.c, utils/modprep.lisp:
	* affi.d, aridecl.d, array.d, charstrg.d, control.d, debug.d:
	* dfloat.d, encoding.d, error.d, eval.d, ffloat.d, flo_konv.d:
	* flo_rest.d, foreign.d, intbyte.d, intdiv.d, io.d, lfloat.d:
	* lisparit.d, lispbibl.d, list.d, pathname.d, predtype.d:
	* realtran.d, record.d, sequence.d, sfloat.d, socket.d, spvw.d:
	* spvw_allocate.d, stream.d, symbol.d, time.d, weak.d:
	rename fehler_ to error_
	* .gdbinit: rename fehler to error
	* CodingStyle: add Reini Urban for the upcoming translations

2007-11-24  Reini Urban  <rurban@x-ray.at>

	<01_fehler_fun>
	* modules/berkeley-db/bdb.c, modules/clx/new-clx/clx.f:
	* modules/dirkey/dirkey.c, modules/pari/cpari.c, modules/pcre/cpcre.c:
	* modules/rawsock/rawsock.c, modules/syscalls/calls.c:
	* affi.d, aridecl.d, array.d, charstrg.d, control.d, debug.d:
	* encoding.d, error.d, eval.d, flo_konv.d, foreign.d, hashtabl.d:
	* i18n.d, intbyte.d, intdiv.d, intelem.d, intlog.d, intmal.d, io.d:
	* lfloat.d, lisparit.d, lispbibl.d, list.d, misc.d, package.d:
	* pathname.d, predtype.d, record.d, sequence.d, socket.d, spvw.d:
	* spvw_allocate.d, spvw_memfile.d, spvw_sigint.d, stream.d, symbol.d:
	* time.d, weak.d, utils/modprep.lisp: rename fehler() to error()
	* modules/berkeley-db/bdb.c, modules/dirkey/dirkey.c:
	* modules/pari/cpari.c, modules/pcre/cpcre.c, modules/rawsock/rawsock.c:
	* modules/regexp/regexi.c, modules/syscalls/calls.c:
	* affi.d, array.d, charstrg.d, control.d, debug.d, encoding.d, error.d:
	* eval.d, foreign.d, i18n.d, io.d, lispbibl.d, list.d, misc.d:
	* package.d, pathname.d, predtype.d, record.d, sequence.d, spvw.d:
	* stream.d, symbol.d: rename error (enum condition_t) to error_condition

2007-11-23  Sam Steingold  <sds@gnu.org>

	Implemented RFE #[ 1834184 ]: handle CLOS warnings in a CLOSy way
	* init.lisp (clos-warning, gf-already-called-warning)
	(gf-replacing-method-warning): export from CLOS
	* clos-package.lisp: ditto
	* condition.lisp (clos-warning, simple-clos-warning)
	(gf-replacing-method-warning, simple-gf-replacing-method-warning)
	(gf-already-called-warning, simple-gf-already-called-warning): define
	(warn-of-type): extract from WARN, accept warning class
	(warn): use WARN-OF-TYPE
	(set-global-handler): bind CLOS::*ENABLE-CLOS-WARNINGS* instead of
	individial variables
	* clos.lisp (*enable-clos-warnings*): set to T when everything is loaded
	* clos-print.lisp (print-object-method-warning): use the new
	framework (still commented out)
	* clos-genfun2b.lisp (*gf-warn-on-replacing-method*): remove
	(std-add-method, std-remove-method): use CLOS-WARN
	(*warn-if-gf-already-called*): remove
	(gf-already-called-warning): add
	(warn-if-gf-already-called): use it
	* clos-class6.lisp (class-not-yet-defined): add
	(class-direct-superclasses, class-direct-slots)
	(class-direct-default-initargs): use it
	* clos-class3.lisp (defclass, ensure-class-using-class-<t>)
	(reinitialize-instance-<defined-class>, std-compute-cpl)
	(compute-slots-<slotted-class>-around)
	(make-instances-obsolete-<semi-standard-class>): use CLOS-WARNING
	* clos-class0.lisp (*enable-clos-warnings*): declare
	(clos-warn, clos-warning): add

2007-11-21  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1835520 ]: PPRINT-LOGICAL-BLOCK ignores
	*PRINT-PPRINT-DISPATCH-TABLE*
	* io.d (prin_object_dispatch_pretty): do not check *PRIN-PPRINTER*

2007-11-21  Jack Unrue  <jdunrue@gmail.com>
	Sam Steingold  <sds@gnu.org>

	* makemake.in (install.nsi): copy from win32msvc/nsis and
	substitute @NAME@, @VERSION@, @BASE_MODULES@, and @MODULES@
	(add_to_path.nsh, is_user_admin.nsh): copy from win32msvc/nsis
	(COPYRIGHT.rtf): create from COPYRIGHT using text_to_rtf.lisp
	(distrib) [win32]: invoke makensis to build woe32 installer
	(clean1): remove COPYRIGHT.rtf and install.nsi

2007-11-20  Sam Steingold  <sds@podval.org>

	* modules/libsvm: upgraded to upstream 2.85

2007-11-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (trampoline/trampoline.h): remove an unused target

2007-11-18  Bruno Haible  <bruno@clisp.org>

	Fix bug #[ 1834193 ]: fresh-line at the end of a line containing
	only tabs.
	* stream.d (wr_ss_lpos): Add special handling of TAB characters.
	(write_char): Likewise.

2007-11-19  Sam Steingold  <sds@gnu.org>

	* gllib/config.charset, glm4/gettext.m4, glm4/gnulib-comp.m4:
	* glm4/iconv.m4, glm4/intdiv0.m4, glm4/intl.m4, glm4/intlmacosx.m4:
	* glm4/lib-link.m4, glm4/link-follow.m4, glm4/lock.m4:
	* glm4/longlong.m4, glm4/po.m4, glm4/printf-posix.m4:
	* glm4/wint_t.m4, glm4/ulonglong.m4: sync with gnulib

2007-11-18  Sam Steingold  <sds@gnu.org>

	* version.h: tag and push out 2.43

2007-11-18  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (all): remove src/uninames.h
	(uninames.h): remove (it comes from gnulib now)

2007-11-16  Sam Steingold  <sds@gnu.org>

	* lispbibl.d [UNIX || __MINGW32__]: do not undef malloc, instead ...
	* makemake.in: when HAVE_MALLOC_POSIX=0, link lisp.run, clisp.exe
	and utils with gllib/malloc (as EXTRAOBJ)
	* modules/regexp/configure.in, modules/regexp/link.sh.in:
	malloc.o, when needed, is already in lisp.a

2007-11-14  Sam Steingold  <sds@gnu.org>

	* win32msvc/nsis/text_to_rtf.lisp: rewrote:
	use \uNNNN to output Unicode characters;
	use "Courier New" (fixed width) font to preserve formatting
	use bold for the headers
	do not use regexp

2007-11-14  Elliott Slaughter  <elliottslaughter@gmail.com>

	* win32msvc/nsis/text_to_rtf.lisp: ASCII text to RTF converter

2007-11-13  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1831367 ]: with-standard-io-syntax/*print-pprint-dispatch*
	* pprint.lisp (make-pprint-dispatch): add
	(*print-pprint-dispatch*, copy-pprint-dispatch): use it
	* defs2.lisp (with-standard-io-syntax): bind
	*PRINT-PPRINT-DISPATCH* to (COPY-PPRINT-DISPATCH NIL)

2007-11-13  Sam Steingold  <sds@gnu.org>

	* makemake.in (CFLAGS): add -Igllib
	(MODULE_CFLAGS): do not add -Igllib
	this is necessary for the systems that require stdint from gllib,
	e.g., solaris

2007-11-10  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:DISPLAY-NOOP): new function
	* modules/clx/new-clx/clx.lisp (DISPLAY-NOOP): export it

2007-11-07  Elliott Slaughter  <elliottslaughter@gmail.com>
	Sam Steingold  <sds@gnu.org>

	* win32msvc/nsis/add_to_path.nsh, win32msvc/nsis/install.nsi:
	* win32msvc/nsis/is_user_admin.nsh: NullSoft Install System scripts

2007-11-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (--help): use @PACKAGE_STRING@ (@PACKAGE_BUGREPORT@)

2007-11-07  Ralf-P. Weinmann  <weinmann@cdc.informatik.tu-darmstadt.de>
	Sam Steingold  <sds@gnu.org>

	fix bug #[ 1827572 ]: macosx: clisp|tee error
	* stream.d (finish_tty_output, force_tty_output, clear_tty_output)
	[UNIX_DARWIN]: treat ENOTSUP like EOPNOTSUPP

2007-11-06  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (SOURCES5): remove $T/nextapp
	* nextapp: remove obsolete directory
	* unix.d (nxterminal_*): remove
	* stream.d, spvw.d, pseudofun.d, lispbibl.d, constsym.d, constobj.d:
	remove all NEXTAPP code

2007-11-06  Sam Steingold  <sds@gnu.org>

	* modules/wildcard/configure.in: fnmatch.h is in the build
	directory, not the source directory

2007-11-06  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCC_CREATESHARED): treat mingw just like all the
	other free OS (gnu/linux/bsd/cygwin)

2007-11-06  Sam Steingold  <sds@gnu.org>

	* modules/wildcard/configure.in: use ac_cv_func_fnmatch_gnu
	instead of FNMATCH_H

2007-11-05  Sam Steingold  <sds@gnu.org>

	* clisp-link.in (run): fix for --with-dynamic-modules

2007-11-05  Sam Steingold  <sds@gnu.org>

	for better dynamic module support:
	* modules/berkeley-db/dbi.lisp: (provide "berkeley-db")
	* modules/dirkey/dirkey1.lisp: (provide "dirkey")
	* modules/fastcgi/fastcgi.lisp: (provide "fastcgi")
	* modules/gdbm/gdbm.lisp: (provide "gdbm")
	* modules/i18n/i18n.lisp: (provide "i18n")
	* modules/oracle/oracle.lisp: (provide "oracle")
	* modules/pari/pari.lisp: (provide "pari")
	* modules/pcre/pcre.lisp: (provide "pcre")
	* modules/rawsock/sock.lisp: (provide "rawsock")
	* modules/regexp/regexp.lisp: (provide "regexp")
	* modules/syscalls/posix.lisp: (provide "syscalls")
	* modules/wildcard/wildcard.lisp: (provide "wildcard")

2007-11-05  Sam Steingold  <sds@gnu.org>

	fix --with-dynamic-modules build
	* makemake.in: pass XCC_PICFLAG to "make -C gllib"
	* clisp-link.in: run prepare_dynamic_module in $destinationdir

2007-11-04  Sam Steingold  <sds@gnu.org>

	* modules/pcre/cpcre.c (check_pattern): pat argument is modified,
	so it has to be a pointer
	(PATTERN-INFO, PCRE-NAME-TO-INDEX, PCRE-EXEC): update callers
	* modules/rawsock/rawsock.c (check_struct_data): arg is modified,
	so it has to be a pointer
	(SOCKADDR-FAMILY, optional_sockaddr_argument, BIND, CONNECT)
	(GETNAMEINFO, fill_msghdr, SENDTO): update callers
	* modules/syscalls/calls.c (check_utmpx): add
	(GETUTXENT, GETUTXLINE, PUTUTXLINE): use it

2007-11-04  Sam Steingold  <sds@gnu.org>

	* modules/pari/configure.in: check for init_opts
	* modules/pari/cpari.c (init_for_clisp) [HAVE_INIT_OPTS]:
	set init_opts to 0

2007-11-02  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (ffcall-aux): split out from all
	(ffcall/avcall/avcall.h.mingw32, ffcall/vacall/vacall.h.mingw32)
	(ffcall/callback/vacall_r/vacall_r.h.mingw32): add targets
	(check-configures): depend on configures
	(tp-mail): CC to clisp-devel

2007-11-02  Sam Steingold  <sds@gnu.org>

	* ffcall: switch from gl_AC_TYPE_LONG_LONG to AC_TYPE_LONG_LONG_INT
	* m4/intparam.m4 (CL_INTPARAM_CROSS): ditto

2007-11-02  Sam Steingold  <sds@gnu.org>

	* version.sh: 2.43 (2007-11-18)

2007-11-01  Sam Steingold  <sds@gnu.org>

	* makemake.in (boot): ensure that FILES in makevars are all local
	* clisp-link.in (normalize): new function
	(link, link_some): use it
	(add-module-set, run): avoid "crazy doubly nested lists"
	* modules/wildcard/link.sh.in, modules/regexp/link.sh.in:
	NEW_FILES are paths to gllib while
	NEW_LIBS are library names without directory

2007-11-01  Sam Steingold  <sds@gnu.org>

	* modules/pari/configure.in: check for freeall pari_init
	killallfiles pari_init_opts
	* modules/pari/cpari.c: #include "config.h"
	(init_for_clisp): drop unused variables
	(init_for_clisp, fini_for_clisp): check functions before calling them

2007-10-31  Sam Steingold  <sds@gnu.org>

	* modules/regexp/configure.in: ac_use_included_regex is NOT cached,
	so we have to duplicate the logic of src/glm4/regex.m4

2007-10-30  Sam Steingold  <sds@gnu.org>

	* charstrg.d: do not include "width.c" & "uniname.c"
	* makemake.in (FILES, OBJECTS): add uniname & width
	(UNICODE_EXTRA): remove uniname & width
	(boot): cannot assume that an element of $FILES does not contain slashes
	* clisp-link.in (link): use dirname and basename instead of sed
	(link_some): do not assume that file does not contain slashes

2007-10-31  Sam Steingold  <sds@gnu.org>

	* modules/regexp/configure.in (MALLOC_O) [gl_cv_func_malloc_posix=yes]:
	set to "malloc.o"
	* modules/regexp/link.sh.in (file_list): add @MALLOC_O@

2007-10-30  Sam Steingold  <sds@gnu.org>

	* makemake.in, modules/regexp/link.sh.in, modules/wildcard/link.sh.in:
	work around the 'unexpected token `;' in  for h in  ; do' bug
	http://www.opengroup.org/onlinepubs/009695399/utilities/xcu_chap02.html#tag_02_09_04_03

2007-10-30  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (HAVE_LONG_LONG_INT) [long_bitsize==64]: define only
	if not already defined (avoid a redefinition warning)
	(_GNU_SOURCE): do not define here, it comes from AC_GNU_SOURCE
	* configure.in: do not call AC_AIX, AC_GNU_SOURCE, CL_PROG_RANLIB
	AC_USE_SYSTEM_EXTENSIONS, they are covered in gl_EARLY
	use AC_HEADER_STDC instead of CL_STDC_HEADERS: it is already used
	in all modules and the reasons for not checking some standard
	headers are no longer applicable
	* m4/ranlib.m4, m4/stdc-headers.m4: remove obsoleted files
	* ffcall/Makefile.devel: drop ranlib.m4 & stdc-headers.m4
	* ffcall/avcall/configure.in, ffcall/callback/configure.in:
	* ffcall/callback/trampoline_r/configure.in:
	* ffcall/callback/vacall_r/configure.in:
	* ffcall/trampoline/configure.in, ffcall/vacall/configure.in:
	use AC_PROG_RANLIB instead of CL_PROG_RANLIB
	* m4/general.m4 (CL_FFCALL_COMMON_TRAMPOLINE): use AC_HEADER_STDC
	instead of CL_STDC_HEADERS

2007-10-29  Sam Steingold  <sds@gnu.org>

	* m4/ldap.m4, m4/netdb.m4, m4/getcwd.m4: remove trivial files
	* m4/signed.m4: remove unused file
	* configure.in: do not call CL_GETWD, CL_LDAP & CL_NETDB
	* modules/dirkey/configure.in: check for headers explicitly
	* m4/gethostbyname.m4 (CL_GETHOSTBYNAME): check for <netdb.h> here
	* unix.d (MAXPATHLEN): use PATH_MAX (when defined)
	or else 4096 (instead of 1024 previously)
	(getwd, getcwd): drop prototypes

2007-10-29  Sam Steingold  <sds@gnu.org>

	* configure.in (AC_COPYRIGHT): update year
	(AC_PREREQ): require 2.61 (datarootdir et al, see below 2007-10-27)

2007-10-29  Sam Steingold  <sds@gnu.org>

	* configure.in: use AC_TYPE_LONG_LONG_INT instead of the obsolescent
	gl_AC_TYPE_LONG_LONG
	* lispbibl.d, foreign.d, affi.d, aridecl.d, arilev0.d, arilev1.d:
	* foreign.d, genclisph.d, intelem.d, intparam.c, time.d:
	use HAVE_LONG_LONG_INT instead of HAVE_LONGLONG

2007-10-29  Sam Steingold  <sds@gnu.org>

	Work around the wildcard build error reported in
	<http://article.gmane.org/gmane.lisp.clisp.devel/16815>
	and <http://article.gmane.org/gmane.lisp.clisp.devel/16824>.
	The problem is that all gnulib autoconf macros are called from
	src/glm4/gnulib-comp.m4:gl_INIT, so they should not be called from
	module configures; we can rely on sourcing config.cache.
	* configure.in: do not call gl_STDBOOL_H & gl_STDINT_H since they
	are already called from gl_INIT
	* modules/regexp/configure.in: do not call gl_FUNC_ALLOCA &
	gl_REGEX: they are already called from the top-level configure.in
	* modules/wildcard/configure.in: do not call gl_FUNC_FNMATCH_POSIX,
	rely on gl_INIT in top-level configure.in

2007-10-29  Vadim Konovalov  <vkonovalov@alcatel-lucent.com>
	Sam Steingold  <sds@gnu.org>

	* makemake.in [win32msvc]: drop support for msvc4 & msvc5, thus
	drop gcc-cccp and use deema instead
	* Makefile.devel: do not generate makefiles for msvc[45] and debug
	* utils/gcc-cccp: remove

2007-10-29  Sam Steingold  <sds@gnu.org>

	* utils/deema.c: extend to fully support the makemake equivalent
	sed -e 's/, *)/,_EMA_)/g' -e 's/, *,/,_EMA_,/g'
	Reported by Vadim Konovalov <vkonovalov@alcatel-lucent.com>

2007-10-28  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (update-docbook-utils): remove from all because
	it downloads 23MB data
	* doc/Makefile (docbook-dtd, docbook-xsl): replaces update-docbook-utils

2007-10-27  Sam Steingold  <sds@gnu.org>

	* utils/fix-perms.sh: all Makefile* are non-executable

2007-10-27  Sam Steingold  <sds@gnu.org>

	* makemake.in, configure, po/Makefile.in.in: use datarootdir
	instead of datadir, as per autoconf 2.60

2007-10-27  Sam Steingold  <sds@gnu.org>

	* modules/oracle/configure.in, modules/fastcgi/configure.in: use
	CL_MODULE_COMMON_CHECKS to avoid errors when generating aclocal.m4

2007-10-27  Sam Steingold  <sds@gnu.org>

	Berkeley-DB 4.5.20 now works
	* modules/berkeley-db/configure.in (DB_READ_UNCOMMITTED)
	(DB_READ_COMMITTED): do not check, they are #defined
	* modules/berkeley-db/bdb.c: ditto
	(dbe_get_tas_spins) [HAVE_DB_ENV_MUTEX_GET_TAS_SPINS]: define
	(dbe_set_tas_spins) [HAVE_DB_ENV_MUTEX_SET_TAS_SPINS]: define

2007-10-26  Sam Steingold  <sds@gnu.org>

	* modules/regexp/regexi.c: do not include <alloca.h>: it is
	defined, if necessary, in <clisp.h>; include "regex.h", not <>
	* modules/regexp/configure.in [ac_use_included_regex=yes]: link
	src/gllib/regex.h into the build directory
	* modules/wildcard/wildcard.lisp: include the local "config.h",
	not the global <> one
	* modules/wildcard/configure.in [FNMATCH_H]: link
	src/gllib/fnmatch.h into the build directory
	Reported by Yaroslav Kavenchuk <kavenchuk@tut.by>

2007-10-26  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (win32msvc/makefile.msvc*): generate from src to
	enable search in gllib
	* clisp.spec (modules): add libsvm

2007-10-26  Sam Steingold  <sds@gnu.org>

	* makemake.in (hln): use utils/hln.lisp instead of utils/hln/
	* utils/hln/: remove
	* utils/hln.lisp: add
	* Makefile.devel (CONFIGURES): drop hln

2007-10-26  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (gnulib-update): also get link-follow
	* glm4/link-follow.m4: add
	* modules/syscalls/configure.in: call gl_AC_FUNC_LINK_FOLLOWS_SYMLINK
	* modules/syscalls/calls.c (my_link)
	[!LINK_FOLLOWS_SYMLINKS && HAVE_REALPATH]: work around link(2) bug
	(hardlink_file) [UNIX]: use my_link()

2007-10-25  Sam Steingold  <sds@gnu.org>

	* init.lisp: all foreign messages require UNICODE because they use
	non-ASCII characters (including german too!)

2007-10-24  Sam Steingold  <sds@gnu.org>

	support post-4.4.20 berkeley-db; more uniform option handling
	* modules/berkeley-db/configure.in (DB_LOCK_READ_UNCOMMITTED)
	(DB_READ_UNCOMMITTED, DB_READ_COMMITTED): check for declarations
	* modules/berkeley-db/bdb.c (DB_LOCK_READ_UNCOMMITTED)
	[!HAVE_DECL_DB_LOCK_READ_UNCOMMITTED]: define to DB_LOCK_DIRTY
	(DB_READ_UNCOMMITTED) [!HAVE_DECL_DB_READ_UNCOMMITTED]:
	define to DB_DIRTY_READ
	(DB_READ_COMMITTED) [!HAVE_DECL_DB_READ_COMMITTED]:
	define to DB_DEGREE_2
	(DB-GET, DB-OPEN, MAKE-DBC, DBC-GET, LOCK-GET, TXN-BEGIN): accept
	only :READ-UNCOMMITTED and READ-COMMITTED, not :DEGREE-2 & DIRTY-READ
	Reported by Reini Urban <rurban@x-ray.at>

2007-10-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (build-aux-update): new .PHONY target, extracted
	from gnulib-update; also updates ltmain.sh and compile
	(gnulib-update): depend on build-aux-update

2007-10-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (gnulib-update): also get
	uniwidth/width streq uniname/uniname unitypes
	* cjk.h, streq.h, uniname.c, uniname.h, uninames.h, unitypes.h,
	* uniwidth.h, width.c: remove; get them from gnulib
	* makemake.in: find these files in gllib

2007-10-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (AUTOCONF_FILES): src/aclocal.m4
	(autoconf/aclocal.m4): move to aclocal.m4
	(autoconf/autoconf.m4): remove
	this move is necessary for automake which expects aclocal.m4 in
	the current directory, just like configure.in

2007-10-24  Sam Steingold  <sds@gnu.org>

	* m4/gethostname.m4, m4/readlink.m4: remove trivial files
	* configure.in: use AC_CHECK_FUNCS instead of
	CL_GETHOSTNAME & CL_READLINK

2007-10-23  Sam Steingold  <sds@gnu.org>

	* error.d (begin_error): check *RECURSIVE-ERROR-COUNT* before
	accessing it, not after

2007-10-22  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (upload): split into
	upload-ssh upload-sf upload-sunsite upload-gnu

2007-10-22  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (xlib_error_handler): fix converter types:
	NextRequest and serial are unsigned long, while minor_code is uint8
	(XLIB:GET-PROPERTY): fix type of r (int->Status)

2007-10-22  Sam Steingold  <sds@gnu.org>

	remove libcharset; use gnulib/localcharset
	* Makefile.devel (CONFIGURES): remove libcharset/configure
	(libcharset/configure): remove target
	(gnulib-update): add localcharset
	(SOURCES4): drop libcharset
	* configure: do not configure libcharset
	* encoding.d: include "localcharset.h" instead of "libcharset.h"
	* makemake.in: use gnulib/localcharset instead of libcharset

2007-10-22  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (gnulib-update): cvs up gnulib;
	check for duplicate m4 files
	declare phony targets as such
	(multibuild-linux-x86, multibuild-darwin-powerpc): use descriptive
	directory names

2007-10-22  Sam Steingold  <sds@gnu.org>

	* makemake.in (LIBOBJS): undo the 2007-10-19 patch; completely remove
	(XCFLAGS): do not add -Igllib
	(MODULE_CFLAGS): add -Igllib

2007-10-22  Sam Steingold  <sds@gnu.org>

	* m4/glibc2.m4, m4/lcmessage.m4, m4/progtest.m4, m4/uintmax_t.m4:
	* m4/wchar_t.m4, m4/xsize.m4: remove files, they are now in glm4

2007-10-22  Sam Steingold  <sds@gnu.org>

	* configure: disable "exit on error" (set +x) around 'test -z
	"$stacksizelimit"' to access exit status instead of exiting configure

2007-10-22  Sam Steingold  <sds@gnu.org>

	* makemake.in [CC_CPLUSPLUS]: build gnulib with gcc because of
	http://sources.redhat.com/bugzilla/show_bug.cgi?id=5200
	(version.h): always use ${SPVW_VERSION}
	* version.h: regenerated

2007-10-20  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (malloc) [UNIX | __MINGW32__]: undef after
	#include "config.h" because it could be defined as rpl_malloc by gnulib

2007-10-20  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (OPEN-FONT, LIST-FONTS, LIST-FONT-NAMES):
	use check_string & check_uint_defaulted
	(make_font_with_info): renamed to make_font; do not accept info
	(LIST-FONTS): do not fill XFontStruct (FONT-INFO) because it
	introduces a memory leak
	(CLOSE-FONT): call DISCARD-FONT-INFO

2007-10-20  Sam Steingold  <sds@gnu.org>

	* ffcall/avcall/configure.in, ffcall/callback/configure.in:
	* ffcall/callback/trampoline_r/configure.in:
	* ffcall/callback/vacall_r/configure.in:
	* ffcall/trampoline/configure.in, ffcall/vacall/configure.in:
	call AC_CONFIG_AUX_DIR before AC_PROG_INSTALL

2007-10-19  Sam Steingold  <sds@gnu.org>

	* modules/regexp/configure.in (REGEX_H, ALLOCA): drop unused variables
	* modules/regexp/link.sh.in (ALLOCA): drop useless variable
	* modules/regexp/regexi.c [HAVE_ALLOCA_H]: include <alloca.h>

2007-10-19  Sam Steingold  <sds@gnu.org>

	* ffcall/Makefile.devel (build-aux/config.guess, build-aux/config.sub)
	(build-aux/ltmain.sh, build-aux/install-sh): new targets (copy
	from CLISP which copies from gnulib)
	(ffcall/build-aux/install-sh): add
	(ffcall/build-aux/config.guess, ffcall/build-aux/config.sub)
	(ffcall/build-aux/ltmain.sh): update

2007-10-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (GL_LIBOBJS): init from @gl_LIBOBJS@
	(LIBOBJS): link utils using it

2007-10-19  Sam Steingold  <sds@gnu.org>

	* m4/general.m4 (CL_MODULE_COMMON_CHECKS): added
	* modules/berkeley-db/configure.in, modules/dirkey/configure.in:
	* modules/gdbm/configure.in, modules/gtk2/configure.in:
	* modules/i18n/configure.in, modules/pari/configure.in:
	* modules/pcre/configure.in, modules/postgresql/configure.in:
	* modules/rawsock/configure.in, modules/readline/configure.in
	* modules/regexp/configure.in, modules/syscalls/configure.in
	* modules/wildcard/configure.in, modules/zlib/configure.in: use it
	* m4/general.m4 (CL_FFCALL_COMMON_LIBTOOL)
	(CL_FFCALL_COMMON_TRAMPOLINE): add
	* ffcall/avcall/configure.in, ffcall/callback/configure.in:
	* ffcall/callback/vacall_r/configure.in: use CL_FFCALL_COMMON_LIBTOOL
	* ffcall/callback/trampoline_r/configure.in:
	* ffcall/trampoline/configure.in: use CL_FFCALL_COMMON_LIBTOOL
	and CL_FFCALL_COMMON_TRAMPOLINE

2007-10-19  Sam Steingold  <sds@gnu.org>

	autoconf cleanup
	* ffcall/Makefile.devel (m4/install.m4): drop
	(m4/libtool.m4): do not generate from clisp
	* ffcall/m4/libtool.m4: use AC_CANONICAL_HOST
	instead of CL_CANONICAL_HOST
	* ffcall/autoconf/aclocal.m4 (m4/install.m4): drop
	* ffcall/avcall/configure.in, ffcall/callback/configure.in:
	* ffcall/callback/trampoline_r/configure.in:
	* ffcall/callback/vacall_r/configure.in:
	use AC_PROG_INSTALL instead of CL_PROG_INSTALL and
	AC_CONFIG_AUX_DIR instead of CL_CANONICAL_HOST
	* m4/general.m4: drop CL_CANONICAL_HOST, use AC_CANONICAL_HOST
	instead; we have build-aux/install-sh anyway, so no need for the trick
	* m4/install.m4, m4/lib-ld.m4, m4/libtool.m4: drop unused
	* configure.in: use AC_CANONICAL_HOST & CL_CANONICAL_HOST_CPU
	instead of CL_CANONICAL_HOST;
	and AC_PROG_INSTALL instead of CL_PROG_INSTALL

2007-10-18  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (check_gdbm, open_gdbm): support g++ compilation

2007-10-18  Sam Steingold  <sds@gnu.org>

	* gettext.m4, iconv.m4, intdiv0.m4, intmax.m4, inttypes-pri.m4:
	* inttypes.m4, inttypes_h.m4, nls.m4, po.m4, size_max.m4:
	* printf-posix.m4, stdint_h.m4, lib-link.m4, lib-prefix.m4:
	* onceonly.m4: import from gnulib, so move from src/m4 to src/glm4
	* Makefile.devel (gnulib-update): also get havelib & gettext
	* ffcall/Makefile.devel (m4/longlong.m4): get from $(CLISP_DIR)/src/glm4

2007-10-18  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (GDBM-STORE, GDBM-DELETE, CHECK_RUN):
	tighten error checking: any non-0 status is an error

2007-10-18  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (view-html): use BROWSERS

2007-10-18  Sam Steingold  <sds@gnu.org>

	* makemake.in (EVERY_INCLUDES_H): stdbool.h & stdint.h are in gllib
	* configure: accept --vimdir and pass it on to makemake
	always run makemake, it is no longer a user-level command
	this fixes bug [ 1467976 ]: clisp configure does not follow GNU
	conventions

2007-10-17  Sam Steingold  <sds@gnu.org>

	* makemake.in (SUBDIRS): pass depfiles to config.status to
	re-create gllib/.deps/
	* configure.in: use gl_STDBOOL_H instead of gt_STDBOOL_H
	* modules/regexp/Makefile.in: drop REGEX_O
	* modules/regexp/link.sh.in (file_list): fix adding @ALLOCA@ & @REGEX_O@
	* modules/wildcard/Makefile.in: drop FNMATCH_O
	* modules/wildcard/link.sh.in (file_list): fix adding @FNMATCH_O@
	* Makefile.devel (src/gllib/Makefile.in): do not force;
	do not create src/configure.ac
	(src/autoconf/aclocal.m4): simplify (use src/configure.in as is)
	* clisp-link.in (link_some): new function; use it to avoid
	accidental creation of circular links because now some module
	files may reside in ../gllib instead of the module directory

2007-10-16  Sam Steingold  <sds@gnu.org>

	use gnulib-tool to synchronize with gnulib
	* unixconf.h.in: renamed to config.h.in
	* Makefile.devel (CONFIG_H_IN): updated
	(gnulib-update): new target
	* configure.in: generate gllib/Makefile; call gl_EARLY, gl_INIT
	* makemake.in: unixconf.h -> config.h
	(MAKE): use @SET_MAKE@
	(SUBDIRS): add, start with building gllib
	(am--refresh): new target, required by automake
	* lispbibl.d, win32.d: unixconf.h -> config.h
	* stdbool.h.in, stdint_.h: remove gnulib files
	* gllib, glm4: add directories (created by gnulib-update)
	* m4/alloca.m4, m4/codeset.m4, m4/extensions.m4, m4/fnmatch.m4:
	* m4/glibc21.m4, m4/longlong.m4, m4/mbstate_t.m4, m4/regex.m4:
	* m4/stdbool.m4, m4/stdint.m4, m4/ulonglong.m4, m4/wint_t.m4:
	remove files, they are now in glm4
	* modules/regexp/: remove gnulib files
	* modules/regexp/link.sh.in, modules/regexp/Makefile.in: updated
	* modules/wildcard/: remove gnulib files
	* modules/wildcard/link.sh.in, modules/wildcard/Makefile.in: updated

2007-10-16  Masayuki Onjo  <masayuki.onjo@gmail.com>
	Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (GDBM-STORE, GDBM-DELETE): signal an error
	on failure instead of returning a boolean

2007-10-16  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GPG): use gpg, not gpg2
	(tag-release): pass "." to cvs

2007-10-16  Sam Steingold  <sds@gnu.org>

	* version.sh: clisp 2.42 release

2007-10-15  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/demos/qix.lisp (qix): use uniform UI
	* modules/clx/new-clx/demos/clx-demos.lisp (*demos*): greynetic &
	bball are broken

2007-10-15  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (TP_EMAIL): coordinator@translationproject.org

2007-10-15  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCFLAGS) [debug & cpu=x86_64]: omit -DDEBUG_SPVW to
	work around bug #[ 1413016 ]: amd64 debug build broken (gc aborts)

2007-10-13  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (check_gdbm): gdbm arg is a gcv_object_t*
	(GDBM-OPEN, GDBM-DEFAULT-KEY-TYPE, GDBM-DEFAULT-VALUE-TYPE, GDBM-CLOSE)
	(GDBM-FILE-SIZE, GDBM-STORE, GDBM-FETCH, GDBM-DELETE, GDBM-FIRSTKEY)
	(GDBM-NEXTKEY, GDBM-REORGANIZE, GDBM-SYNC, GDBM-EXISTS, GDBM-SETOPT):
	update all callers

2007-10-12  Sam Steingold  <sds@gnu.org>

	* version.sh, spvw.d: pretest 2.41.1 (2007-10-12)
	* Makefile.devel: coalesce TOPNAME & TOPDIR; fix tp-mail

2007-10-12  Sam Steingold  <sds@gnu.org>

	modify the last patch to be more general and less cluttered by default
	* trace.lisp (tracer): replace GLOBAL-CALL-COUNTER and
	LOCAL-CALL-COUNTER with BINDINGS
	(trace1): use BINDINGS in the trace body
	(trace-output, trace-pre-output, trace-post-output): do not accept
	LOCAL-CALL-COUNT
	(untrace2): remove the PROCLAIM call

2007-10-11  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (open_gdbm): extracted from GDBM-OPEN
	(GDBM-OPEN): accept GDBM structures to re-open them if necessary

2007-10-10  Sam Steingold  <sds@gnu.org>

	drop sub-byte bit vectors because we need to keep vector length
	together with the data (similar to binary stream i/o)
	* modules/gdbm/gdbm.c (gdbm_data_t, check_data_type, with_datum)
	(datum_to_object): drop GDBM_DATA_BIT_VECTOR, add
	GDBM_DATA_32BIT_VECTOR & GDBM_DATA_8BIT_VECTOR

2007-10-10  Sam Steingold  <sds@gnu.org>

	closed GDBM is no longer accepted by functions requiring DB access
	* modules/gdbm/gdbm.c (check_gdbm): accept require_valid_handle arg
	(GDBM-FILE-SIZE, GDBM-STORE, GDBM-FETCH, GDBM-DELETE, GDBM-FIRSTKEY)
	(GDBM-NEXTKEY, GDBM-REORGANIZE, GDBM-SYNC, GDBM-EXISTS, GDBM-SETOPT):
	require an open GDBM

2007-10-10  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (gdbm_data_t): replace GDBM_DATA_BINARY with
	GDBM_DATA_VECTOR and GDBM_DATA_BIT_VECTOR; and GDBM_DATA_FIXNUM
	with GDBM_DATA_INTEGER
	(check_data_type): use CL symbols for types
	(gdbm_open_read_write, gdbm_open_option, gdbm_store_flag):
	use the "default=" DEFCHECKER option
	(GDBM-OPEN): accept :DEFAULT-KEY-TYPE and :DEFAULT-VALUE-TYPE
	(check_gdbm): also extract the default types
	(GDBM-DEFAULT-KEY-TYPE, GDBM-DEFAULT-VALUE-TYPE): add
	(error_bad_type): add
	(with_datum): use it; replace fixnum with integer, using I_to_LEbytes
	(datum_to_object): use switch; signal an error on GDBM_DATA_NOTYPE,
	handle integers (with LEbytes_to_I) and bit vectors
	(gdbm_setopt_option): accept :DEFAULT-VALUE-TYPE and :DEFAULT-KEY-TYPE
	(GDBM-SETOPT): set the default types
	make available even without HAVE_GDBM_SETOPT
	* modules/gdbm/gdbm.lisp (gdbm): add slots PATH, KEY-TYPE, VALUE-TYPE
	(gdbm-path, gdbm-default-key-type, gdbm-default-value-type): export
	(gdbm-open-p): add

2007-10-09  Sam Steingold  <sds@gnu.org>

	* utils/modprep.lisp (to-C-name): drop package prefix to support
	non-keyword symbols in DEFCHECKER which are not followed by "="

2007-10-09  Masayuki Onjo  <masayuki.onjo@gmail.com>

	change keyword argument :binary -> :type
	* modules/gdbm/gdbm.c (gdbm_data_t, check_data_type): add
	(with_datum, datum_to_object): also handle fixnums and floats
	(GDBM-FETCH, GDBM-FIRSTKEY, GDBM-NEXTKEY): take :TYPE instead of :BINARY

2007-10-09  Sam Steingold  <sds@gnu.org>

	implement RFE #[ 1808029 ]: trace with call counters
	* trace.lisp (make-local-call-counter): add
	(tracer): add GLOBAL-CALL-COUNTER & LOCAL-CALL-COUNTER slots
	(trace1): incf GLOBAL-CALL-COUNTER & bind LOCAL-CALL-COUNTER
	(trace-output): abstracted from ...
	(trace-pre-output, trace-post-output): accept LOCAL-CALL-COUNTER
	(untrace2): make LOCAL-CALL-COUNTER notspecial

2007-10-08  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:ACCESS-HOSTS):
	handle FamilyServerInterpreted
	(make_xatom): check XGetAtomName return value
	(DISPLAY-VENDOR): check ServerVendor return value
	(KEYSYM-NAME): check XKeysymToString return value
	(XLIB::DISPLAY-EXTENDED-MAX-REQUEST-LENGTH)
	(XLIB::DISPLAY-RESOURCE-MANAGER-STRING)
	(XLIB::SCREEN-RESOURCE-STRING): add, but do not export
	(DISPLAY-RESOURCE-ID-BASE, DISPLAY-RESOURCE-ID-MASK): implement
	using <X11/Xlibint.h>
	(XScreenNo): return -1 on failure
	(XLIB::SET-DISPLAY-DEFAULT-SCREEN): use it
	* modules/clx/new-clx/clx.lisp (CHANGE-KEYBOARD-MAPPING)
	(KEYBOARD-MAPPING, DISPLAY-RESOURCE-ID-BASE)
	(DISPLAY-RESOURCE-ID-MASK): do not mark as UNDEFINED

2007-10-07  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:SET-DISPLAY-DEFAULT-SCREEN): add
	(XLIB:LIST-FONTS): use XLoadFont instead of passing NULL font
	* modules/clx/new-clx/clx.lisp (DISPLAY-DEFAULT-SCREEN): add a DEFSETF
	(get-default-display, open-default-display): add from clx
	(cut-buffer, (setf cut-buffer), rotate-cut-buffers):
	use DISPLAY-DEFAULT-SCREEN instead of (FIRST DISPLAY-ROOTS)
	* modules/clx/new-clx/demos/clx-demos.lisp (x-host-display)
	(x-open-display): drop
	* modules/clx/new-clx/demos/bball.lisp:
	* modules/clx/new-clx/demos/bwindow.lisp:
	* modules/clx/new-clx/demos/greynetic.lisp:
	* modules/clx/new-clx/demos/hanoi.lisp:
	* modules/clx/new-clx/demos/koch.lisp:
	* modules/clx/new-clx/demos/petal.lisp:
	* modules/clx/new-clx/demos/plaid.lisp:
	* modules/clx/new-clx/demos/recurrence.lisp:
	* modules/clx/new-clx/demos/sokoban.lisp:
	use XLIB:DISPLAY-DEFAULT-SCREEN instead of CLX-DEMOS:X-OPEN-DISPLAY
	* modules/clx/new-clx/demos/clclock.lisp:
	new demo based on http://common-lisp.net/~crhodes/clx
	* modules/clx/new-clx/demos/clx-demos.lisp (*demos*): add clclock

2007-09-30  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/image.lisp (image-pixmap): pass the required
	arguments :width & :height to put-image

2007-10-06  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/bdb.c: use safe_to_string when appropriate

2007-10-06  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c: use *misc-encoding* for string conversion
	(error_gdbm): accept fatal_message
	(GDBM-OPEN): pass it as the 5th arg to gdbm_open()
	* modules/gdbm/gdbm.lisp (gdbm-error): add :CODE slot

2007-10-06  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (switchu): remove: was used 3 times for strmtype in ...
	* predtype.d (TYPE-OF, CLASS-OF, heap_statistics_mapper):
	use switch instead of switchu.
	switch is already used with strmtype in stream.d and spvw_circ.d

2007-10-06  Sam Steingold  <sds@gnu.org>

	* makemake.in (vimdir): install in ${datadir}/vim/vimfiles/after/syntax
	* clisp.spec: add %{prefix}/share/vim/vimfiles/after/syntax/lisp.vim

2007-10-02  Sam Steingold  <sds@gnu.org>

	* error.d (OS_filestream_error): check that the stream argument is
	actually a stream object (this is needed because OS_filestream_error
	is called by handle_lseek which is called by handle_length which
	is used by the gdbm module which does not have Lisp streams)
	* genclisph.d (emit_to_I): add and use it for size, ssize and off
	* lispbibl.d (handle_length): add declaration
	(off_to_I): define using sint??_to_I instead of [QL]_to_I because
	Q_to_I may not be defined on a 32-bit platform
	(uint64_to_I, sint64_to_I): always define
	* stream.d (handle_length): implement
	(fd_lseek): extract from handle_lseek
	(handle_lseek): use it
	(FILE-LENGTH): use it to handle unbuffered streams
	(FILE-POSITION): use handle_lseek on unbuffered streams
	* modules/gdbm/gdbm.c (GDBM:GDBM-FILE-SIZE): use handle_length

2007-10-02  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (GDBM:GDBM-FILE-SIZE): implement
	* modules/gdbm/gdbm.lisp (GDBM:GDBM-FILE-SIZE): export
	(gdbm-p, gdbm-error, gdbm-error-message): export
	* modules/gdbm/configure.in: check for all functions
	* modules/gdbm/gdbm.c: use the configure checks

2007-10-01  Sam Steingold  <sds@gnu.org>

	* genclisph.d: emit size_to_I & ssize_to_I
	* modules/rawsock/rawsock.c (size_to_I, ssize_to_I): remove
	* modules/rawsock/configure.in: do not check for sizeof(size_t)
	* modules/pcre/cpcre.c (fullinfo_size): use size_to_I

2007-10-01  Sam Steingold  <sds@gnu.org>

	* modules/pcre/cpcre.c (PCRE-VERSION, PCRE-COMPILE): use
	safe_to_string()
	(fullinfo_size): accept option argument;
	use size_t instead of unsigned long int
	(fullinfo_nametable): fix combining 2 bytes into an int
	(PATTERN-INFO): do not report PCRE_INFO_BACKREFMAX twice;
	use fullinfo_size instead of fullinfo_int for PCRE_INFO_STUDYSIZE

2007-09-30  Sam Steingold  <sds@gnu.org>

	* utils/fix-perms.sh: report what is been done;
	make link.sh not executable

2007-09-30  Sam Steingold  <sds@gnu.org>

	* makemake.in: accept --vimdir and install the new file lisp.vim
	there (defaults to ${datadir}/vim/vimfiles/after)

2007-09-30  Sam Steingold  <sds@gnu.org>

	* .gdbinit (full): also break in xlib_error_handler
	* modules/clx/new-clx/demos/bball.lisp:
	* modules/clx/new-clx/demos/bwindow.lisp:
	* modules/clx/new-clx/demos/greynetic.lisp:
	* modules/clx/new-clx/demos/hanoi.lisp:
	* modules/clx/new-clx/demos/petal.lisp:
	* modules/clx/new-clx/demos/plaid.lisp:
	* modules/clx/new-clx/demos/recurrence.lisp: adapted from
	http://www.cs.cmu.edu/afs/cs/project/ai-repository/ai/lang/lisp/gui/clx/clx_demo.cl
	* modules/clx/new-clx/demos/clx-demos.lisp (*demos*): new variable
	which lists all demos
	(run-all-demos): new function
	* modules/clx/new-clx/demos/qix.lisp (qix): use
	XLIB:DISPLAY-DEFAULT-SCREEN instead of (FIRST XLIB:DISPLAY-ROOTS)
	* modules/clx/new-clx/demos/koch.lisp (koch): ditto

2007-09-29  Sam Steingold  <sds@gnu.org>

	* complete.lisp (completion): when no symbols are found and no package
	separator #\: has been entered, search for completion among packages
	* init.lisp: load complete after macros3 because of WITH-COLLECT

2007-09-26  Sam Steingold  <sds@gnu.org>

	wrap all library calls in begin_system_call/end_system_call
	* modules/gdbm/gdbm.c (SYSCALL): add
	(GDBM-OPEN, GDBM-CLOSE, with_datum, GDBM-SYNC): use it
	(GDBM-STORE, GDBM-FETCH, GDBM-DELETE, GDBM-FIRSTKEY, GDBM-NEXTKEY)
	(GDBM-EXISTS): set values outside of with_datum()
	(CHECK_RUN): add a convenience wrapper
	(GDBM-REORGANIZE, GDBM-SETOPT): use it

2007-09-26  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:MOTION-EVENTS): XFree(events)
	(XLIB:MODIFIER-MAPPING): use STACK_to_mv, return no values on failure
	(XLIB:SET-MODIFIER-MAPPING): clean-up stack on failure
	(make_fill_bit_vector): add
	(make_key_vector, XLIB:%SAVE-GCONTEXT-COMPONENTS)
	(XLIB:KEYBOARD-CONTROL): use it
	(XLIB:SET-MODIFIER-MAPPING): fix memory corruption in xmk construction
	(XLIB:CHANGE-KEYBOARD-MAPPING): fix memory corruption in
	XChangeKeyboardMapping call (num_codes = #keysyms, not #keycodes)

2007-09-26  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1797132 ]: assertion failure in new-clx
	support 64-bit KeySym in KEYBOARD-MAPPING using an extra dimension
	* modules/clx/new-clx/configure.in : AC_CHECK_SIZEOF(KeySym)
	* modules/clx/new-clx/clx.f (KBD_MAP_RANK, check_dim)
	(KBD_MAP_TYPE, extra_dim_push): define based on SIZEOF_KEYSYM
	(check_kbdmap_mx): replaces check_uint32_mx
	(XLIB:CHANGE-KEYBOARD-MAPPING, XLIB:KEYBOARD-MAPPING): use them

2007-09-26  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (check_error_code): add DEFCHECKER
	(xlib_error_handler): use check_error_code_reverse instead of a
	literal vector lookup for robustness and readability

2007-09-26  Sam Steingold  <sds@gnu.org>

	support non-keyword symbols in DEFCHECKER
	* utils/modprep.lisp (maybe-prepend-colon): add
	(new-checker): use it
	(print-tables-1): separate objects with spaces

2007-09-26  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (xlib_a_cons): use allocate_cons()
	instead of `(NIL . NIL)` for initialization

2007-09-25  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (make_key_vector): do not clobber value1
	(check_bitvec_256): new macro
	(get_key_vector): implemented
	(XLIB:OPEN-DISPLAY): call disable_sigpipe() not here, but ...
	(module__clx__init_function_2): ... here
	(XLIB::SET-GCONTEXT-DASHES, handle_image_z, XLIB:PUT-IMAGE)
	(XLIB:CHANGE-PROPERTY, XLIB:GLOBAL-POINTER-POSITION)
	(XLIB:KEYBOARD-MAPPING, XLIB:OPEN-DISPLAY): remove unused variable
	(font_char_info): simplify to avoid a gcc warning
	(XLIB:INPUT-FOCUS): fix STACK handling
	(XLIB:GRAB-KEY): fix XGrabKey call
	(XLIB:QUERY-KEYMAP): use check_bitvec_256
	(XLIB:KEYCODE->CHARACTER): fix KEYSYM-INDEX-FUNCTION handling
	(X11/Xauth.h): #include
	(my_xau_get_auth_by_name): add (fixme?)
	(XLIB:DISPLAY-AUTHORIZATION-DATA, XLIB:DISPLAY-AUTHORIZATION-NAME):
	use it or return constant ""
	(XLIB:DISPLAY-AUTHORIZATION): add
	* modules/clx/new-clx/clx.lisp (XLIB:DISPLAY-AUTHORIZATION): export

2007-09-23  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (with_datum): replacement for with_gdbm_key
	* modules/gdbm/gdbm.lisp (define-condition):
	do not terminate the message with "."

2007-09-23  Masayuki Onjo  <masayuki.onjo@gmail.com>

	* modules/gdbm/gdbm.lisp (GDBM:WITH-OPEN-DB): add macro
	* modules/gdbm/gdbm.c (with_gdbm_key): add macro
	(GDBM-FETCH, GDBM-DELETE, GDBM-EXISTS): add vector support
	(GDBM-FIRSTKEY, GDBM-NEXTKEY): new keyword argument :BINARY

2007-09-22  Sam Steingold  <sds@gnu.org>

	* modules/dirkey/dirkey.c (fehler_ldap): rename to error_ldap
	* modules/pcre/cpcre.c (pcre_error): rename to error_pcre
	* modules/clx/new-clx/clf.x (closed_display_error): rename to
	error_closed_display
	* .gdbinit (full): break in error_gdbm

2007-09-21  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (CHECK_SOCKADDR): new macro
	(SOCKADDR-FAMILY, optional_sockaddr_argument, BIND, CONNECT)
	(GETNAMEINFO, fill_msghdr, SENDTO): use it

2007-09-21  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/bdb.c (dbe_get_data_dirs): declare a variable
	in the block where it is actually used
	(record_length): use default: to avoid a compiler warning about
	enumeration values not handled in switch and control reaching end
	of non-void function

2007-09-20  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c [HAVE_SIGNALS]: use writing_to_subprocess
	to avoid being killed by SIGPIPE
	(begin_sock_call, end_sock_call): define
	(SYSCALL, GET_SOCK_OPT, SET_SOCK_OPT): use them instead of
	begin_system_call/end_system_call

2007-09-20  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (GDBM-STORE, GDBM-FETCH, GDBM-DELETE)
	(GDBM-NEXTKEY, GDBM-EXISTS): use a variable from with_string_0
	instead of calling asciz_length()
	(GDBM:GDBM-SETOPT): convert :CACHESIZE argument properly

2007-09-20  Masayuki Onjo  <masayuki.onjo@gmail.com>

	* modules/gdbm/gdbm.c (GDBM:GDBM-VERSION): add
	* modules/gdbm/gdbm.lisp (GDBM-VERSION): export

2007-09-18  Sam Steingold  <sds@gnu.org>

	bug fix: pwd struct fields can be NULL which caused segfault
	* misc.d, lispbibl.d (push_string_array, safe_to_string): add
	* modules/syscalls/calls.c (ARR_TO_LIST): remove
	(hostent_to_lisp, servent_to_lisp, grp_to_lisp):
	use push_string_array instead of ARR_TO_LIST
	(utmpx_to_lisp, UNAME, servent_to_lisp, passwd_to_lisp, FILE-OWNER)
	(VERSION, PropVariantToLisp, FILE-PROPERTIES): use safe_to_string
	* modules/rawsock/rawsock.c (GETADDRINFO): use safe_to_string
	(protoent_to_protocol, netent_to_network): use push_string_array

2007-09-17  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.lisp (GDBM:DO-DB): new macro
	* modules/gdbm/configure.in (<gdbm/gdbm.h>): check
	* modules/gdbm/gdbm.c: #include <gdbm/gdbm.h> when it is available
	(GDBM::GDBM-OPEN): finalize GDBM object
	(datum_to_object): new function
	(GDBM:GDBM-FIRSTKEY, GDBM:GDBM-NEXTKEY): use it
	(GDBM:GDBM-SETOPT): simplify code
	(check_gdbm): return GDBM_FILE; update all callers; fix some GC-safety

2007-09-17  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (POSIX:LOADAVG): implement
	* modules/syscalls/posix.lisp (POSIX:LOADAVG): export
	* modules/syscalls/configure.in (getloadavg): check

2007-09-17  Masayuki Onjo  <masayuki.onjo@gmail.com>
	Sam Steingold  <sds@gnu.org>

	* Makefile.devel (MODULES): added gdbm
	* modules/gdbm: new module

2007-08-26  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (finalize-coutput-file): write
	register_foreign_inttype forms into init_function_2 ("init once")
	instead of init_function_1 ("init-always")

2007-08-24  Sam Steingold  <sds@gnu.org>

	implement RFE #[ 1779938 ]: RENAME-DIRECTORY
	* pathname.d (RENAME-DIR): implement
	* constsym.d, subr.d (rename_dir): add
	* init.lisp (rename-dir): exoirt

2007-08-24  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/bdb.c: fix some error_bdb calls;
	use db->get_env instead of a direct dbenv slot access;
	avoid "DB->get_cachesize: method not permitted when environment
	specified" error log messages
	(BDB:DBE-SET-OPTIONS): accept :NCACHE :CACHESIZE :CACHE
	(BDB:DBE-GET-OPTIONS): report :CACHE
	(cache2lisp): extract from db_get_cache
	(dbe_get_cache): add
	(db_get_cache): call it when db is based on a dbe
	(db_get_type): new function
	fix bug #[ 1779416 ]: Berkeley-DB module outputs spurious errors
	(record_length): do not call get_re_len on DB_BTREE & DB_HASH
	(BDB:DB-GET-OPTIONS): do not call methods inappropriate for a DB
	type, avoiding "call implies an access method which is
	inconsistent with previous calls" error log messages

2007-08-23  Sam Steingold  <sds@gnu.org>

	* constobj.d (foreign_inttype_table): add
	* lispbibl.d (register_foreign_inttype): declare and export to clisp.h
	(mallocing, nomalloc): declare to avoid warnings
	* exporting.lisp (def-c-type): only one argument is required
	* foreign.d (parse_foreign_inttype, register_foreign_inttype): add
	(foreign_layout, convert_from_foreign, convert_to_foreign, do_av_start)
	(do_av_arg, do_va_start, do_va_arg, do_va_return): use
	foreign_inttype_table for system int types
	(init_ffi): register a couple of int types for the test suite
	* foreign1.lisp (def-c-type): when typespec is missing, assume int
	type and get size and sign at compile time
	(finalize-coutput-file): output int types
	* modules/bindings/glibc/linux.lisp: define most int types using
	the new one argument def-c-type call
	(dirent64, readdir64, readdir64_r, scandir64, alphasort64)
	(versionsort, versionsort64): add
	(seekdir, telldir): for some reason position is "long", not
	"off_t", in my <dirent.h> (glibc-headers-2.4-11)

2007-07-24  Sam Steingold  <sds@gnu.org>

	merge some netbsd/pkgsrc patches
	* makemake.in (XCC_CREATESHARED): treat DragonFly like all the
	other BSDs
	* ffcall/avcall/asmi386.h, ffcall/callback/vacall_r/asmi386.h:
	* ffcall/vacall/asmi386.h, asmi386.h, asmi386.hh:
	DragonFly defines __DragonFly__, not __DragonFly

2007-07-08  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1607416 ]: back_trace is not initialized when it is a
	register
	* spvw.d (back_trace): do not init to NULL at the declaration,
	instead...
	(init_memory): init back_trace to NULL here

2007-06-28  Sam Steingold  <sds@gnu.org>

	* pathname.d (make_launch_pipe): do not access STACK, accept
	pointers into it instead
	(init_launch_streamarg): accept a pointer into STACK instead of an index

2007-06-25  Jack Unrue  <jdunrue@gmail.com>

	* modules/syscalls/calls.c (FMTID_SummaryInformation)
	(FMTID_UserDefinedProperties): provide local definitions
	to support build using MinGW w32api 3.9

2007-06-25  Sam Steingold  <sds@gnu.org>

	* pathname.d (interpret_launch_priority): do not access STACK,
	accept an argument instead

2007-06-22  Sam Steingold  <sds@gnu.org>

	fix last patch
	* init.lisp (sys::get-doc-entity-caller): add
	(get-file-doc, set-file-doc): use it

2007-06-21  Sam Steingold  <sds@gnu.org>

	Keep separate file information for each caller (DEFUN, DEFSTRUCT &c)
	* init.lisp (sys::get-file-doc, sys::set-file-doc): add
	(sys::check-redefinition): use them

2007-06-20  Sam Steingold  <sds@gnu.org>

	* m4/proto.m4 (CL_PROTO_MISSING, CONST_VARIANTS, SIZE_VARIANTS):
	new macros
	* m4/connect.m4, m4/ioctl.m4, m4/select.m4, m4/tcpconn.m4: use them

2007-06-20  Sam Steingold  <sds@gnu.org>

	* malloc/getpagesize.h, malloc/gmalloc.c: updated from Emacs:
	LGPL->GPL; Pthreads; a prototype fix from CLISP bug #[ 1607416 ]

2007-06-19  Sam Steingold  <sds@gnu.org>

	* m4/ioctl.m4 (CL_IOCTL): "request" is an "unsigned int" on arm-wince-pe
	* m4/tcpconn.m4 (CL_TCPCONN): "len" is a "socklen_t" in setsockopt()
	Reported by Kamil Shakirov <kamils80@gmail.com>

2007-06-09  Sam Steingold  <sds@gnu.org>

	* modules/postgresql/configure.in, modules/postgresql/postgresql.lisp:
	search for PostgreSQL headers also in pgsql (for Mandriva)
	Suggested by Frederik Himpe <fhimpe@telenet.be>

2007-06-08  Jörg Höhle  <hoehle@users.sourceforge.net>

	* macros3.lisp (expand-LETF, expand-LETF*): use lexical environment
	(EXT:LETF): always return nil with empty body
	(LETF): fix a case with wrong order of parameters for (VALUES ...)

2007-06-06  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1731462 ]: EXT:LETF with more than one place
	* macros3.lisp (expand-LETF): accumulate intermediates

2007-06-06  Jörg Höhle  <hoehle@users.sourceforge.net>

	* loop.lisp (max-if, min-if): mark as ABI

2007-06-05  Sam Steingold  <sds@gnu.org>

	* modules/fastcgi/fastcgi.lisp (hex-value): use DIGIT-CHAR-P
	* modules/oracle/oracle.lisp (hex-value): ditto
	Suggested by Jörg Höhle.
	(if-null): remove (use OR instead)
	(curconn, connect, to-sqlval, hash-to-sqlparam-array, check-connection)
	(pairs-to-hash, array-to-hash): use AND & UNLESS instead
	(cat): use EXT:STRING-CONCAT

2007-06-03  Jörg Höhle  <hoehle@users.sourceforge.net>

	Use (gensym "NAME-") to enhance readability of CL macros.
	* condition.lisp (IGNORE-ERRORS, HANDLER-CASE, ASSERT, CHECK-TYPE)
	(ECASE, ETYPECASE, CCASE, CTYPECASE)
	(WITH-SIMPLE-RESTART, expand-restart-case): Use (gensym "NAME").
	* defs1.lisp (DO-SYMBOLS, DO-EXTERNAL-SYMBOLS)
	(EXT:DOSEQ, EXT:DOHASH): ditto
	* defs2.lisp (WITH-HASH-TABLE-ITERATOR): ditto
	* macros1.lisp (PROG1, PROG2, do/do*-expand, DOLIST, DOTIMES)
	(PSETQ, MULTIPLE-VALUE-BIND, MULTIPLE-VALUE-SETQ, COND): ditto
	* macros2.lisp (TYPECASE, NTH-VALUE, EXT:TIMES)
	(WITH-OUTPUT-TO-STRING): ditto
	* macros3.lisp (EXT:ETHE): ditto
	* loop.lisp (LOOP, expand-loop): ditto

2007-05-23  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1721583 ]: *terminal-encoding* readline segfault
	* encoding.d (sys::set-terminal-encoding): return normalized value.

2007-05-20  Bruno Haible  <bruno@clisp.org>

	* unix.d [UNIX_LINUX && UNIX_GNU]: Don't include <asm/page.h>.
	* lispbibl.d (UNIX_GNU): Move definition down.
	Reported by Ulrich Müller <ulm@gentoo.org>.

2007-05-13  Sam Steingold  <sds@gnu.org>

	* clos-class3.lisp (check-method-redefinition): extracted from
	ANALYZE-METHOD-DESCRIPTION
	(install-class-direct-accessors): use it
	* clos-method2.lisp (analyze-method-description): ditto

2007-05-13  Shawn Betts  <sabetts@vcn.bc.ca>
	Sam Steingold  <sds@gnu.org>

	* clx.f: as per the CLX manual,
	(:EXPOSURE, :GRAPHICS-EXPOSURE): :X, :Y, :WIDTH, :HEIGHT are uint16
	(:CONFIGURE-NOTIFY, :CREATE-NOTIFY, :GRAVITY-NOTIFY)
	(:REPARENT-NOTIFY, :CONFIGURE-REQUEST): :X, :Y are sint16

2007-05-09  Shawn Betts  <sabetts@vcn.bc.ca>
	Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:GET-PROPERTY): check
	XGetWindowProperty return value

2007-05-06  Sam Steingold  <sds@gnu.org>

	ensure that (DEFGENERIC IF) and (DEFUN IF) signal PROGRAM-ERROR
	* init.lisp (check-special-operator): extract from
	REMOVE-OLD-DEFINITIONS
	(check-redefinition): call it
	(remove-old-definitions): call either CHECK-REDEFINITION or
	CHECK-SPECIAL-OPERATOR

2007-05-06  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1713130 ]: some CL symbols are not locked
	* clos-genfun3.lisp (defgeneric): call SYS::CHECK-REDEFINITION
	(defmethod, defgeneric): use SYS::GET-FUNNAME-SYMBOL
	(ensure-generic-function-using-class): use PREDEFUN instead of DEFUN
	* clos-class3.lisp (finalize-inheritance, make-instances-obsolete)
	(class-name, validate-superclass, add-direct-subclass)
	(ensure-class-using-class, reader-method-class, writer-method-class)
	(remove-direct-subclass, class-direct-subclasses, compute-slots)
	(compute-class-precedence-list, compute-effective-slot-definition)
	(compute-effective-slot-definition-initargs, compute-default-initargs):
	use PREDEFUN instead of DEFUN
	* clos-genfun1.lisp (print-object, generic-function-methods)
	(generic-function-method-class, generic-function-signature)
	(generic-function-undeterminedp, generic-function-method-combination)
	(generic-function-argorder, generic-function-declarations): ditto
	* clos-genfun2a.lisp (compute-applicable-methods)
	(compute-applicable-methods-using-classes): ditto
	* clos-genfun2b.lisp (compute-discriminating-function)
	(add-method, remove-method): ditto
	* clos-methcomb2.lisp (compute-effective-method)
	(find-method-combination): ditto
	* clos-method1.lisp (method-function, method-qualifiers)
	(method-lambda-list, method-signature, method-specializers)
	(method-generic-function, (setf method-generic-function)): ditto
	* defs1.lisp (expand-form): moved here from init.lisp
	* defs2.lisp (default-directory, date-format, date-string, dir):
	moved here from init.lisp
	* init.lisp (in-package, the-environment, load, defmacro, defun):
	call SYS::CHECK-REDEFINITION explicitly at top-level
	(expand-form, default-directory, date-format, date-string, dir):
	move to defs*.lisp so that they are defined with full DEFUN

2007-05-04  Sam Steingold  <sds@gnu.org>

	* init.lisp (sys::check-redefinition): WHAT is a string,
	so use CALLER instead
	* places.lisp (define-setf-expander, defsetf):
	pass a string as WHAT to CHECK-REDEFINITION
	* clos-class2.lisp ((setf find-class)):
	call TEXT on WHAT in the CHECK-REDEFINITION call
	* clos-methcomb2.lisp (define-method-combination): ditto
	* clos-method2.lisp (analyze-method-description): ditto
	* cmacros.lisp (define-compiler-macro): ditto
	* trace.lisp (check-traceable): ditto

2007-04-28 Shawn Betts  <sabetts@vcn.bc.ca>
	Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (encode_event): because some slots point
	to the same C structure slot (:WINDOW and :EVENT-WINDOW mostly),
	the way encode_event is written :EVENT-WINDOW will overwrite :WINDOW.
	If :WINDOW is supplied and :EVENT-WINDOW is not, then the xevent
	slot will be set to 0, instead of the proper value.
	This patch memsets the whole structure to 0 and gets rid of the
	else clauses.

2007-04-28  Sam Steingold  <sds@gnu.org>

	* spvw.d (fehler_notreached): refer to
	http://clisp.cons.org/impnotes/faq.html#faq-bugs
	instead of asking for private e-mail

2007-04-23  Sam Steingold  <sds@podval.org>

	* modules/libsvm: upgraded to upstream 2.84

2007-04-04  Vadim Konovalov  <vadim@vkonovalov.ru>
	Sam Steingold  <sds@gnu.org>

	* lispbibl.d (unspecified) [MICROSOFT]: define to 0, like for GCC

2007-03-07  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1666851 ]: [AIX 5.3] Problem finding connect
	* m4/socklen_t.m4, configure.in, socket.d, stream.d, win32.d:
	* modules/rawsock/rawsock.c: replace SOCKLEN_T with CLISP_SOCKLEN_T
	because AIX defines SOCKLEN_T internally
	Thanks to Laurent Vaucher <laurentvaucher@users.sourceforge.net>

2007-02-27  Shawn Betts  <sabetts@vcn.bc.ca>
	Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f:
	use enum instead of #define for slot_DISPLAY_*
	(slot_DISPLAY_DISPLAY, display_structure_size): added
	(make_display): accept display_number
	(OPEN-DISPLAY): pass it to make_display()
	(DISPLAY-DISPLAY): return the new display slot
	* modules/clx/new-clx/clx.lisp (display): added DISPLAY slot

2007-02-22  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1666470 ]: EXT::LAUNCH crash
	again: cannot do pushSTACK(foo()) if foo() manipulates STACK
	* stream.d (make_pipe): new function
	(MAKE-PIPE-INPUT-STREAM, MAKE-PIPE-OUTPUT-STREAM, MAKE-PIPE-IO-STREAM)
	(mkops_from_handles, mkips_from_handles): use it
	(mkops_from_handles, mkips_from_handles): return value without STACK
	* lispbibl.d (mkops_from_handles, mkips_from_handles): update prototypes
	* pathname.d (make_launch_pipe): pass stack location instead of
	index as the first argument
	(LAUNCH): use L_to_I() for PID, not fixnum()

2007-02-22  Sam Steingold  <sds@gnu.org>

	fix new-clx "--with-debug" compilation
	* modules/clx/new-clx/clx.f (get_client_message_data): declare void
	(encode_event): use skipSTACK instead of popSTACK to avoid a warning
	(xlib_error_handler): make_bool() accept an int, not an object

2007-02-15  Sam Steingold  <sds@gnu.org>

	* modules/clx/mit-clx/dependent.lisp (buffer-input-wait-default):
	SOCKET-STATUS accepts non-integer timeout

2007-02-15  Mattias Nilsson  <mattiasn@bredband.net>
	Sam Steingold  <sds@gnu.org>

	* modules/clx/mit-clx/dependent.lisp (buffer-input-wait-default):
	only check the :input direction

2007-01-05  Evgeny Zubok  <zubok@users.sourceforge.net>
	Sam Steingold  <sds@gnu.org>

	* modules/clx/mit-clx/display.lisp (read-xauth-entry): fixed for McCLIM
	See patch #[ 1628499 ]: McCLIM/mit-clx: fail to connect to X server

2007-02-05  Sam Steingold  <sds@gnu.org>

	* modules/oracle/oracle.lisp, modules/fastcgi/fastcgi.lisp:
	(hex-value): better error reporting
	(hex-byte-value): accept 2 arguments
	(hex-to-byte-array): optimized (less consing, 60% faster)

2007-02-05  Sam Steingold  <sds@gnu.org>

	fixed NO_UNICODE + WIN32_NATIVE (mingw) compilation
	* encoding.d (fehler_incomplete) [!UNICODE]: made available for
	CONVERT-STRING-FROM-BYTES
	* stream.d (rd_ch_keyboard, wr_ch_array_window) [WIN32_NATIVE]:
	fixed cint/chart conversion
	Thanks to Michael Kappert <michael.kappert@gmx.net> for testing

2007-02-03  Sam Steingold  <sds@gnu.org>

	* modules/fastcgi/fastcgi.lisp (byte-array-to-string): optimized

2007-01-22  John Hinsdale <hin@alma.com>

	Allow binary file uploads via FastCGI
	* modules/fastcgi/fastcgi.lisp, fastcgi_wrappers.c: handle binary
	data via STDIN on POST request.  Reported by Mike.Halloran@gmail.com

2007-01-22  Shawn Betts  <sabetts@vcn.bc.ca>
	Sam Steingold  <sds@gnu.org>

	New-CLX supports stumpwm
	* modules/clx/new-clx/clx.f (SET-SELECTION-OWNER): fix argument order
	(encode_event): set the event type; fix STACK handling
	:EVENT-WINDOW is sometimes just a synonym for :WINDOW, sometimes
	not; correctly map :EVENT-WINDOW to the corresponding XEvent slot
	(:REPARENT-NOTIFY): add :OVERRIDE-REDIRECT-P
	(ungrab_X): fix STACK handling
	(xlib_error_handler): pass :ASYNCHRONOUS up
	(XLIB:MAPPING-NOTIFY): implemented
	(travel_queque): used to peek the event and called the event
	handler which meant calling PROCESS-EVENTS inside that event
	handler got the same event (this doesn't happen in mit-clx or
	portable-clx). So travel_queque now just calls XNextEvent()
	* modules/clx/new-clx/clx.lisp (SET-SELECTION-OWNER): export
	implement error conditions (copied from mit-clx)

2007-01-01  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (TheLfloat_) [DEBUG_SPVW]: added

2007-01-10  Sam Steingold  <sds@gnu.org>

	* encoding.d (fehler_buffer_parity): renamed to fehler_incomplete()
	(handle_incomplete): new function
	(uni16be_mbstowcs, uni16le_mbstowcs, uni32be_mbstowcs)
	(uni32le_mbstowcs): use it

2007-01-10  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1632718 ]: CONVERT-STRING-FROM-BYTES does not check
	incomplete byte sequences
	* encoding.d (CONVERT-STRING-FROM-BYTES): signal an error when the
	vector is not used completely

2007-01-10  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1631760 ]: unicode-16 et al cannot be used
	with unbuffered streams
	* encoding.d (uni16be_mbstowcs, uni16le_mbstowcs, uni32be_mbstowcs)
	(uni32le_mbstowcs): signal an error only when at least one char
	was found to enable single byte increments in rd_ch_unbuffered()

2007-01-08  Mike McMahon  <mmcm@users.sourceforge.net>
	Sam Steingold  <sds@podval.org>

	fixed bug #[ 1564818 ]: CRLF handling does not work for UNICODE-16
	* stream.d (strm_channel_extrafields_t): moved ignore_next_LF from ...
	(strm_unbuffered_extrafields_t): ... here
	(ChannelStream_ignore_next_LF): added
	(UnbufferedStream_ignore_next_LF): removed
	(low_clear_input_unbuffered_handle, rd_ch_unbuffered)
	(listen_char_unbuffered, rd_ch_array_unbuffered)
	(make_unbuffered_stream, stream_reset_eltype)
	(SYSTEM::BUILT-IN-STREAM-SET-ELEMENT-TYPE): use
	ChannelStream_ignore_next_LF instead of UnbufferedStream_ignore_next_LF
	(rd_ch_buffered, rd_ch_array_buffered):
	set and test ChannelStream_ignore_next_LF

2007-01-04  Sam Steingold  <sds@podval.org>

	* stream.d (STREAM-EXTERNAL-FORMAT): compare encodings using EQUALP

2007-01-04  Sam Steingold  <sds@podval.org>

	* stream.d (SET-STREAM-EXTERNAL-FORMAT): use check_encoding()
	instead of test_external_format_arg() because the encoding
	is NOT an :EXTERNAL-FORMAT keyword argument

2007-01-03  Sam Steingold  <sds@podval.org>

	* constobj.d (ansi_user_package_name, base10_radixnil)
	(common_lisp_string): removed unused objects
	(modern_user_package): added
	* package.d (init_packages): set it to CS-COMMON-LISP-USER
	* spvw.d (main_actions): use it for *PACKAGE* in -modern

2007-01-02  Sam Steingold  <sds@podval.org>

	* configure (STACK_LIMIT): set to 16384 because of power5, see
	https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=166347

2006-12-24  Bruno Haible  <bruno@clisp.org>

	Make it work with gcc-4.3 snapshots.
	* intparam.c (main1): Rename get_integer_bitsize to
	get_unsigned_integer_bitsize. New macro get_signed_integer_bitsize.
	* lispbibl.d (bit, bitm): Change return type to 'unsigned long' instead
	of 'long'.

2007-01-02  Sam Steingold  <sds@podval.org>

	* hashtabl.d (hashcode_tree_rec): renamed from hashcode_tree
	(hashcode_tree): use it
	(gcinvariant_hashcode_tree_p_rec): renamed from
	gcinvariant_hashcode_tree_p
	(gcinvariant_hashcode_tree_p): use it
	(HASHCODE_TREE_MAX_LEVEL, HASHCODE_TREE_NEED_LEAVES):
	undef after they are no longer used
	(hashcode3, hashcode3stable, hashcode4, sxhash)
	(gcinvariant_hashcode3_p, gcinvariant_hashcode3stable_p)
	(gcinvariant_hashcode4_p): simplified

2006-12-29  Sam Steingold  <sds@podval.org>

	discard macro lambda list when (OPTIMIZE SPACE) is 3
	* init.lisp (sys::maybe-arglist): added
	(defmacro): use it
	* compiler.lisp (compile): ditto
	* record.d (MACRO-LAMBDA-LIST): signal an error when the lambda
	list is not available due to the compiler optimization settings
	* describe.lisp (describe-object@MACRO): call DESCRIBE-ARGLIST
	(describe-arglist): handle possible errors in ARGLIST

2006-12-29  Sam Steingold  <sds@podval.org>

	* backquote.lisp (BACKQUOTE): pass a 2nd argument to MAKE-MACRO
	* compiler.lisp (compile): ditto
	* places.lisp ((setf MACRO-FUNCTION)): ditto
	* trace.lisp (trace1): ditto

2006-12-28  Sam Steingold  <sds@podval.org>

	fixed bug #[ 948868 ]: hashcode[34]_cons weakness
	* hashtabl.d (hashcode_tree, gcinvariant_hashcode_tree_p): added
	(hashcode3_cons0, hashcode3_cons1, hashcode3_cons2, hashcode3_cons3)
	(gcinvariant_hashcode3_cons0_p, gcinvariant_hashcode3_cons1_p)
	(gcinvariant_hashcode3_cons2_p, gcinvariant_hashcode3_cons3_p)
	(hashcode3stable_cons0, hashcode3stable_cons1, hashcode3stable_cons2)
	(hashcode3stable_cons3, gcinvariant_hashcode3stable_cons0_p)
	(gcinvariant_hashcode3stable_cons1_p, hashcode4_cons0)
	(gcinvariant_hashcode3stable_cons2_p, hashcode4_cons1)
	(gcinvariant_hashcode3stable_cons3_p, hashcode4_cons2)
	(hashcode4_cons3, gcinvariant_hashcode4_cons0_p)
	(gcinvariant_hashcode4_cons1_p, gcinvariant_hashcode4_cons2_p)
	(gcinvariant_hashcode4_cons3_p, sxhash_cons0, sxhash_cons1)
	(sxhash_cons2, sxhash_cons3): removed
	(hashcode3, hashcode3stable, hashcode4, sxhash): use hashcode_tree()
	(gcinvariant_hashcode3_p, gcinvariant_hashcode3stable_p)
	(gcinvariant_hashcode4_p): use gcinvariant_hashcode_tree_p()

2006-12-28  Sam Steingold  <sds@podval.org>

	fix bug #[ 1208124 ]: hashcode_bignum weakness
	* hashtabl.d (hashcode_bignum): use all digits

2006-12-27  Sam Steingold  <sds@podval.org>

	ARGLIST now works for macros too
	* constsym.d (macro_lambda_list): added
	* defmacro.lisp (make-macro-expander, make-funmacro-expander):
	pass lambdalist to MAKE-MACRO
	* init.lisp (defun, in-package, the-environment, do, dotimes)
	(defmacro): ditto
	* describe.lisp (describe-object@macro): suggest SYS::MACRO-LAMBDA-LIST
	(arglist): handle macros
	* lispbibl.d (Macro): added slot macro_lambda_list
	* record.d (MAKE-MACRO): accept second argument
	(check_macro): new function
	(MACRO-EXPANDER): use it
	(MACRO-LAMBDA-LIST): added
	* subr.d (make_macro): updated
	(macro_lambda_list): added

2006-12-27  Sam Steingold  <sds@podval.org>

	fixed bug [ 1483762 ]: socket's stream-external-format always :default
	* stream.d (STREAM-EXTERNAL-FORMAT): return :DEFAULT for two-way
	and echo streams only if the external formats of the constituent
	streams are different

2006-12-27  Sam Steingold  <sds@podval.org>

	fixed bug [ 1623179 ]:
	broken (setf (stream-external-format stream direction) enc)
	* places.lisp (stream-external-format): fixed argument handling

2006-12-27  Sam Steingold  <sds@podval.org>

	fix bug #[ 1412454 ]: format/*print-pretty* interaction: extra newlines
	* io.d (pr_enter_1): respect *PPRINT-FIRST-NEWLINE* in all cases

2006-12-27  Sam Steingold  <sds@podval.org>

	fix bug #[ 1482465 ]: confusing format error report, cause fill-stream
	* format.lisp (format-error): use ~T for indentation and ~S to
	print format string so thhat the spacing is preserved
	* constsym.d (stream_start_s_expression, stream_end_s_expression): added
	* io.d (write_spaces): use check_posfixnum
	(FORMAT-TABULATE): use check_posfixnum
	call STREAM-START-S-EXPRESSION and STREAM-END-S-EXPRESSION around
	spaces() to ensure that the spaces are preserved

2006-12-26  Sam Steingold  <sds@podval.org>

	fix bug #[ 1622642 ]: DESCRIBE: confusing spacing
	* fill-out.lisp (with-stream-s-expression): new macro
	* describe.lisp (describe1): use it

2006-12-19  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1618724 ]: broken compiler warning for invalid
	optimize quality
	* compiler.lisp (parse-optimize-quality): fixed the c-warn call

2006-12-18  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1612313 ]: DEFPACKAGE code executed during non
	top-level compilation
	* defpackage.lisp (defpackage): use ANSI situations for EVAL-WHEN

2006-12-17  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-SYMBOL-MACROLET): uniform message syntax:
	"declare SPECIAL"

2006-12-17  Sam Steingold  <sds@gnu.org>

	* init.lisp (date-string): added
	* dribble.lisp (dribble-toggle): use it
	* compiler.lisp (compile-file): ditto

2006-12-17  Sam Steingold  <sds@gnu.org>

	* dribble.lisp (dribble-toggle): open the target file with the
	:EXTERNAL-FORMAT of the source stream
	Reported by Pascal Bourguignon <pjb@informatimago.com>

2006-12-11  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1613300 ]: extra space in unreadable output
	* io.d (pr_unreadably): do not print a space after string when the
	printer is pr_record_ab_00

2006-12-10  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1612859 ]: IMPORT into the KEYWORD package does not
	make a symbol a constant variable
	* error.d (check_symbol_not_symbol_macro)
	(check_symbol_not_global_special): implemented
	* lispbibl.d (check_symbol_not_symbol_macro)
	(check_symbol_not_global_special): declared
	* control.d (PROCLAIM): use check_symbol_not_symbol_macro()
	* macros2.lisp (define-symbol-macro): call
	SYSTEM::%PROCLAIM-SYMBOL-MACRO before SYSTEM::%PUT,
	do not call CHECK-NOT-SPECIAL-VARIABLE-P at all
	(check-not-special-variable-p): obsolete
	* symbol.d (SYS::%PROCLAIM-SYMBOL-MACRO): use
	check_symbol_not_global_special()
	(SYS::%PROCLAIM-CONSTANT): use check_symbol_not_symbol_macro()
	* package.d (make_present): use check_symbol_not_symbol_macro(),
	do not make symbol a constant unless it was uninterned

2006-12-04  Sam Steingold  <sds@podval.org>

	* modules/libsvm: upgraded to upstream 2.83

2006-12-03  Anton Vodonosov  <avodonosov@users.sourceforge.net>
	    Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1607666 ]: LISTEN does not call STREAM-LISTEN
	* io.d (LISTEN): call STREAM-LISTEN
	* constsym.d (STREAM-LISTEN): added

2006-11-28  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1604579 ]: (SETF DOCUMENTATION) and COMPILE
	* record.d (CLOSURE-SET-DOCUMENTATION): allow NIL argument
	* compiler.lisp (compile): reset the documentation in the compiled
	closure because it might have been reset by (setf documentation)
	and is now different from the literal in the lambdabody

2006-11-28  Sam Steingold  <sds@gnu.org>

	* comptran.d (R_R_atanh_R_R): fix IMAGPART sign for real arguments

2006-11-27  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1603260 ]: Loading a compiled file does not reset the
	first value of FUNCTION-LAMBDA-EXPRESSION
	* init.lisp (sys::remove-old-definitions): discard function lambda
	expression too because loading a compiled file does not set it

2006-11-21  Sam Steingold  <sds@podval.org>

	export structure MOP
	* defstruct.lisp (structure-keyword-constructor): renamed from
	structure-kconstructor
	* init.lisp (structure-slots, structure-direct-slots)
	(structure-keyword-constructor, structure-boa-constructors)
	(structure-copier, structure-predicate): export
	* exporting.lisp (export-structure-accessories): the above are now
	external in EXT, not internal in SYS

2006-11-20  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1436987 ]: atanh branch cut strangeness
	* comptran.d (R_R_atanh_R_R): fixed branch cuts logic

2006-11-20  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1469663 ]: clisp-link run does not work w/o dynamic modules
	* clisp-link.in (run): remove $destinationdir before add-module-sets

2006-11-17  Bruno Haible  <bruno@clisp.org>

	fixed bug #[ 1578179 ]: print-read-consistency of strings
	containing #\Return characters
	* io.d (closure_reader): Recognize #0Y"..." syntax.
	(pr_sstring_ab): Write using #0Y"..." syntax if *print-readably* is
	true and the string contains #\Return characters.

2006-11-17  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1483768 ]: automatic pretty-printing of symbols in conses
	fixed bug #[ 1598053 ]: PPRINT dispatch not honored for nested objects
	* io.d (pretty_print_call): removed
	(pr_enter_1): call pr_xxx directly
	(prin_object_ki): abstracted from prin_object and pprin_object
	(prin_object, pprin_object): use prin_object_ki
	(prin_object_dispatch_low): renamed from prin_object_dispatch
	(prin_object_dispatch_pretty): converted from pretty_print_call
	(prin_object_dispatch): call either of the above

2006-11-13  Magnus Henoch  <mange@freemail.hu>
	    Sam Steingold  <sds@gnu.org>

	* modules/clx/mit-clx/clx.lisp (*protocol-families*): Add :internet6.
	* modules/clx/mit-clx/display.lisp (read-xauth-entry): Likewise.

2006-11-13  Sam Steingold  <sds@gnu.org>

	* modules/fastcgi/fastcgi.h: removed unused file

2006-11-13  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1595700 ]: bad base64 error report
	* encoding.d (base64_wcstombs): do not access invalid memory

2006-11-11  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1575569 ]: utf-8 conversion error
	* encoding.d (utf8_wcslen): support up to 4 bytes/character.

2006-11-12  Sam Steingold  <sds@gnu.org>

	* io.d (pr_unreadably): new function (similar to old pr_other_obj)
	(pr_unreadably_2, pr_record_ab_00): added
	(pr_hex6_obj, pr_other_obj): removed
	(pr_machine, pr_system): use pr_unreadably instead of pr_hex6_obj
	(pr_orecord) [Rectype_Readtable]: use pr_unreadably instead of
	pr_hex6_obj
	[Rectype_Byte, Rectype_Symbolmacro, Rectype_GlobalSymbolmacro]:
	[Rectype_Macro, Rectype_FunctionMacro, Rectype_Weakpointer]:
	[Rectype_WeakAnd, Rectype_WeakOr]:
	use pr_unreadably instead of inline code
	[Rectype_Weakmapping, Rectype_WeakAndMapping, Rectype_WeakOrMapping]:
	use pr_unreadably_2 instead of inline code
	(pr_subr, pr_fsubr, pr_cclosure): use pr_unreadably instead of
	pr_other_obj

2006-11-09  Bruno Haible  <bruno@clisp.org>

	fixed bug #[ 1591671 ]: typep and subtypep fail ...
	* subtypep.lisp (indefinite-subclassp): New function.
	(STANDARD-OBJECT): Use it.

2006-11-09  Jörg Höhle  <hoehle@users.sourceforge.net>

	* stream.d (finish_tty_output) [UNIX]: try fsync(), tcdrain() or
	ioctl() until success, not all of them.

2006-11-08  Sam Steingold  <sds@gnu.org>

	* spvw.d (print_banner): print version and instructions on getting help
	* reploop.lisp (commands0): tweak help message

2006-11-08  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1589311 ]: ROUND is broken for long floats [even+1/2]
	* lfloat.d (LF_fround_LF): adjust mask when rounding to match comments

2006-11-06  Sam Steingold  <sds@podval.org>

	* io.d (read_vector_length_check): extracted the common part of
	BIT-VECTOR-READER and VECTOR-READER
	(BIT-VECTOR-READER, VECTOR-READER): use it

2006-11-04  José H. Espinosa  <jose.h.espinosa@gmail.com>
	    Sam Steingold  <sds@gnu.org>

	* makemake.in (XCC_CREATESHARED) [darwin]: define

2006-11-01  Sam Steingold  <sds@gnu.org>

	* modules/gtk2/gtk.lisp (glade-load): added
	(run-glade-file, gui-from-file): use it

2006-10-26  Sam Steingold  <sds@gnu.org>

	* modules/gtk2/gtk.lisp (GladeXMLConnectFunc, GladeNewFunc)
	(GladeXMLCustomWidgetHandler, GladeBuildChildrenFunc)
	(GladeFindInternalChildFunc, GladeApplyCustomPropFunc):
	no need for C-POINTER indirection
	(gui-from-file): call glade_xml_signal_autoconnect_full

2006-10-22  Sam Steingold  <sds@gnu.org>

	* threads.lisp (process-unlock): fixed TEXT call
	(yes-or-no-p-timeout): added
	* xthread.d: "extern inline" --> "static inline"

2006-10-21  "José H. Espinosa"  <jose.h.espinosa@gmail.com>
	    Sam Steingold  <sds@gnu.org>

	* makemake.in (MODULE_CPPFLAGS) [with_dynamic_modules]:
	remove a spurious space that caused
	"error: `CPPFLAGS' has changed since the previous run"

2006-10-19  Sam Steingold  <sds@podval.org>

	* makemake.in (docdir) [redhat]: replaced CLISP_VERSION with TOPDIR
	(VERSION, VERSION_SUFFIX, TOPDIR): moved up to the configurable section
	(lisplibdir): append TOPDIR to enable multiple CLISP version
	installed on the same system simultaneously
	Suggested by Nelson H. F. Beebe <beebe@math.utah.edu>

2006-10-18  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/fastcgi/fastcgi.lisp (FASTCGI:GETENV): can be called
	outside server loop.

2006-10-17  Sam Steingold  <sds@gnu.org>

	* configure (--install): when ${prefix} or ${exec_prefix} are not
	writable, run "make install" using su

2006-10-16  Sam Steingold  <sds@gnu.org>

	* modules/bindings/win32/win32.lisp: use default-foreign-library

2006-10-16  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp (finalize-model): accept an optional
	pointer arg
	(train): make model depend on problem so that problem cannot be
	GCed unless the model is GCed
	(make-problem): finalize the problem with destroy-problem

2006-10-16  Jörg Höhle  <hoehle@users.sourceforge.net>

	* eval.d (get_closure): regularize nearly duplicate gettext message
	* po/de.po, po/fr.po: fixed several tilde format errors and
	translations.  Many translations still erroneous or missing.

2006-10-16  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (src--distrib, doc--distrib): removed
	(tp-mail): add target to send a note to translation@IRO.UMontreal.CA

2006-10-16  Sam Steingold  <sds@gnu.org>

	module doc&interface unification
	* modules/i18n/i18n.lisp: do not lock
	CUSTOM:*SYSTEM-PACKAGE-LIST*, it is done by EXT:SAVEINITMEM
	* modules/matlab/matlab.lisp: add :MATLAB to *FEATURES*,
	add "MATLAB" to CUSTOM:*SYSTEM-PACKAGE-LIST*
	* modules/netica/netica.lisp: add :NETICA to *FEATURES*,
	add "NETICA" to CUSTOM:*SYSTEM-PACKAGE-LIST*
	* modules/zlib/zlib.lisp: do not lock "ZLIB",
	it is done by EXT:SAVEINITMEM

2006-10-15  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (MODULES): added gtk2
	* modules/gtk2: new module based on http://dgym.homeunix.net/clisp-gtk2/

2006-10-13  Sam Steingold  <sds@gnu.org>

	* version.sh: clisp 2.41 release (Friday the 13th!)

2006-10-13  Sam Steingold  <sds@gnu.org>

	* init.lisp, compiler.lisp: replaced
	FFI::*DEFAULT-FOREIGN-LIBRARY* with FFI::*FOREIGN-LIBRARY*
	* foreign1.lisp (DEFAULT-FOREIGN-LIBRARY): new macro, set
	FFI::*FOREIGN-LIBRARY* inside EVAL-WHEN

2006-10-13  Sam Steingold  <sds@gnu.org>

	* modules/pcre/cpcre.c (fullinfo_firsttable): avoid a gcc warning

2006-10-13  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (DEF-C-VAR, DEF-CALL-OUT): call NOTE-C-VAR and
	NOTE-C-FUN depending on the value of library at run time, not
	macroexpansion time

2006-10-13  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/Makefile (svm.so): pass -fPIC to $(CXX)

2006-10-12  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1575946 ]: broken COMPILE of APPLY in LABELS
	* compiler.lisp (c-APPLY): handle not-yet compiled local functions

2006-10-12  Sam Steingold  <sds@podval.org>

	* foreign1.lisp (*default-foreign-library*): defvar and export
	(get-assoc): new helper
	(DEF-C-VAR, DEF-CALL-OUT): use *DEFAULT-FOREIGN-LIBRARY* as the
	default :LIBRARY argument
	* compiler.lisp (with-compilation-unit): bind *DEFAULT-FOREIGN-LIBRARY*
	* init.lisp (*default-foreign-library*): init & proclaim special
	(load): bind *DEFAULT-FOREIGN-LIBRARY*
	* modules/libsvm/libsvm.lisp: set *DEFAULT-FOREIGN-LIBRARY* at top-level
	instead of passing (:LIBRARY ...) to each DEF-CALL-OUT

2006-10-12  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/fastcgi/fastcgi.lisp, fastcgi_wrappers.c (fcgi_env):
	Fix memory leak via :malloc-free allocation, check malloc(),
	untabify, reindent, small Lisp and C tweaks.

2006-10-12  Sam Steingold  <sds@gnu.org>

	* configure.in: call AC_CONFIG_AUX_DIR, AC_PROG_LIBTOOL,
	AC_LIBTOOL_WIN32_DLL

2006-10-12  Sam Steingold  <sds@gnu.org>

	* libcharset/build-aux/config.guess, libcharset/build-aux/config.sub:
	* libcharset/build-aux/install-sh, libcharset/build-aux/ltmain.sh:
	* ffcall/build-aux/config.guess, ffcall/build-aux/config.sub:
	* ffcall/build-aux/ltmain.sh, m4/libtool.m4: updated
	* build-aux/config.dynamic: replaced with ...
	* build-aux/ltmain.sh: added

2006-10-11  Sam Steingold  <sds@podval.org>

	fixed FFI callbacks, broken since the 2005-10-02 patch
	* lispbibl.d (mallocing, nomalloc): declare for clisp.h
	* foreign.d (mallocing, nomalloc): declare global
	(converter_malloc_t): remove one level of indirection
	* foreign1.lisp (convert-to-foreign-C, note-c-call-in): output
	convert_to_foreign() with the appropriate 4th argument

2006-10-10  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp (predict-probability): prob_estimates
	is a DOUBLE-FLOAT vector, not an INT one

2006-10-10  Sam Steingold  <sds@gnu.org>

	* _clisp.c (main): fixed handling of "--" option terminator
	Reported by François-René ÐVB Rideau <fahree@gmail.com>

2006-10-10  Sam Steingold  <sds@podval.org>

	* clhs.lisp (start-mesasge): helper extracted from read-from-file
	(read-from-file): use it
	* modules/libsvm/libsvm.lisp (load-problem, save-problem): ditto

2006-10-09  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp (problem-y-n, problem-x-n): added
	(problem-list, problem-slots): removed
	(cross-validation): call `check-parameter'

2006-10-09  John Hinsdale  <hin@alma.com>

	* modules/fastcgi/fastcgi.lisp, fastcgi_wrappers.c, fastcgi.h:
	New function FASTCGI:ENV to return the entire environment
	Useful enhancement, suggested by Don Cohen

	* modules/fastcgi/fastcgi.lisp:
	Compatible behavior to EXT:GETENV, behaving appropriately
	based on "true CGI" vs. "FastCGI" mode.

2006-10-08  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp (problem-slots, problem-list): added
	(problem-l, problem-y, problem-x): use `problem-slots'
	(save-problem): use `problem-list'

2006-10-05  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp: use C-POINTER instead of C-PTR to
	avoid needless conversions between Lisp and C
	(destroy-parameter, destroy-problem): pass :FULL T to FOREIGN-FREE
	to match ALLOCATE-DEEP
	(finalize-model): new function, use SET-FOREIGN-POINTER to avoid
	the "invalidating session pointer" error
	Suggested by Jörg Höhle

2006-10-05  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (gnu-distrib): use basename to strip off
	../archives/<VER>/
	(GPG): --yes, not -yes

2006-10-05  Sam Steingold  <sds@podval.org>

	merged LOOKUP-FOREIGN-FUNCTION & FOREIGN-LIBRARY-FUNCTION into
	FIND-FOREIGN-FUNCTION; LOOKUP-FOREIGN-VARIABLE &
	FOREIGN-LIBRARY-VARIABLE into FIND-FOREIGN-VARIABLE
	* foreign.d (check_foreign_function_type): new function
	(FOREIGN-FUNCTION): use it
	(lookup_foreign_variable): extracted from LOOKUP-FOREIGN-VARIABLE
	(LOOKUP-FOREIGN-VARIABLE): use it (kept as legacy to avoid
	changing O(version))
	(FIND-FOREIGN-VARIABLE): new function, calls either
	lookup_foreign_variable or foreign_library_variable
	(lookup_foreign_function): extracted from LOOKUP-FOREIGN-FUNCTION
	(LOOKUP-FOREIGN-FUNCTION): use it (kept as legacy to avoid
	changing O(version))
	(FIND-FOREIGN-FUNCTION): new function, calls either
	lookup_foreign_function or foreign_library_function
	(find_library_by_name): renamed from find_library
	(find_library_by_address): new function
	(check_library): rewrote to absorb most of FOREIGN-LIBRARY
	(FOREIGN-LIBRARY): use it
	(foreign_library_check, push_foreign_library_object): new helpers
	(foreign_library_variable): extracted from FOREIGN-LIBRARY-VARIABLE,
	signal an error on platforms without dlsym
	(FOREIGN-LIBRARY-VARIABLE): use it (kept as legacy to avoid
	changing O(version))
	(foreign_library_function): extracted from FOREIGN-LIBRARY-FUNCTION,
	signal an error on platforms without dlsym
	(FOREIGN-LIBRARY-FUNCTION): use it (kept as legacy to avoid
	changing O(version))
	* foreign1.lisp (DEF-C-VAR): use FIND-FOREIGN-VARIABLE instead of
	FOREIGN-LIBRARY-VARIABLE and LOOKUP-FOREIGN-VARIABLE
	(DEF-CALL-OUT, DEF-LIB-CALL-OUT): use FIND-FOREIGN-FUNCTION
	instead of FOREIGN-LIBRARY-FUNCTION and LOOKUP-FOREIGN-FUNCTION
	* constsym.d, subr.d (find_foreign_variable)
	(find_foreign_function): added

2006-10-03  Sam Steingold  <sds@gnu.org>

	* modules/libsvm: new module to interface to LibSVM
	http://www.csie.ntu.edu.tw/~cjlin/libsvm

2006-10-03  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1569234 ]: on some platforms SUBR is not a record
	* documentation.lisp (function-documentation)
	(set-function-documentation): do not fallthrough on subr

2006-10-01  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (release): new target
	(gnu-distrib): pass --use-agent -yes to gpg

2006-09-23  Sam Steingold  <sds@podval.org>

	* version.sh: clisp 2.40 release

2006-10-01  Sam Steingold  <sds@gnu.org>

	* makemake.in (hln): do NOT use $(SHELL) and --cache-file=../config.cache
	to avoid error "`CFLAGS' has changed since the previous run" (this
	reverts the 2006-07-17 patch)

2006-10-01  Sam Steingold  <sds@gnu.org>

	* documentation.lisp (function-documentation)
	(set-function-documentation): handle FSUBR

2006-09-29  Sam Steingold  <sds@podval.org>

	* sequence.d (end_minus_start): new function
	(seq_filterop, remove_op, delete_op, seq_duplicates)
	(substitute_op): use it

2006-09-28  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1567186 ]: set-difference ... :test 'equalp
	* defs1.lisp (list-to-ht): there is no separate fasthash &
	stablehash for EQUALP

2006-09-27  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1566466 ]: assoc error when combining compiled and
	interpreted code
	* compiler.lisp (declared-optimize): do not use ASSOC because a
	combination of interpreted and compiled code - e.g., via
	the (COMPILE) declaration - will break since the declarations in
	the interpreted code are not canonicalized

2006-09-26  Sam Steingold  <sds@podval.org>

	* spvw.d (init_symbol_functions): fix g++ compilation
	* record.d (CLOSURE-DOCUMENTATION, CLOSURE-LAMBDA-LIST): ditto
	* modules/pcre/cpcre.c (PCRE:PCRE-EXEC): ditto
	* lispbibl.d (chart, as_chart): ditto, as recommended by
	http://groups.google.com/group/comp.lang.c++/msg/a81d13be2aa78176

2006-09-22  Jörg Höhle  <hoehle@users.sourceforge.net>

	* stream.d (publish_host_data): do-not-resolve-p in
	SOCKET-STREAM-PEER and SOCKET-STREAM-LOCAL behaves again as
	documented, like prior to inversion introduced 2005-12-14.

2006-09-19  Sam Steingold  <sds@podval.org>

	* foreign.d (convert_from_foreign, convert_to_foreign):
	check data==NULL and issue an error instead of a segfault

2006-09-15  Sam Steingold  <sds@podval.org>

	more meaningful error message on top-level READ with a non-NIL
	recursive-p argument
	* io.d (check_read_reference_table): new function
	(make_references, lookup_label): use it

2006-09-10  Sam Steingold  <sds@podval.org>

	* modules/rawsock/configure.in (net/if.h): need <sys/types.h> on *BSD
	* modules/rawsock/rawsock.c (RAWSOCK:IFADDRS): also require <net/if.h>
	(check_iff): added *BSD macros

2006-09-10  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1555096 ]: cannot create pathnames with :wild-inferiors
	* pathname.d (PARSE-NAMESTRING) [WIN32_NATIVE]: when converting
	/cygdrive/c to C: check that the first directory component is a string
	Thanks to Yaroslav Kavenchuk <kavenchuk@tut.by> for debugging

2006-09-09  Sam Steingold  <sds@podval.org>

	* modules/rawsock/rawsock.c (sockaddr_to_lisp): added
	(RAWSOCK:IFADDRS): implemented
	* modules/rawsock/sock.lisp (ifaddrs): added defstruct

2006-09-09  Sam Steingold  <sds@podval.org>

	* io.d (fehler_invalid_value): new function
	(make_references, lookup_label, circle_p): use it

2006-09-07  Sam Steingold  <sds@podval.org>

	* modules/rawsock/sock.lisp (open-unix-socket, open-unix-socket-stream):
	export; fixed socket calls (:AF_UNIX -> :UNIX, :SOCK_STREAM -> :STREAM)

2006-09-07  Sam Steingold  <sds@podval.org>

	* foreign.d (FOREIGN-LIBRARY-FUNCTION): fixed last patch
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>

2006-09-05  Sam Steingold  <sds@podval.org>

	* modules/rawsock/rawsock.c (RAWSOCK:IF-NAME-INDEX): new function

2006-09-03  Sam Steingold  <sds@podval.org>

	When the OPTIMIZE SPACE level is low enough, keep function
	documentation and lambda list.
	* compiler.lisp (make-closure): accept documentation and pass it
	on to SYS::%MAKE-CLOSURE
	(parse-optimize-quality): do not support interpreted code (reverses
	the 2005-02-11 patch)
	(fnode): added slots LAMBDA-LIST and DOCUMENTATION
	(c-LAMBDABODY): fill them
	(create-fun-obj): pass them to MAKE-CLOSURE when the OPTIMIZE
	SPACE level is right, using...
	(non-user-symbol-p, generatedp): new functions
	... to avoid wasting space for gensyms and lambdas
	* constobj.d (version): bump
	* constsym.d (closure_documentation, closure_set_documentation)
	(closure_lambda_list): added
	* describe.lisp (describe-object@FUNCTION): use
	DESCRIBE-ARGLIST and DESCRIBE-DOCUMENTATION
	(arglist): use SYS::CLOSURE-LAMBDA-LIST
	(describe-arglist, describe-documentation): added
	(describe-signature): removed
	* documentation.lisp (function-documentation): use
	SYS::CLOSURE-DOCUMENTATION and Foreign-Function properties
	(documentation@symbol): use it
	(set-function-documentation): use SYS::CLOSURE-SET-DOCUMENTATION
	and Foreign-Function properties
	((setf documentation)@symbol): use it
	* eval.d (parse_dd): do not call NOTE-OPTIMIZE (reverses the
	2005-02-11 patch) because local DECLARE should not change the
	global OPTIMIZE settings
	* foreign.d (LOOKUP-FOREIGN-FUNCTION, FOREIGN-LIBRARY-FUNCTION):
	accept an additional PROPERTIES argument
	* foreign1.lisp (DEF-CALL-OUT): pass PROPERTIES to
	LOOKUP-FOREIGN-FUNCTION and FOREIGN-LIBRARY-FUNCTION,
	do not call (SETF DOCUMENTATION)
	* init.lisp (defmacro, defun): do not call SYSTEM::%SET-DOCUMENTATION
	* io.d (CLOSURE-READER): consts is a list, expect optional
	LAMBDA-LIST and DOCUMENTATION
	(pr_cclosure_lang): print consts as a list,
	also print LAMBDA-LIST and DOCUMENTATION, if any
	* lispbibl.d (Ffunction): added ff_properties slot
	(Cclosure_last_const, ccv_flags_lambda_list_p)
	(ccv_flags_documentation_p): new CPP macros: use bit(2) as an
	indicator for DOCUMENTATION and bit(1) for LAMBDA-LIST
	* record.d (CLOSURE-CONSTS): use them to keep DOCUMENTATION
	and LAMBDA-LIST separate from consts
	(%MAKE-CLOSURE): accept LAMBDA-LIST and DOCUMENTATION
	(MAKE-CONSTANT-INITFUNCTION): pass 6 arguments to %MAKE-CLOSURE
	(CLOSURE-DOCUMENTATION, CLOSURE-SET-DOCUMENTATION)
	(CLOSURE-LAMBDA-LIST): implemented
	* spvw_debug.d (TheCclosure_, Cclosure_length_): added
	* subr.d (make_closure, lookup_foreign_function)
	(foreign_library_function): updated
	(closure_documentation, closure_set_documentation)
	(closure_lambda_list): added

2006-09-03  Sam Steingold  <sds@podval.org>

	* configure: accept FOO=BAR argument to set the shell variable

2006-09-03  Stephen Compall  <s11001001@users.sourceforge.net>
	Sam Steingold  <sds@podval.org>

	fixed bug #[ 1550803 ]: make-pathname ignores explicit :DIRECTORY NIL
	* pathname.d (merge_dirs, MERGE-PATHNAMES): :DIRECTORY NIL
	overrides :DEFAULTS

2006-09-03  Magnus Henoch  <mange@freemail.hu>
	Sam Steingold  <sds@podval.org>

	* ffcall/callback/trampoline_r/proto.c,
	* ffcall/callback/vacall_r/vacall-powerpc.c (env) [__NetBSD__]:
	use r13 instead of r11
	* ffcall/callback/vacall_r/Makefile.in (vacall-powerpc.lo): depend
	on vacall-powerpc-netbsd.s
	* ffcall/callback/vacall_r/vacall-powerpc-netbsd.s: added

2006-08-24  Sam Steingold  <sds@podval.org>

	* clhs.lisp (*browsers*): added :FIREFOX, :FIREFOX-WINDOW, :FIREFOX-TAB,
	:NETSCAPE-TAB, :MOZILLA-TAB; renamed :NETSCAPE-REMOTE and
	:MOZILLA-REMOTE to :NETSCAPE-WINDOW and :MOZILLA-WINDOW respectively

2006-08-15  Sam Steingold  <sds@podval.org>

	* Makefile.devel (update-docbook-utils): delegate to doc/Makefile

2006-08-15  Sam Steingold  <sds@podval.org>

	support case-sensitive packages
	* modprep.lisp (*package-properties*): new parameter
	(defmodule-p): accept module properties as the 3rd argument
	(case-sensitive-package-p): new function
	(string-upcase-verbose): use it

2006-08-10  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1538333 ]: ADJUST-ARRAY on non-adjustable vectors
	without a fill pointer
	* array.d (fehler_no_fillp): new function
	(get_fill_pointer): use it
	(ADJUST-ARRAY): use it to signal an error instead of creating a new
	array with fill pointer from an array without one

2006-08-10  Sam Steingold  <sds@podval.org>

	support PCREv6 pcre_dfa_exec()
	* modules/pcre/cpcre.c (pcre_error): handle DFA errors
	(pcre_exec_flags): handle DFA flags
	(PCRE-EXEC): accept :WORK-SPACE :DFA :PARTIAL :DFA-SHORTEST :DFA-RESTART
	when pcre_exec returns 0, retry with doubled ovector_size
	* modules/pcre/configure.in: check for pcre_dfa_exec

2006-08-01  Sam Steingold  <sds@podval.org>

	* makemake.in (XCFLAGS) [ia64]: no special treatment is necessary
	anymore, according to Dr. Werner Fink <werner@suse.de> in
	<http://article.gmane.org/gmane.lisp.clisp.general:11358>

2006-08-01  Sam Steingold  <sds@podval.org>

	* spvw_memfile.d (loadmem_from_handle): avoid a GCC warning

2006-08-01  John Hinsdale  <hin@alma.com>

	* modules/oracle/oracle.lisp:  Fix incorrect loop termination and
	premature advancing of database cursor in ORACLE:FETCH-ALL
	Thanks to Feng Hou <houfen@gmail.com> for report, test case and fix.

2006-07-31  Sam Steingold  <sds@podval.org>

	* modules/berkeley-db/bdb.c (asciz_to_string0): turn into a CPP macro
	this fixes the NO_UNICODE build (the encoding argument is not evaluated)
	Reported by Reini Urban <rurban@x-ray.at>

2006-07-31  Sam Steingold  <sds@podval.org>

	* spvw.d (find_name): reorder conditionals for WIN32_NATIVE
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>

2006-07-27  Sam Steingold  <sds@podval.org>

	fix bug #[ 1482533 ]: print-object built-in object: no-applicable-method
	* clos-print.lisp (print-object): added a method for built-in objects

2006-07-27  Sam Steingold  <sds@podval.org>

	* modules/rawsock/rawsock.c (RAWSOCK:CONVERT-ADDRESS): made restartable

2006-07-26  Sam Steingold  <sds@podval.org>

	fix bug #[ 1529244 ]: rawsock is broken on big-endian
	* socket.d (resolve_host): use UI_to_LEbytes() instead of I_to_uint32()
	for uint32 argument so that it will work on big-endian machines
	* modules/rawsock/rawsock.c (RAWSOCK:CONVERT-ADDRESS): ditto

2006-07-26  Sam Steingold  <sds@podval.org>

	* configure, makemake.in: accept --elispdir and install emacs
	files there (datadir/emacs/site-lisp/ by default)

2006-07-25  Sam Steingold  <sds@podval.org>

	* configure: when CONFIG_SHELL is bash and /bin/sh is not, re-exec the
	configure script with CONFIG_SHELL to enable sourcing of config.cache

2006-07-25  Dr. Werner Fink  <werner@suse.de>
	Sam Steingold  <sds@podval.org>

	fix executable images on ia64
	* spvw_memfile.d (loadmem_from_handle): when mem_searched, call
	set_file_offset(mem_start), not set_file_offset(0)

2006-07-25  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1526448 ]: Reinitialization of class does not call
	finalize-inheritance
	* clos-class3.lisp (reinitialize-instance-<defined-class>): call
	FINALIZE-INHERITANCE
	* gray.lisp (fundamental-stream): bind CLOS::*ALLOW-MIXING-METACLASSES*
	also with EXT:COMPILER-LET; remove EVAL-WHEN

2006-07-25  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1528201 ]: sigsegv: make-instance of named anonymous class
	* clos-package.lisp: import sys::check-symbol
	* clos-class1.lisp (shared-initialize-<potential-class>): use it

2006-07-24  Sam Steingold  <sds@podval.org>

	* spvw.d (find_name) [!RTLD_DEFAULT]: emulate RTLD_DEFAULT
	whenever it is not defined (e.g., on AIX in addition to FreeBSD)
	(libc_handle): defined at static inside find_name()
	Reported by Nirendra Maharaj <nirendram@fastmail.fm>

2006-07-23  Sam Steingold  <sds@podval.org>

	* modules/syscalls/calls.c (POSIX::USER-INFO):
	use S(Kdefault) instead of `:DEFAULT`

2006-07-21  Sam Steingold  <sds@podval.org>

	* modules/syscalls/calls.c (POSIX::STAT-VFS): require
	HAVE_SYS_STATVFS_H in addition to HAVE_STATVFS

2006-07-20  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1516684 ]: initially not executed in loop
	* loop.lisp (loop-initialization): new slot preamble
	(revadd): new macro
	(expand-loop): merge INITIALLY-CODE and STARTUP-CODE into a single
	annotated list PREAMBLE (elements are marked on whether they come
	from :INITIALLY or :START) - this ensures that the initialization
	and :INITIALLY forms are evaluated in the right order

2006-07-19  Sam Steingold  <sds@podval.org>

	* makemake.in (encflags): make -E 1:1 the first argument to ensure
	that no encoding variable is ever left as ASCII (the default for
	the C locale)

2006-07-19  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1494059 ]: open-url fails to recognize file:/// (unix)
	* clhs.lisp (open-url): restore the leading #\/ on unix
	[win32|cygwin]: try the version without the leading #\/ first

2006-07-17  Sam Steingold  <sds@podval.org>

	* makemake.in (hln): use $(SHELL) and --cache-file=../config.cache

2006-07-17  Sam Steingold  <sds@podval.org>

	* Makefile.devel (REL, GNU_SYM): new variables
	(upload): also upload symlink directive
	(gnu-distrib): also create symlink directive
	(tag-release): new target

2006-07-16  Sam Steingold  <sds@podval.org>

	* version.sh: clisp 2.39 release

2006-07-14  Thiemo Seufer  <ica2_ts@csv.ica.uni-stuttgart.de>
	Sam Steingold  <sds@podval.org>

	* m4/general.m4 (CL_CANONICAL_HOST_CPU_FOR_FFCALL):
	re-enable FFI for mips/mipsel
	http://article.gmane.org/gmane.lisp.cl-debian/1493

2006-07-14  Peter Van Eynde  <pvaneynd@debian.org>
	Sam Steingold  <sds@podval.org>

	fixed bug #[ 1506857 ]: build fails with gcc-4.1 on ia64
	* makemake.in (XCFLAGS) [ia64]: -O0, not -O2

2006-06-30  Sam Steingold  <sds@podval.org>

	* modules/syscalls/posix.lisp (ffs): added a Lisp implementation of
	http://www.opengroup.org/onlinepubs/009695399/functions/ffs.html

2006-06-30  Sam Steingold  <sds@podval.org>

	* configure, makemake.in: accept --with-gmalloc
	* configure.in: do not call CL_GMALLOC
	* m4/gmalloc.m4: removed
	* malloc/getpagesize.h, malloc/gmalloc.c: updated from Emacs

2006-06-30  Sam Steingold  <sds@podval.org>

	* makemake.in (anymodule): use $(SHELL) to run sub-configure scripts

2006-06-29  Sam Steingold  <sds@podval.org>

	use symbolic error codes when possible
	* modules/berkeley-db/bdb.c (bdb_errno): new checker
	* modules/berkeley-db/dbi.lisp (bdb-error): renamed "number" to "code"

2006-06-29  Sam Steingold  <sds@podval.org>

	* modules/rawsock/sock.lisp: import EXPORTING:DEFINE-CONDITION

2006-06-29  Sam Steingold  <sds@podval.org>

	* modules/berkeley-db/bdb.c (BDB:DBC-GET): fixed last patch -
	accept :READ-COMMITTED and :READ-UNCOMMITTED

2006-06-29  Sam Steingold  <sds@podval.org>

	use gai_strerror() to signal errors in getaddrinfo() and getnameinfo()
	* modules/rawsock/rawsock.c (error_eai): new function
	(RAWSOCK::GETNAMEINFO, RAWSOCK::GETADDRINFO): use it
	* modules/rawsock/sock.lisp (eai): new condition type
	* modules/rawsock/configure.in: check for gai_strerror()

2006-06-29  Sam Steingold  <sds@podval.org>

	* modules/syscalls/calls.c (POSIX::GROUP-INFO, POSIX::USER-INFO):
	set errno to 0 before system calls to separate errors from "not found"

2006-06-27  Sam Steingold  <sds@podval.org>

	* m4/test.m4: use sub-shell "()" instead of "eval" (needed on Solaris)

2006-06-27  Sam Steingold  <sds@podval.org>

	* m4/bold.m4: from libsigsegv
	* configure.in, modules/berkeley-db/configure.in:
	* modules/clx/new-clx/configure.in, modules/dirkey/configure.in:
	* modules/i18n/configure.in, modules/pari/configure.in:
	* modules/pcre/configure.in, modules/postgresql/configure.in:
	* modules/rawsock/configure.in, modules/readline/configure.in:
	* modules/regexp/configure.in, modules/syscalls/configure.in:
	* modules/wildcard/configure.in, modules/zlib/configure.in:
	use BOLD_MSG instead of AC_MSG_NOTICE

2006-06-23  Sam Steingold  <sds@podval.org>

	* modules/syscalls/calls.c (POSIX::PATHCONF): new function

2006-06-21  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1426388 ]: rawsock :end vs. :size confusion
	* charstrg.d (test_vector_limits): no return value, remove just 2
	STACK elements: :START and :END (not vector)
	(test_string_limits_ro): adjusted the call to test_vector_limits()
	* encoding.d (CONVERT-STRING-TO-BYTES): ditto
	* lispbibl.d (test_vector_limits): updated prototype
	(stringarg, test_vector_limits): export to clisp.h
	* modules/rawsock/rawsock.c (parse_buffer_arg, check_iovec_arg):
	use test_vector_limits()
	updated their callers because now parse_buffer_arg() and
	check_iovec_arg() remove :START and :END from STACK

2006-06-20  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1491252 ]: i18n does not build on cf:alpha
	* utils/modprep.lisp (*tag-length-limit*): new variable
	(init-to-tag): use it to limit the size of C identifiers

2006-06-19  Sam Steingold  <sds@podval.org>

	* makemake.in (CLISP_VERSION): removed, TOPDIR is used instead
	(VERSION_SUFFIX): new user variable for custom distributions

2006-06-19  John Hinsdale <hin@alma.com>

	* modules/oracle/orafns.c: call OCILogoff so as to not leak connections
	Thanks to Feng Hou <houfen@gmail.com> for report and patch.

2006-06-18  Peter Van Eynde  <pvaneynd@debian.org>
	Sam Steingold  <sds@podval.org>

	fixed bug #[ 1507628 ]: #define unused (void) breaks clisp 2.38 on arm
	* modules/syscalls/calls.c (unused): undefine before #include <signal.h>

2006-06-15  Sam Steingold  <sds@podval.org>

	* m4/test.m4: redirect test output to log, not /dev/null

2006-06-15  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1407763 ]: (disassemble 'car) hangs on openpower-linux1
	* spvw.d (init_symbol_values) [UNIX_LINUX & POWERPC]: set
	SYS::*DISASSEMBLE-USE-LIVE-PROCESS* to NIL

2006-06-14  Sam Steingold  <sds@podval.org>

	fixed bug #[ 1497226 ]: clisp/src/m4/x11.m4 fails to detect x11 on FC5
	* m4/x11.m4: removed
	* configure.in, makemake.in, modules/clx/new-clx/Makefile.in:
	* modules/clx/new-clx/configure.in, modules/clx/new-clx/link.sh.in:
	use AC_PATH_XTRA instead of CL_FIND_X
	This reverts parts of the 2005-09-16 patch

2006-06-14  Sam Steingold  <sds@podval.org>

	* foreign1.lisp (ffi-module@constant-table): fixed :value declaration
	(DEF-CALL-OUT): fixed a typo in the 2006-01-30 patch, this fixes
	bug #[ 1483902 ]: build error in ffi modules

2006-06-14  Sam Steingold  <sds@podval.org>

	* modules/bindings/win32/win32.lisp: added clipboard access functions

2006-05-30  John Hinsdale <hin@alma.com>

	* modules/oracle/orafns.c: Support for Oracle 10g date/time types

2006-05-29  Sam Steingold  <sds@podval.org>

	* modules/pari/pari.lisp (pari-nil): removed, gnil not found in pari CVS

2006-05-29  Sam Steingold  <sds@podval.org>

	* modules/syscalls/configure.in: removed CL_LSTAT

2006-05-23  Bruno Haible  <bruno@clisp.org>

	* unix.d (gettimeofday): Remove workaround for Cygwin bug. It was
	fixed on 1997-05-27.

2006-05-20  Bruno Haible  <bruno@clisp.org>

	* lispbibl.d: Treat DragonFly BSD like FreeBSD.
	* asmi386.hh (DECLARE_FUNCTION): Likewise.

2006-05-19  Sam Steingold  <sds@podval.org>

	* list.d (LIST-LENGTH-IN-BOUNDS-P): fixed last fix

2006-05-18  Sam Steingold  <sds@podval.org>

	* stream.d (TERMINAL-RAW) [!KEYBOARD]: fixed compilation

2006-05-17  Sam Steingold  <sds@podval.org>

	* list.d (LIST-LENGTH-IN-BOUNDS-P): fix g++ compilation,
	error was "jump to label 'no' crosses initialization of uintV m"

2006-05-17  Jörg Höhle  <hoehle@users.sourceforge.net>

	Readline completion now works with UTF-8 terminal encoding.
	* stream.d (lisp_completion) [UNICODE]: Convert byte index to
	string index.
	(make_keyboard_stream) [WIN32_NATIVE]: add missing begin_system_call()

2006-05-05  Jörg Höhle  <hoehle@users.sourceforge.net>

	* keyboard.lisp (exec-with-keyboard): Do not rely
	on *terminal-io*, call (terminal-raw *keyboard-input*)
	* stream.d (terminal-raw): Recognize *keyboard-input*.
	Reported by Dave Roberts <dave@vyatta.com>

2006-05-16  Bruno Haible  <bruno@clisp.org>

	* stream.d (finish_tty_output, force_tty_output) [UNIX_CYGWIN]:
	Ignore error EBADRQC.
	Fixes: clisp -norc -x '(sys::exit nil)' > /dev/null

2006-05-16  Bruno Haible  <bruno@clisp.org>

	* unix.d [UNIX_CYGWIN]: Undefine WIN32 after including <windows.h>.
	* lispbibl.d [UNIX_CYGWIN]: Likewise.

2006-05-10  Bruno Haible  <bruno@clisp.org>

	* makemake.in: Respect the value of the environment variable CFLAGS
	given at configure time.

2006-05-07  Bruno Haible  <bruno@clisp.org>

	* spvwtabf.d (subr_tab_data): Align correctly also when using the
	SunPRO C compiler.
	* spvwtabs.d (symbol_tab_data): Likewise.

2006-05-15  Petr Salinger  <Petr.Salinger@t-systems.cz>
	    Jörg Höhle  <hoehle@users.sourceforge.net>

	* makemake.in (XCC_CREATESHARED): Recognize k*bsd* OS type.

2006-05-07  Bruno Haible  <bruno@clisp.org>

	* stream.d (FILE-POSITION): Fix handling of non-empty broadcast-streams
	(bug introduced on 2004-02-15).

2006-05-05  Arseny Slobodyuk  <ampy@users.sourceforge.net>

	* modules/calls.c: do not use IPropertyStorage related
	constants not declared by modern mingw win32 headers.
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>

2006-05-03  Jörg Höhle  <hoehle@users.sourceforge.net>

	* spvw.d (quit): do not duplicate call to done_win32(), leave it
	to fini_lowest_level() alone.

2006-05-02  Jörg Höhle  <hoehle@users.sourceforge.net>

	Must use #if STACKCHECKxyz, not #if defined(STACKCHECKxyz)
	* eval.d (interpret_bytecode_): fix
	* lispbibl.d (with_saved_backtrace): fix
	* record.d (update_instance): fix

2006-04-29  Bruno Haible  <bruno@clisp.org>

	* makemake.in (XCFLAGS): Add -falign-functions=4 not only when
	debugging. But add it only for i386 CPUs.

2006-04-29  Bruno Haible  <bruno@clisp.org>

	* makemake.in (check-doc): Use lynx or curl as fallback when wget
	doesn't exist.

2006-04-29  Arseny Slobodyuk  <ampy@users.sourceforge.net>

	GREAT socket speedup on win32
	* win32aux.d (interruptible_call_event, interruptible_return_event)
	(interruptible_routine, interruptible_arg)
	(interruptible_result): new static variables.
	(DoInterruptible): do not start new thread each time DoInterruptible
	is called. Use events to signal thread started once. Abort thread
	only when Ctrl-C or Ctrl-Break is pressed.
	(temp_interrupt_handler): close event handles as well as thread ones.
	(standbythreadf): "stand-by thread" function.
	(done_win32): terminate thread, close events.

2006-04-28  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/configure.in, modules/pari/configure.in:
	* modules/pcre/configure.in, modules/postgresql/configure.in:
	* modules/zlib/configure.in: add $LIB<mod> to $LIB (not $LTLIB<mod>)
	Reported by Albert Chin <clisp-devel@mlists.thewrittenword.com>
	in message <http://article.gmane.org/gmane.lisp.clisp.devel:15576>

2006-04-26  Jörg Höhle  <hoehle@users.sourceforge.net>

	* spvw_sigsegv.d (stackoverflow_handler) [UNIX]: libsigsegv doc
	says to restore normal signal mask prior to leaving handler.

2006-04-25  Jörg Höhle  <hoehle@users.sourceforge.net>

	Increase memory sizes for builds/tests with fixed memory size.
	* spvw.d (parse_options): default -m 3MB
	* makemake.in (interpreted.mem, halfcompiled.mem): Grant 1800 KW.
	(stage/*.fas): Grant 1000 KW.

2006-04-26  Jörg Höhle  <hoehle@users.sourceforge.net>

	(code-char #\Rubout) has value 127 since at least 1998.
	* constobj.d (charname_127) [WIN32_PATHNAMES]: renamed from
	charname_8bis, value unchanged.

2006-04-26  Jörg Höhle  <hoehle@users.sourceforge.net>

	* charstrg.d (charname_table_codes) [WIN32_PATHNAMES]: Add #\Esc
	as synonym to #\Escape for interoperability.
	* constobj.d (charname_27bis) [WIN32_PATHNAMES]: added
	Suggested by Frank Buss <fb@frank-buss.de>

2006-04-26  Sam Steingold  <sds@gnu.org>

	* modules/pcre/configure.in: fixed a typo
	Reported by Albert Chin <clisp-devel@mlists.thewrittenword.com>

2006-04-26  Bruno Haible  <bruno@clisp.org>

	* build-aux/config.guess, build-aux/config.sub: Update to GNU version
	2006-04-26.

2006-04-21  Jörg Höhle  <hoehle@users.sourceforge.net>

	* spvw_garcol.d (gar_col_normal): delay close_some_files()
	until within gar_col_done().

2006-04-22  Bruno Haible  <bruno@clisp.org>

	* m4/general.m4 (CL_CANONICAL_HOST_CPU): Recognize powerpc64 / powerpc
	and x86_64 / i386 depending on the compiler.
	(CL_CANONICAL_HOST_CPU_FOR_FFCALL): Likewise.

2006-04-21  Bruno Haible  <bruno@clisp.org>

	* clos-class6.lisp ((setf class-valid-initargs-from-slots)): Clear
	caches when the value actually changes.
	Fixes bug #[ 1470929 ], reported by Kim-Minh Kaplan.

2006-04-19  Bruno Haible  <bruno@clisp.org>

	* m4/general.m4 (CL_CANONICAL_HOST_CPU): Map rs6000 -> powerpc,
	not vice versa.
	(CL_CANONICAL_HOST_CPU_FOR_FFCALL): Likewise.
	* m4/ffcall-codeexec.m4 (CL_CODEEXEC): Update.

2006-04-16  Jörg Höhle  <hoehle@users.sourceforge.net>

	* describe.lisp (describe-object@global-symbol-macro):
	complete 2005-01-05.  When adding internal types, please
	update DESCRIBE for it uses ECASE (TYPE-OF x).

2006-03-31  Jörg Höhle  <hoehle@users.sourceforge.net>

	* debug.d (EXT:GC): use uintM_to_I(free_space()), not UL_to_I().

2006-03-19  Jörg Höhle  <hoehle@users.sourceforge.net>

	* xcharin.lisp (fehler-char-arg): fix format string.

2006-04-16  Bruno Haible  <bruno@clisp.org>

	* lispbibl.d (POWERPC): Renamed from RS6000.
	* intlog.d: Update.

2006-04-15  Bruno Haible  <bruno@clisp.org>

	Report circular and dotted lists in macro forms and type specifiers.
	Allow circular and dotted lists in DESTRUCTURING-BIND.
	* list.d (sys::list-length-in-bounds-p,
	sys::proper-list-length-in-bounds-p): New functions.
	* defmacro.lisp (macro-call-error): Provide different error messages
	for the case of a circular or dotted list.
	(%proper-list-p): New special variable.
	(make-length-test): Remove accept-dotted optional argument. Use
	%proper-list-p instead. If %proper-list-p is true, also emit a check
	whether the form is a proper list. If %proper-list-p is false, emit
	code that doesn't traverse the entire list.
	(make-macro-expansion): Bind %proper-list-p to t.
	* macros2.lisp (deftype): Bind %proper-list-p to t.
	* places.lisp (define-setf-expander): Bind %proper-list-p to t.
	* defs2.lisp (destructuring-bind): Bind %proper-list-p to nil.
	(destructing-error): Provide different error message for the case of a
	circular list.

2006-04-14  Bruno Haible  <bruno@clisp.org>

	Fix compiler macro handling.
	* cmacros.lisp (compiler-macro-function, (setf compiler-macro-function)):
	Simplify by use of get-funname-symbol.
	* compiler.lisp (expand-compiler-macro): Call the compiler-macro
	function directly, not through *macroexpand-hook*. Recognize special
	return value NIL.
	(c-form): If expand-compiler-macro did something, just recurse. Fixes
	bug #[ 1420585 ].

2006-04-10  Bruno Haible  <bruno@clisp.org>

	Implement feature request #[ 1415783 ].
	* clos-genfun3.lisp (make-generic-function): Add method-combination-p
	argument. If false, move the :method-combination keyword argument to
	the end.
	(analyze-defgeneric): Return method-combination-p as 5th value.
	(defgeneric): When :method-combination was not specified, move the
	:method-combination keyword argument to the end.
	(make-generic-function-form): Update.

2006-04-10  Bruno Haible  <bruno@clisp.org>

	Complete Sam's 2005-11-21 patch.
	* clos-class3.lisp (defclass): Verify that a slot's :ALLOCATION value
	is a symbol. Don't treat the symbol NIL specially.

2006-04-10  Bruno Haible  <bruno@clisp.org>

	* clos-class1.lisp: Undo read-macro hacks by Sam 2005-11-28.
	* clos-class3.lisp: Likewise.
	* clos-genfun2b.lisp: Likewise.
	* clos-genfun3.lisp: Likewise.
	Maintainability is more important than a few bytes of source code.
	The right place for unifying immutable strings across a file is io.d.

2006-04-10  Bruno Haible  <bruno@clisp.org>

	* clos-genfun3.lisp: Undo a de-internationalization by Sam 2005-11-28.
	Needed for French.

2006-04-10  Bruno Haible  <bruno@clisp.org>

	* Makefile.devel (ANSITESTS_CVS_ROOT): Update after savannah reorg.

2006-03-22  Jörg Höhle  <hoehle@users.sourceforge.net>

	* array.d (ADJUST-ARRAY) [HAVE_SMALL_SSTRING]: Fix bug #[ 1445842 ]
	ADJUST-ARRAY of 0-length adjustable string failed.
	Reported by David Tolpin

2006-03-22  Jörg Höhle  <hoehle@users.sourceforge.net>

	* misc.d (registry) [WIN32_NATIVE]: refix 2000-12-04,
	do not goto outside `with_string_0'.

2006-03-10  Jörg Höhle  <hoehle@users.sourceforge.net>

	* spvw.d (init_memory) [DEBUG_SPVW]: fix stack depth reporting.

2006-03-10  Jörg Höhle  <hoehle@users.sourceforge.net>

	* clhs.lisp: add #+ for documentation of optional packages.

2006-03-06  Bruno Haible  <bruno@clisp.org>

	* backquote.lisp (bq-append): Don't optimize if form1 has the
	shape (QUOTE (SYS::UNQUOTE ...)). Fixes bug #[ 1308444 ].
	Based on proposed fix by Matthew Cross <mcross@irobot.com>.

2006-03-03  Jörg Höhle  <hoehle@users.sourceforge.net>

	gcc-3.3.3 on Sparc64 barfs on ({ var x=y; {var z...; value;}})
	* intlog.d (I_logcount_I): remove superfluous second {} block.
	* arilev0.d (mulu32_64) [SPARC]: ditto.
	Reported by Magnus Henoch <mange@freemail.hu>

2006-03-01  Jörg Höhle  <hoehle@users.sourceforge.net>

	* defs2.lisp (destructuring-bind): Forgotten by 2004-05-23
	patch to allow () to match NIL in destructuring lambda lists.
	%ignored is no more, %null-tests is there.
	Reported by Rob Warnock <rpw3@rpw3.org> and
	Kaz Kylheku <kkylheku@gmail.com>

2006-02-28  Jörg Höhle  <hoehle@users.sourceforge.net>

	* time.d (%%TIME): complete 2004-11-27, use uintM with used_space().
	Reported by Don Cohen that TIME fails when allocated memory
	crosses the 4GB boundary.

2006-02-23  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1399376 ]: Failure of socket tests on Mac OS X
	* socket.d (FILL0): new macro
	(with_host_port, connect_to_x_server, socket_getlocalname_aux)
	(socket_getpeername, create_server_socket_by_socket)
	(accept_connection): use it to zero-out sockaddr before use

2006-02-23  Jörg Höhle  <hoehle@users.sourceforge.net>

	* stream.d (listen_byte_ia8_buffered): use persev_immediate as in
	listen_char_buffered() to avoid hanging on sockets.
	Reported by Don Cohen

2006-02-22  Jörg Höhle  <hoehle@users.sourceforge.net>

	* stream.d (SOCKET-SERVER): revisit 2006-01-25, avoid calling
	create_server_socket_by_string() twice when interface is supplied.
	Reported by Don Cohen

2006-02-21  Jörg Höhle  <hoehle@users.sourceforge.net>

	Check compilation with MSVC6
	* win32aux.d (with_file_id): fixed a typo from 2005-12-18.
	* makemake.in [win32msvc]: for MS shell quoting, use template
	echotab '$(RUN) -x "(print \"hi\")"'
	(libcharset.h) [win32msvc]: complete 2005-07-01 copying
	localcharset.h together with libcharset.h (no new dependency)

2006-02-05  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1388897 ]: FFI:uint64 maps to long long when supported
	* foreign.d [HAVE_LONG_LONG]: use av_start_longlong,
	va_return_longlong etc.  Otherwise, continue to pass a struct of
	two uint32: this is compatible with MSVC's __int64 handling.

2006-02-04  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1421652 ]: CPP macros using "do{}while(0)" do not
	work with statement arguments containing break or continue
	* lisparit.d (check_real_replacement, check_rational_replacement):
	remove break from calls to if_realp(), if_rationalp()

2006-02-04  Jörg Höhle  <hoehle@users.sourceforge.net>

	* foreign.d (foreign-address-unsigned): revisit last patch. Do not
	yet introduce uintP_to_I abstraction, use ulong_to_I() for now.

2006-02-03  Jörg Höhle  <hoehle@users.sourceforge.net>

	* foreign.d (foreign-address-unsigned, unsigned-foreign-address)
	[WIDE]: uintP does not fit into 32 bits, use I_to_UQ/UQ_to_I().
	Reported by James Bielman <jamesjb@jamesjb.com>

2006-02-02  Jörg Höhle  <hoehle@users.sourceforge.net>

	* ffcall/avcall, ffcall/vacall [HAVE_LONG_LONG]: complete switch
	from HAVE_LONGLONG to HAVE_LONG_LONG, bug #[ 1385013 ]
	* foreign.d [_MSC_VER]: Incidentally, this prevents
	#undef HAVE_LONGLONG in avcall.h with MSVC, so the FFI now
	provides FFI:UINT64/SINT64 conversions.

2006-01-30  Jörg Höhle  <hoehle@users.sourceforge.net>

	fixed bug #[ 1211847 ]: preserve object identity of FFI types
	* foreign1.lisp (def-call-out): no side effects during macro-
	expansion, minimize number of calls to parse-c-type (from Sam
	Steingold's wishlist) and do not inline the value of
	parse-c-function, to preserve EQ tests (cf. foreign.d:equal_fvd).
	* foreign1.lisp (note-c-fun): changed API, but I argue it's not ABI
	* foreign1.lisp (argvector-to-signature): removed

2006-01-26  Sam Steingold  <sds@gnu.org>

	* savemem.lisp (saveinitmem): accept :DOCUMENTATION
	* constsym.d (image_doc): added
	* spvw.d (init_symbol_values): init it
	(usage): document -help-image
	(argv_actions): add argv_help_image
	(parse_options): handle -help-image
	(main_actions): ditto: print *IMAGE-DOC* and *SCRIPT*

2006-01-26  Sam Steingold  <sds@gnu.org>

	* spvw.d (main_actions): for "-x": use SYS::MAIN-LOOP instead of
	SYS::*DRIVER* so that even user images offer full CLISP functionality
	* constsym.d (main_loop): added

2006-01-26  Sam Steingold  <sds@gnu.org>

	SAVEINITMEM now accepts :SCRIPT argument that disables
	interpreting the first positional argument as the script name.
	* savemem.lisp (saveinitmem): accept :SCRIPT
	* constsym.d (*script*): added
	* spvw.d (init_symbol_values): init it
	(main_actions): when it is NIL, push the script argument onto
	*ARGS* to be processed by the image's init function

2006-01-26  Sam Steingold  <sds@gnu.org>

	* build-aux/config.sub, build-aux/config.guess: upgrade to 2006-01-02

2006-01-26  Sam Steingold  <sds@gnu.org>

	* makemake.in (install) [cygwin]: clisp-<ver>.README goes to
	/usr/share/doc/Cygwin/, not to /usr/share/doc/clisp-<ver>/Cygwin/

2006-01-25  Sam Steingold  <sds@gnu.org>

	* stream.d (SOCKET-SERVER): avoid calling
	create_server_socket_by_string() twice when interface is supplied;
	restore the default interface to "0.0.0.0" for backwards compatibility

2006-01-25  Sam Steingold  <sds@gnu.org>

	* makemake.in (EVERY_INCLUDES_H) [unix|win32gcc]: add unixconf.h

2006-01-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (gnu-distrib): new target
	(distrib): depend on gnu-distrib
	(upload): also upload to gnu.org

2006-01-24  Sam Steingold  <sds@gnu.org>

	* version.sh: clisp 2.38 release

2006-01-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (clean0): also remove *.core and *.stackdump

2006-01-23  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (find_memdump): when 'image size' fails,
	reset mem_start to -1

2006-01-22  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/bdb.c, modules/berkeley-db/configure.in:
	support Berkeley DB 4.4

2006-01-22  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1412268 ]: buffer overflow in stream handling code
	* w32shell.c (real_path): check length of namein

2006-01-22  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (find_memdump) [!LOADMEM_TRY_SEARCH]: disable
	find_marker()

2006-01-20  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (distrib): also depend on doc-distrib
	(SRC_DIST, SRC_DIST1): go to $(ARCHIVE)
	(doc-distrib, doc--distrib): new targets
	(upload): also upload $(DOC_DIST)
	(src-distrib): do not depend on potfiles because they are already
	created by "all" and thus should not be re-created by "src-distrib"

2006-01-20  Sam Steingold  <sds@gnu.org>

	* built.d (built_flags): report readline version

2006-01-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-exec-image): new target
	(CHECK_DEPS): added check-exec-image

2006-01-19  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (find_memdump): reduce the portion of
	memdump_header_t used as marker to comply with loadmem_from_handle();
	use an intermediate variable to ensure that the second argument to
	lseek(SEEK_END) is indeed negative

2006-01-18  Sam Steingold  <sds@gnu.org>

	speed-up image-in-executable loading
	* spvw_memfile.d (savemem_with_runtime): set mem_start if it was -1
	(savemem): append mem_start to the image
	(loadmem_from_handle): assume that the image end with mem_start
	use ABORT_SYS, ABORT_INI, ABORT_MEM instead of abort[123]
	(find_memdump): try to find mem_start at the end of the image first;
	use the time-consuming (~1sec) find_marker() as a last resort

2006-01-18  Sam Steingold  <sds@gnu.org>

	* execname.c (find_executable) [UNIX_CYGWIN32]: cygwin's
	realpath() does not append ".exe", so we have to do it here

2006-01-18  Sam Steingold  <sds@gnu.org>

	* makemake.in (setup.hint) [cygwin]: depend on SUMMARY
	remove duplicate entries in the "require:" line

2006-01-18  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (loadmem_from_executable): check the return value
	of open_filename(), just in case cygwin breaks find_executable again

2006-01-18  Sam Steingold  <sds@gnu.org>

	* modules/i18n/gettext.c (bool_char_lconv): WARN instead of
	NOTREACHED when the value is invalid
	(CHAR_MAX): defined in <limits.h>, do not redefine it here

2006-01-16  Sam Steingold  <sds@gnu.org>

	* win32.d (HAVE_ICONV): Yaroslav Kavenchuk reports no problems
	with clisp/libiconv/mingw, so do not unconditionally disable ICONV
	here (reverts a part of the 2005-05-28 patch)

2006-01-16  Sam Steingold  <sds@gnu.org>

	* constsym.d, init.lisp (*eq-hashfunction*, *eql-hashfunction*)
	(*equal-hashfunction*): export from CUSTOM
	Reported by Tomas Zellerin <zellerin@gmail.com>

2006-01-13  Sam Steingold  <sds@gnu.org>

	* savemem.lisp (saveinitmem): accept :norc
	* constsym.d (*norc*): added
	* spvw.d (init_symbol_values): init *norc*
	(main_actions): do not load RC-file if *norc* is non-NIL

2006-01-13  Sam Steingold  <sds@gnu.org>

	* spvw.d: executable image should load RC-file by default
	(parse_options): do not reset argv_norc when argv_memfile is NULL
	(init_memory): set argv_memfile to executable_name, not "self"
	(main_actions): check argv_memfile in addition to argv_norc when
	loading the RC-file

2006-01-13  Sam Steingold  <sds@gnu.org>

	Ensure that the executable image contains just one memdump
	* spvw_memfile.d (find_memdump): new function
	(mem_searched): new variable
	(savemem_with_runtime): call find_memdump if it has not been
	called already so that an image saved by an executable image
	called with -M does not include 2 images
	(loadmem_from_executable): call find_memdump(); close the handle

2006-01-12  Sam Steingold  <sds@gnu.org>

	use memdump_header as the marker instead of runtime_size
	for creating executable images
	* spvw.d (init_memory): remove marker and runtime_size
	* spvw_memfile.d (mem_start): new static, replaces runtime_size
	(savemem_with_runtime): when mem_start is 0, copy the whole executable
	(fill_memdump_header): extracted from savemem()
	(savemem): use it
	(find_marker): moved here from utils/filesize.c
	(loadmem_from_executable): use it instead of runtime_size
	* makemake.in, _distmakefile: removed filesize
	* utils/filesize.c: removed

2006-01-12  Sam Steingold  <sds@gnu.org>

	* modules/postgresql/configure.in: look for
	<postgresql/postgres_ext.h> in addition to <postgres_ext.h>
	* modules/postgresql/postgresql.lisp: include either
	Reported by Jeff Bowman <wolfjb@bigfoot.com> that debian unstable
	installs all of the postgres include files in /usr/include/postgresql/

2006-01-12  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1399709 ]: cannot append to a file
	the 2005-12-13 patch that fixed bug #[ 1379620 ] introduced this one
	* pathname.d (open_output_file): open handle WRONLY only on UNIX
	and only if the underlying file exists and is special; this allows
	buffer filling for regular files (there are no special files on WIN32)
	* stream.d (low_fill_buffered_handle): assume that a non-readable
	stream with a regular handle has a readable handle
	(position_file_buffered): reverse last patch

2006-01-11  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1402338 ]: socket-status ignores microseconds in timeout
	* stream.d (sec_usec): fixed a typo in TV_SEC

2006-01-07  Sam Steingold  <sds@gnu.org>

	make utils/filesize idempotent
	* utils/filesize.c: append file size to marker instead of
	overwriting it, write file size in hex
	* spvw.d (init_memory): use stroul() instead of atol()

2006-01-07  Sam Steingold  <sds@gnu.org>

	* defs1.lisp (encode-universal-time): handle correctly early
	1900-01-01 GMT (which is 1899-12-31 EST)

2006-01-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCFLAGS) [disable-mmap]: add -DNO_MULTIMAP_SHM
	-DNO_MULTIMAP_FILE -DNO_SINGLEMAP -DNO_TRIVIALMAP

2006-01-05  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1395894 ]: bad read from make-xterm-io-stream
	* modules/syscalls/posix.lisp (make-xterm-io-stream): fix bitrot

2005-12-22  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/syscalls/calls.c (POSIX:SYSLOG): use
	syslog(priority,"%s",string) to disable % processing and avoid crashes

2006-01-05  Sam Steingold  <sds@gnu.org>

	* modules/i18n/i18n.lisp, modules/syscalls/posix.lisp: do not define
	impnotes documentation in lisp, do it in libdir/Symbol-Table.text

2006-01-04  Sam Steingold  <sds@gnu.org>

	* makemake.in: strip runtime on no-debug woe32
	because woe32 users do not have gdb anyway

2006-01-03  Sam Steingold  <sds@gnu.org>

	* utils/filesize.c (main): check that the marker is found just once

2006-01-03  Sam Steingold  <sds@gnu.org>

	* misc.d (clisp_setenv) [WIN32_NATIVE]: use setenv_via_environ()
	when value is "" because putenv("NAME=") unsets NAME instead of
	setting it to ""

2006-01-03  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (init_language): pass NULL as the second
	argument to clisp_setenv() to unset a variable

2006-01-03  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp (make-xterm-io-stream): accept :title

2006-01-03  Sam Steingold  <sds@gnu.org>

	* utils/filesize.c (find_marker): fread() returns size_t, not ssize_t

2006-01-03  Sam Steingold  <sds@gnu.org>

	* spvw_memfile.d (loadmem_from_executable): use fd_read() instead
	of read() to fix woe32

2006-01-03  Sam Steingold  <sds@gnu.org>

	SAVEINITMEM can create standalone executables
	* spvw.d (runtime_size): new static
	(init_memory): when runtime_size is non-0, try to load image from
	the end of the executable, and set argv_memfile to "self"
	* spvw_memfile.d (savemem): accept exec_p, call savemem_with_runtime
	(savemem_with_runtime, loadmem_from_executable): new functions
	(CLOSE_HANDLE): new macro
	(loadmem, loadmem_from_handle): use it
	* configure.in: check for fchmod
	* execname.c (get_executable_name): new function,
	returns executable_name
	* lispbibl.d (savemem): updated the prototype
	* makemake.in (UTILS): added filesize
	(lisp.run): call filesize
	(distrib) [!BINARY_DISTRIB]: distribute filesize.c
	* _distmakefile [!UNIX_BINARY_DISTRIB]: call filesize on executables
	* pathname.d, subr.d (SAVEMEM): accept EXEC-P
	* savemem.lisp (%saveinitmem): pass NIL as EXEC-P to SAVEMEM
	(saveinitmem): accept :EXECUTABLE
	* utils/filesize.c: new file, replace "my magic marker"
	with the file size in decimal

2006-01-02  Jörg Höhle  <hoehle@users.sourceforge.net>

	* spvw.d (parse_options): have lisp.run --version print information
	even without image file (no -M lispinit.mem).

2006-01-02  Sam Steingold  <sds@gnu.org>

	* clisp-link.in (make_lisprun): new shortcut

2006-01-02  Sam Steingold  <sds@gnu.org>

	* version.sh: clisp 2.37 release

2006-01-02  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (documentation@symbol): handle uninterned symbols

2006-01-01  Sam Steingold  <sds@gnu.org>

	* constsym.d, execname.c, lispbibl.d, misc.d, pathname.d, spvw.d:
	* subr.d: removed HAVE_DISASSEMBLER

2006-01-01  Sam Steingold  <sds@gnu.org>

	better handle numbers that are exactly the midpoint between their
	possible binary approximations, like 1d23 (bug #[ 1389060 ])
	* format.lisp (format-scale-exponent): use exact values as
	arguments to FORMAT-SCALE-EXPONENT-AUX

2006-01-01  Sam Steingold  <sds@gnu.org>

	* time.d (DEFAULT-TIME-ZONE) [WIN32]: decrease time_max by 24 so that
	the second call to seconds_west() will receive an acceptable argument

2006-01-01  Sam Steingold  <sds@gnu.org>

	* configure: replaced --list-modules with --help-modules
	and print more information

2005-12-27  Sam Steingold  <sds@gnu.org>

	* m4/make.m4 (cl_cv_gnu_make): send make error output to 5

2005-12-23  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (RLIMIT): never signal an error when
	"what" is missing and the alist is returned

2005-12-22  Sam Steingold  <sds@gnu.org>

	* lispbibl.d, socket.d, stream.d: "interface" is a win32 keyword

2005-12-21  Jörg Höhle  <hoehle@users.sourceforge.net>

	* clhs.lisp (http-proxy): downcase environment variable http_proxy

2005-12-21  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-doc): explicitly check for the internet connection

2005-12-21  Sam Steingold  <sds@gnu.org>

	* m4/test.m4: use eval to avoid errors

2005-12-21  Sam Steingold  <sds@gnu.org>

	* configure.in: call CL_PROG_MAKE
	* m4/make.m4: added
	* makemake.in: benchmarks & --enable-maintainer-mode require GNU make

2005-12-21  Dr. Werner Fink  <werner@suse.de>

	fixed bug #[ 1376646 ]: factorial broken on 64bit cpu
	* intmal.d (FN_fak_I): uintL is not uintV on 64-bit platforms

2005-12-19  Tomas Zellerin  <zellerin@gmail.com>

	* constsym.d: new keywords :INTERFACE, :BACKLOG
	* lispbibl.d, socket.d: create_server_socket split to
	create_server_socket_by_string and create_server_socket_by_socket
	* socket.d (bindlisten_via_ip): accept pointer to backlog
	* stream.d (SOCKET-SERVER): accept keywords :INTERFACE :BACKLOG
	* subr.d, subrkw.d (SOCKET-SERVER): changed signature

2005-12-19  Sam Steingold  <sds@gnu.org>

	* stream.d (find_open_file): fix compilation with gcc4

2005-12-18  Sam Steingold  <sds@gnu.org>

	base check_file_re_open() on unique file ID, not truenames that
	can be fooled by hard links
	* win32.d, unix.d (file_id, with_file_id, errno_t, handle_file_id)
	(file_id_eq): declare
	* win32aux.d, unixaux.d (with_file_id, handle_file_id)
	(file_id_eq): implemented
	* pathname.d (check_file_re_open): use with_file_id & &find_open_file
	* stream.d (strm_channel_extrafields_t): added fid field
	(ChannelStream_file_id): new macro
	(find_open_file): implemented
	(make_file_stream): fill ChannelStream_file_id

2005-12-16  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (POSIX::FILE-STAT): use SIZEOF_INO_T to
	determine how to convert inode number to Lisp
	* configure.in: use CL_STAT instead of explicit checks
	* modules/syscalls/configure.in: ditto
	* m4/stat.m4 (CL_STAT): renamed from CL_LSTAT;
	concentrate all sys/stat.h and sys/statvfs.h checks here

2005-12-16  Sam Steingold  <sds@gnu.org>

	* describe.lisp (describe-object@funcallable-standard-object):
	added the method
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>

2005-12-16  Sam Steingold  <sds@gnu.org>

	* makemake.in (clisp.dvi, clisp.ps, clisp.pdf): I am sick of telling
	people to ignore clisp.dvi errors, so now these errors are ignored

2005-12-16  Dr. Werner Fink  <werner@suse.de>
	    Sam Steingold  <sds@gnu.org>

	* foreign.d (check_faddress_valid): do not declare inline, g++ 4
	cannot link global inline on linux
	* lispbibl.d (check_faddress_valid): ditto

2005-12-15  Sam Steingold  <sds@gnu.org>

	* stream.d (position_file_buffered): when the file is not
	readable, do not call buffered_nextbyte()

2005-12-15  Sam Steingold  <sds@gnu.org>

	* pathname.d (direction_symbol, check_file_re_open): added
	(open_file): use check_file_re_open() to ensure that we are not
	opening a file twice
	* constsym.d (file_error): added

2005-12-15  Sam Steingold  <sds@gnu.org>

	* socket.d (socket_getlocalname_aux, socket_getpeername): assume
	that unknown sa_family means local connection (AF_UNIX, AF_LOCAL)

2005-12-15  Sam Steingold  <sds@gnu.org>

	* modules/bindings/win32/win32.lisp (with-handle): fixed

2005-12-15  Sam Steingold  <sds@gnu.org>

	* stream.d (publish_host_data): do not invoke test_socket_stream twice

2005-12-14  Sam Steingold  <sds@gnu.org>

	* stream.d (publish_host_data): fixed STACK handling
	Reported by Lennart Staflin <lenst@lysator.liu.se>

2005-12-14  Sam Steingold  <sds@gnu.org>

	* spvw_objsize.d (objsize_iarray, objsize_s8string, objsize_s16string)
	(objsize_s32string, objsize_sstring): return uintM instead of uintL
	Reported by Dr. Werner Fink <werner@suse.de> on IA64 with g++

2005-12-13  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1379620 ]: OPEN :DIRECTION :OUTPUT now creates
	write-only handles and handles named pipes correctly
	* stream.d (low_fill_buffered_handle): when the stream is not
	readable, do not try to read from it
	* pathname.d (open_output_file): accept wronly argument
	(open_file): pass wronly to open_output_file()

2005-12-12  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (defined_class_length): cast address to aint instead
	of ULONG to avoid the g++ warning "cast from pointer to integer of
	different size" on amd64

2005-12-12  Sam Steingold  <sds@gnu.org>

	* spvw.d: use while instead of dotimes and do/while instead of
	dotimesp to simplify debugging with gdb

2005-12-11  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (I_to_uint64, I_to_sint64) [!HAVE_FFI]: define for STREAM
	Reported by Lennart Staflin <lenst@lysator.liu.se> on MacOS X 10.3.9

2005-12-09  Sam Steingold  <sds@gnu.org>

	* constobj.d (type_hashtable_size): use ASH instead of FLOOR,
	use upper case uniformly

2005-12-09  Sam Steingold  <sds@gnu.org>

	* spvw.d (init_object_tab): handle "." specially to save time

2005-12-09  Sam Steingold  <sds@gnu.org>

	* encoding.d (base64_range): declare "signed char" because we
	store -1 (triggers a bug on PowerPC where "char" = "unsigned char")
	Reported by Magnus Henoch <mange@freemail.hu>

2005-12-09  Sam Steingold  <sds@gnu.org>

	* m4/readline.m4 (CL_READLINE): check for <readline/readline.h>

2005-12-09  Sam Steingold  <sds@gnu.org>

	* encoding.d (CHARSET-TYPEP): use Sstring_length instead of
	Svector_length for the range string because Svector_length returns
	non-0 value for "" on AMD64-Linux

2005-12-08  Sam Steingold  <sds@gnu.org>

	* misc.d (clisp_setenv): added a cast for C++ compilation

2005-12-08  Sam Steingold  <sds@gnu.org>

	* encoding.d (base64_range): do not use a literal string for
	initialization because it allocates an extra element for 0

2005-12-07  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (documentation@package): prepend (impnotes-root) to the doc

2005-12-07  Sam Steingold  <sds@gnu.org>

	* defs1.lisp (*system-package-list*): use "COMMON-LISP"
	instead of "LISP"

2005-12-06  Sam Steingold  <sds@gnu.org>

	* m4/termcap.m4 (CL_TERMCAP): avoid "case x in (..) ;; esac"
	1-line syntax as it is not understood by the Solaris /bin/sh

2005-12-06  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (open-url): new function
	(ensure-clhs-map, ensure-impnotes-map): use it

2005-12-05  Sam Steingold  <sds@gnu.org>

	* m4/putenv.m4 (CL_PUTENV): check unsetenv() declared return value
	* misc.d (cat_env_var): value must be non-NULL
	(setenv_via_environ): extracted from clisp_setenv()
	(clisp_setenv): use it to unset the variable

2005-12-05  Sam Steingold  <sds@gnu.org>

	* m4/readline.m4 (CL_READLINE): pass filename_completion_function
	to CL_PROTO to avoid ugly messages

2005-12-05  Sam Steingold  <sds@gnu.org>

	* m4/x11.m4: fix overlapping messages, do not use broken CL_SILENT
	* m4/general.m4 (CL_SILENT): removed broken macro

2005-12-05  Sam Steingold  <sds@gnu.org>

	* makemake.in (HSDEFAULT): drop trailing slash
	(clisp-1.html): substitute @PLATFORM@

2005-12-05  Sam Steingold  <sds@gnu.org>

	* inspect.lisp (inspect-frontend@:http): use UNWIND-PROTECT to
	ensure that SOCK and SERVER are closed
	Suggested by Tomas Zellerin <zellerin@gmail.com>

2005-12-05  Sam Steingold  <sds@gnu.org>

	* misc.d (clisp_setenv) [HAVE_UNSETENV]: use unsetenv

2005-12-04  Sam Steingold  <sds@gnu.org>

	* spvw.d (main_actions): remove the legacy warning about RC file
	name (_clisprc -> .clisprc) transition

2005-12-04  Sam Steingold  <sds@gnu.org>

	* m4/putenv.m4 (CL_PUTENV): check for unsetenv

2005-12-04  Sam Steingold  <sds@gnu.org>

	* makemake.in (UNAME_R): strip everything after [^A-Za-z0-9.]

2005-12-04  Sam Steingold  <sds@gnu.org>

	* m4/readline.m4: fixed last patch that was totally broken

2005-12-04  Sam Steingold  <sds@gnu.org>

	* version.sh: clisp 2.36 release

2005-12-04  Sam Steingold  <sds@gnu.org>

	* spvw_circ.d (get_circ_mark, get_circ_unmark):
	use the appropriate flavor of dotimes
	Reported by Peter Van Eynde <pvaneynd@debian.org> [on m68k]

2005-12-03  Sam Steingold  <sds@gnu.org>

	* pseudofun.d (base64_mblen, base64_mbstowcs, base64_wcslen)
	(base64_wcstombs, base64_range): declare

2005-12-03  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (nobject_out1): print encodings

2005-12-03  Sam Steingold  <sds@gnu.org>

	* encoding.d (base64_range): fixed for "-1" in table_base64

2005-12-02  Sam Steingold  <sds@gnu.org>

	* defs1.lisp (encode-universal-time): reverted part of the 2005-11-30
	patch: no need to adjust the return value of DEFAULT-TIME-ZONE
	* time.d (seconds_west): fixed a bug in the last patch:
	now_gm and now_local must be structures, not pointers, because
	gmtime and localtime return pointers to the same memory ares.
	also note that seconds_west is NOT the same as (mktime(&now_gm) -
	mktime(&now_local)) during DST

2005-12-01  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (nobject_out1): output more information for streams

2005-11-30  Sam Steingold  <sds@gnu.org>

	Fixed a bug in ENCODE-UNIVERSAL-TIME that made it an imperfect
	inverse for DECODE-UNIVERSAL-TIME because it passed non-UT hours
	to DEFAULT-TIME-ZONE which required UT hours
	* time.d (seconds_west): new function, extracted from...
	(DEFAULT-TIME-ZONE): require 2 arguments: time in hours and UT-P
	call seconds_west() and then again if UT-P is false
	* subr.d (default_time_zone): requires 2 arguments
	* defs1.lisp (decode-universal-time, encode-universal-time):
	pass 2 arguments to DEFAULT-TIME-ZONE

2005-11-30  Sam Steingold  <sds@gnu.org>

	* modules/i18n/gettext.c: include <limits.h> to define CHAR_MAX
	Reported by Magnus Henoch <mange@freemail.hu>

2005-11-30  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1369668 ]: invalid slot :ALLOCATION causes segfault
	* record.d (ptr_to_slot): do not assume that slotinfo is valid,
	signal an error if it is not, accept slotname for error reporting
	(slot_using_class_up, SLOT-VALUE, SET-SLOT-VALUE, SLOT-BOUNDP)
	(SLOT-MAKUNBOUND, %SHARED-INITIALIZE, %REINITIALIZE-INSTANCE)
	(do_initialize_instance): pass slot to ptr_to_slot

2005-11-29  Sam Steingold  <sds@gnu.org>

	* misc.d (cat_env_var) [woe32]: putenv("FOO=") removes FOO,
	[posix]: putenv("FOO") removes FOO
	(clisp_setenv) [WIN32_NATIVE]: ignore ERROR_ENVVAR_NOT_FOUND when
	passing NULL value to SetEnvironmentVariableA()

2005-11-28  Sam Steingold  <sds@gnu.org>

	* init.lisp (loading-message): new function
	(load): use it
	* defs1.lisp (load-lpt-many, load-lpt-one): ditto
	(load-logical-pathname-translations): use search-file exclusively

2005-11-28  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (convert-to-foreign-C): added
	(note-c-call-in): use it

2005-11-28  Sam Steingold  <sds@gnu.org>

	* makemake.in (lispbibl.h): depend on unixconf.h

2005-11-28  Sam Steingold  <sds@gnu.org>

	* clhs.lisp, clos-class1.lisp, clos-class3.lisp, clos-genfun2b.lisp:
	* clos-genfun3.lisp, clos-methcomb2.lisp, compiler.lisp, defmacro.lisp:
	* defs1.lisp, describe.lisp, format.lisp, type.lisp, condition.lisp:
	read-macro micro-optimizations

2005-11-26  Sam Steingold  <sds@gnu.org>

	* stream.d (error_eof_p): new function; on woe32, WSAESHUTDOWN is
	signaled when the other end is shutdown, so take it to mean EOF
	(low_read_array_unbuffered_handle, low_fill_buffered_handle)
	(low_read_unbuffered_socket, low_listen_unbuffered_socket)
	(low_read_array_unbuffered_socket, low_fill_buffered_socket): use it
	Reported by Vasilis M. <vasilism@hotmail.com>

2005-11-26  Sam Steingold  <sds@gnu.org>

	* .gdbinit: ensure that all invocations get -E 1:1

2005-11-26  Sam Steingold  <sds@gnu.org>

	New charset BASE64
	* encoding.d (base64_mblen, base64_mbstowcs, base64_wcslen)
	(base64_wcstombs, base64_range, base64_table, table_base64)
	(base64_to_bytes, base64_to_chars): added
	(init_encodings_1): unit BASE64
	* constsym.d (BASE64): added
	* clhs.lisp (*base64-table*, base64-encode, *table-base64*)
	(base64-decode): removed
	(open-http): use CHARSET:BASE64 instead of BASE64-ENCODE

2005-11-26  Sam Steingold  <sds@gnu.org>

	* .gdbinit (run_test, run_all_tests): suite --> tests (typo)

2005-11-26  Sam Steingold  <sds@gnu.org>

	* makemake.in (LN_HARD): set from @LN@, also set a Makefile variable
	with the same name so that the AFS users can change it at run time

2005-11-26  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (Snstring): export to clisp.h to make module i18n
	build --without-unicode

2005-11-25  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp: set documentation sys::process-id
	to point to impnotes#process-id

2005-11-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-doc): new target to check Symbol-Table.text

2005-11-23  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (base64-encode, base64-decode): stolen from CLLIB
	(http-proxy): do not separate username with password
	(open-http): send "Authorization" when proxy user:pass is specified

2005-11-22  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1364177 ]: infinite loop in regexp-split
	* modules/regexp/regexp.lisp (regexp-split): avoid an infinite loop
	by signaling an error when the pattern matches an empty string

2005-11-22  Sam Steingold  <sds@gnu.org>

	* init.lisp (*http-proxy*): export
	* clhs.lisp (*http-proxy*): new variable
	(http-proxy): new function
	(open-http): use it
	(ensure-impnotes-map): handle errors in Symbol-Table.text

2005-11-22  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp (SOCKET-SERVICE-PORT):
	avoid package lock warnings

2005-11-22  Sam Steingold  <sds@gnu.org>

	* modules/i18n/i18n.lisp (i18n:locale-conv, i18n:set-locale)
	(i18n:language-information): added impnotes documentation

2005-11-22  Sam Steingold  <sds@gnu.org>

	* makemake.in (.SHELL): add on all *bsd* systems

2005-11-21  Sam Steingold  <sds@gnu.org>

	fix bug #[ 1359066 ]: :ALLOCATION kind not extensible
	* clos-class3.lisp (defclass): permit user-defined :allocation
	(checked-compute-slots): require non-NIL location only from slots
	with standard :ALLOCATION (:CLASS or :INSTANCE)

2005-11-21  Sam Steingold  <sds@gnu.org>

	* configure: suggest setting CC when printing libsigsegv building
	recommendations

2005-11-21  Sam Steingold  <sds@gnu.org>

	* m4/readline.m4 (CL_READLINE): fail when --with-readline was
	specified, but a modern readline cannot be found

2005-11-21  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (DEF-C-CONST): rewrote
	(note-c-const): removed
	(c-const-value): added

2005-11-20  Sam Steingold  <sds@gnu.org>

	* clhs.lisp: set package/impnotes documentation for packages
	EXT, CLOS, AFFI

2005-11-19  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (ensure-clhs-map, ensure-impnotes-map): use a separate
	variable to record whether the map is good

2005-11-19  Sam Steingold  <sds@gnu.org>

	* describe.lisp (launch-doc): launch the browser only on top-level

2005-11-19  Sam Steingold  <sds@gnu.org>

	* clhs.lisp, exporting.lisp: document package EXPORTING in
	exporting.lisp, not in clhs.lisp

2005-11-19  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (impnotes-map-source) [woe32]: #\\ is also a path separator

2005-11-19  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (DEF-C-CONST): call PREPARE-MODULE before the
	first reference to *name*; do not evaluate NOTE-C-CONST at
	macroexpansion time
	(note-c-const): do not call PREPARE-MODULE here

2005-11-18  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (POSIX:STRING-TIME): implemented
	* modules/syscalls/posix.lisp (STRING-TIME) [unix]: exported
	* modules/syscalls/configure.in (strptime, strftime, mktime): check

2005-11-18  Sam Steingold  <sds@gnu.org>

	* modules/bindings/win32/win32.lisp (with-handle): declare the
	HANDLE variable READ-ONLY
	(MessageBoxA): new function

2005-11-18  Sam Steingold  <sds@gnu.org>

	* condition.lisp (find-subclasses-of-type): added
	(make-condition): use it to enable TYPE arguments that do not
	name a specific class
	* utils/clispload.lsp (*expected-failures*): removed
	MAKE-CONDITION.3 and MAKE-CONDITION.4

2005-11-17  Sam Steingold  <sds@gnu.org>

	* defs1.lisp (*system-package-list*): remove "CUSTOM": the
	variables and functions in this package are for the users to change

2005-11-17  Sam Steingold  <sds@gnu.org>

	DESCRIBE can now point the browser to impnotes
	* package.d ((SETF PACKAGE-DOCUMENTATION)): package documentation
	is either a doc-string or a list (doc-string impnotes-id)
	* documentation.lisp (documentation): ditto
	* makemake.in (DATA_FILES): added Symbol-Table.text
	* init.lisp (clhs-root): moved from EXT to CUSTOM to avoid locking
	(*impnotes-root-default*, impnotes-root): export from CUSTOM
	* describe.lisp (launch-doc): new function
	(describe): use it for symbols and packages for CLHS and impnotes
	* clhs.lisp (open-http): catch connection errors when
	:IF-DOES-NOT-EXIST is not :ERROR
	(ensure-clhs-map): reset clhs-map-source early to avoid re-running
	again and again after a failure
	(get-string-map, ensure-impnotes-map): added
	(documentation@symbol/clhs): call ENSURE-CLHS-MAP only for symbols
	in the COMMON-LISP package
	(documentation@symbol/impnotes, documentation@package/impnotes): added
	set package/impnotes documentation for packages GRAY, CL-USER, CS-CL,
	CS-CL-USER, SCREEN, SOCKET, GSTREAM, I18N, FFI, CHARSET, EXPORTING
	* cfgunix.lisp, cfgsunux.lisp, cfgwin32.lisp
	(*impnotes-root-default*): defvar
	(impnotes-root): defun
	* modules/berkeley-db/dbi.lisp: added impnotes doc for package BDB
	* modules/dirkey/dirkey1.lisp: added impnotes doc for package LDAP
	* modules/fastcgi/fastcgi.lisp: added impnotes doc for package FASTCGI
	* modules/matlab/matlab.lisp: added impnotes doc for package MATLAB
	* modules/netica/netica.lisp: added impnotes doc for package NETICA
	* modules/oracle/oracle.lisp: added impnotes doc for package ORACLE
	* modules/pari/pari.lisp: added impnotes doc for package PARI
	* modules/pcre/pcre.lisp: added impnotes doc for package PCRE
	* modules/postgresql/postgresql.lisp: added impnotes doc for package SQL
	* modules/rawsock/sock.lisp: added impnotes doc for package RAWSOCK
	* modules/readline/readline.lisp: added impnotes doc for package
	READLINE
	* modules/regexp/regexp.lisp: added impnotes doc for package REGEXP
	* modules/syscalls/posix.lisp: added impnotes doc for package POSIX
	* modules/wildcard/wildcard.lisp: added impnotes doc for package
	WILDCARD
	* modules/zlib/zlib.lisp: added impnotes doc for package ZLIB

2005-11-17  Sam Steingold  <sds@gnu.org>

	* makemake.in (.SHELL) [netbsd]: new target to ensure make uses $(SHELL)

2005-11-17  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/configure.in: check for <netinet/in.h>
	* modules/syscalls/calls.c: include <netinet/in.h> before
	<arpa/inet.h> to avoid warnings on FreeBSD

2005-11-17  Sam Steingold  <sds@gnu.org>

	New declaration EXT:NOTSPECIAL undoes the effects of DEFVAR et al
	* compiler.lisp (c-PROCLAIM): handle NOTSPECIAL declarations
	* control.d (PROCLAIM): ditto
	* constsym.d (EXT:NOTSPECIAL): added
	* init.lisp (EXT:NOTSPECIAL): exported

2005-11-16  Sam Steingold  <sds@gnu.org>

	New function EXT:OPEN-HTTP and macro EXT:WITH-HTTP-INPUT.
	Function EXT:CLHS is now deprecated in favor of DESCRIBE.
	* clhs.lisp (*browsers*) [cygwin macos]: added :DEFAULT browser
	(*clhs-table*): removed
	(browse-url): do not handle NIL browser specially; still need to
	special-case :DEFAULT on woe32
	(with-http-input): new macro
	(open-http, get-clhs-map, ensure-clhs-map): new functions
	(documentation@symbol/clhs): new method
	(clhs): use them, deprecate
	* describe.lisp (describe-object@symbol): when CLHS doc is
	available, print it or launch the browser (depending on *browser*)
	* makemake.in (DATA_FILES, DATA_FILES_TOP_PATH): removed clhs.txt

2005-11-16  Sam Steingold  <sds@gnu.org>

	* macros2.lisp (with-open-stream): close VAR only when it is not NIL

2005-11-15  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:CHANGE-KEYBOARD-MAPPING)
	(XLIB:KEYCODE->CHARACTER): fixed C++ compilation

2005-11-15  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (check_socket_domain)
	(check_socket_protocol): added some woe32 constants

2005-11-14  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (traverse-anode): use make-array/dotimes instead
	of coerce/mapcap/list/coerce (avoids some consing)

2005-11-14  Sam Steingold  <sds@gnu.org>

	* subtypep.lisp (STANDARD-OBJECT): fixed handling of (AND ...)

2005-11-14  Sam Steingold  <sds@gnu.org>

	* array.d (fill_initial_element): extracted from make_storagevector()
	(ADJUST-ARRAY): call if for strings when the data vector is not
	created using make_storagevector() to ensure that the
	:INITIAL-ELEMENT argument is not ignored

2005-11-14  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1356695 ]: read labels are not resolved in #2A
	* io.d (ARRAY-READER): disentangle references in generic arrays
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>

2005-11-12  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in: include <sys/types.h> before
	<sys/uio.h> when checking for struct iovec so that size_t is defined

2005-11-11  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (GETNAMEINFO, GETADDRINFO): support woe32:
	(error_missing): new function
	(getnameinfo_t, getaddrinfo_t, freeaddrinfo_t): new types
	(my_getnameinfo, my_getaddrinfo, my_freeaddrinfo): new functions
	(getnameinfo_f, getaddrinfo_f, freeaddrinfo_f): new variables
	(module__rawsock__init_function_2): init them

2005-11-11  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (module__syscalls__init_function_2):
	moved ole32 and kernel32 here (not static anymore)

2005-11-11  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp (service): do not check type of PROTOCOL

2005-11-10  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c [win32]: include <ws2tcpip.h> for
	getaddrinfo, freeaddrinfo, getnameinfo
	(SETSOCKOPT_ARG_T) [win32]: define to char* (unix: from CL_TCPCONN)
	* modules/rawsock/configure.in, modules/syscalls/configure.in:
	use CL_SOCKET for solaris

2005-11-09  Sam Steingold  <sds@gnu.org>

	SOCKET:SOCKET-SERVICE-PORT is now deprecated in favor of OS:SERVICE
	* modules/syscalls/calls.c (POSIX:SERVICE): implemented
	* modules/syscalls/posix.lisp (service): new structure
	* beossock.lisp: removed
	* constsym.d, subr.d (socket_service_port): removed
	* init.lisp (socket-service-port): removed; do not load beossock
	* socket.d (socket-service-port): removed
	* makemake.in (LPARTS): removed beossock

2005-11-09  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/posix.lisp (group-info): new structure
	* modules/syscalls/calls.c (group-info): implemented
	(user-info): renamed from user-data

2005-11-09  Sam Steingold  <sds@gnu.org>

	* makemake.in (encflags): add -Emisc 1:1 to avoid encoding errors

2005-11-08  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (passwd_to_lisp): replaces PASSWD_TO_STACK
	(USER-DATA): use passwd_to_lisp() instead of PASSWD_TO_STACK()
	user argument is now optional, as documented

2005-11-08  Sam Steingold  <sds@gnu.org>

	* defpackage.lisp (defpackage): :SHADOWING-IMPORT-FROM, :USE,
	:IMPORT-FROM accept package designators, not just package names

2005-11-08  Sam Steingold  <sds@gnu.org>

	* m4/test.m4 (CL_TEST_NT): TEST_NT defaults to "no"

2005-11-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (SACLA_CLISP): run in ANSI mode

2005-11-07  Sam Steingold  <sds@gnu.org>

	* loop.lisp (expand-loop/compatible-p): handle "ing" keyword variants

2005-11-07  Sam Steingold  <sds@gnu.org>

	* stream.d (parse_sock_list): handle socket servers as documented
	Reported by Johan Liseborn <johan@liseborn.se>

2005-11-01  Sam Steingold  <sds@gnu.org>

	* m4/readline.m4 (CL_READLINE): check for rl_gnu_readline_p and
	refuse to use readline if it is not defined - this should take
	care of the OSX broken readline (see unix/PLATFORMS)
	* modules/readline/configure.in: do not check rl_gnu_readline_p here

2005-11-01  Sam Steingold  <sds@gnu.org>

	* makemake.in (CHECK_DEPS): add check-script
	(check-script): new target

2005-11-01  Sam Steingold  <sds@gnu.org>

	* m4/test.m4: stricter test to catch *BSD sh/test breakage

2005-10-31  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (nobject_out1): handle Foreign-Address only when
	DYNAMIC_FFI is defined

2005-10-31  Sam Steingold  <sds@gnu.org>

	* spvw.d (main_actions): when argv_execute_file=="-", use the
	value of *STANDARD-INPUT*, not the symbol itself (bug #[ 1344222 ])

2005-10-30  Sam Steingold  <sds@gnu.org>

	ensure that make uses the same shell that configure tests
	* configure.in: write CONFIG_SHELL into makemake
	* makemake.in: set SHELL to CONFIG_SHELL

2005-10-29  Sam Steingold  <sds@gnu.org>

	* package.d (get_current_package): issue a CERROR when resetting
	the package
	* lispbibl.d (get_current_package): declare maygc
	* io.d (write_sstring_case, pr_symbol, pr_like_symbol):
	save objects around get_current_package()

2005-10-28  Sam Steingold  <sds@gnu.org>

	* stream.d (publish_host_data): accept raw sockets
	(STREAM-HANDLES): replaces SOCKET-STREAM-HANDLES, returns both
	input and output handles as two values
	* subr.d, constsym.d (stream_handles): ditto
	* init.lisp (stream-handles): always export it

2005-10-27  Sam Steingold  <sds@gnu.org>

	* spvw_typealloc.d (reallocate_small_string) [DEBUG_SPVW]: use
	varobject_bytelength() instead of objsize() to compile with SPVW_PURE
	* spvw_page.d (oint_addr_relevant_len): define to 32 by default
	* lispbibl.d (oint_type_* &c) [AMD64]: define the same way on all
	platforms: works on BSD* with -DNO_TRIVIALMAP -DNO_MULTIMAP_SHM
	-DNO_MULTIMAP_FILE -DNO_SINGLEMAP

2005-10-25  Yaroslav Kavenchuk  <kavenchuk@jenty.by>
	    Sam Steingold  <sds@gnu.org>

	* makemake.in (NEED_RECONFIGURE) [!TEST_NT]: fixed a typo

2005-10-25  Sam Steingold  <sds@gnu.org>

	* .gdbinit (OS_error, OS_file_error, OS_filestream_error): break

2005-10-25  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in: check "struct iovec"
	* modules/rawsock/rawsock.c (struct iovec) [!HAVE_STRUCT_IOVEC]: define
	(read, write) [win32]: use recv/send instead
	(readv) [!HAVE_READV]: implemented
	(writev) [!HAVE_WRITEV]: implemented
	(SOCKETPAIR) [!HAVE_SOCKETPAIR]: implemented
	(SOCK-READ, SOCK-WRITE): use readv and writev even when the OS
	does not offer them
	* modules/rawsock/sock.lisp (describe-object@sockaddr): new
	method, calls getnameinfo

2005-10-24  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (check_socket_protocol): added
	IPPROTO-RSVP IPPROTO-GRE IPPROTO-PIM IPPROTO-COMP

2005-10-24  Sam Steingold  <sds@gnu.org>

	* modules/postgresql/postgresql.lisp, modules/readline/readline.lisp:
	do not #include <clisp.h> - it is done automatically

2005-10-23  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:CHANGE-KEYBOARD-MAPPING)
	(XLIB:SHAPE-EXTENTS, XLIB:SHAPE-RECTANGLES, XLIB:DEFAULT-KEYSYM-INDEX)
	(XLIB:KEYBOARD-MAPPING, XLIB:KEYSYM-NAME, XLIB:KEYCODE->CHARACTER):
	implemented
	* modules/clx/new-clx/clx.lisp (gcontext): added a %timestamp slot
	for the sake of clue/clio

2005-10-22  Sam Steingold  <sds@gnu.org>

	* screen.lisp (*new-window*, read-keyboard-char): removed
	undocumented and unused symbols

2005-10-22  Sam Steingold  <sds@gnu.org>

	avoid configure errors on woe32
	* m4/eloop.m4: check that conftest exists before running it
	* m4/poll.m4: if AC_CHECK_FUNC does not find poll,
	cl_cv_func_poll will not be set

2005-10-21  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (SOCK-LISTEN): backlog is optional
	and defaults to SOMAXCONN

2005-10-21  Sam Steingold  <sds@gnu.org>

	fixed user-defined HT tests
	* lispbibl.d (hashtable_length): fixed the wrong value
	* hashtabl.d (rehash): fixed user-defined ht-test handling
	(hash_prepare_store): fixed `cacheable' logic

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/bdb.c: avoid void* pointer arithmetics

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (RAWSOCK:SENDMSG): call fill_msghdr()
	(NETWORK, SOCK-READ, SOCK-WRITE): added casts to pacify G++
	(RAWSOCK:GETADDRINFO): fixed argument order and stack cleanup

2005-10-20  Sam Steingold  <sds@gnu.org>

	* hashtabl.d (hash_store): user-defined hash tables do not have to
	be rehashed due to GC
	(hash_prepare_store): fixed a GC-safety bug: hashcode_raw() may
	trigger GC for user-defined hash tables
	* spvw_debug (TheHashtable_) [DEBUG_SPVW]: added

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (check_socket_type):
	default=0 for the sake of getaddrinfo()
	(RAWSOCK:GETADDRINFO): ai_canonname may be NULL
	(RAWSOCK:RECVMSG, RAWSOCK:SENDMSG): fixed typo in the conditionals,
	fixed some typos;
	accept :START and :END to conform with other SEND/RECV functions

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/readline/readline.lisp: removed "RL_" prefix from the
	Lisp names of the STATE-* constants

2005-10-20  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (to-c-name): downcase all-upper-case names only in
	case-insensitive packages so that (def-c-const ENOENT) will work
	in modules/bindings/glibc/linux.lisp
	(def-c-const): simplified :DOCUMENTATION handling, fixed :TYPE
	handling, issue a warning when the constant cannot be defined,
	tweak f-name case

2005-10-20  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (WIDE_HARD): define oint_data_* to oint_addr_* when
	they are the same, for clarity

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (parse_buffer): start is uintL, not uintV
	(parse_buffer_arg, check_struct_data, fill_iovec, fill_msghdr):
	avoid void* pointer arithmetics
	(check_addrinfo_flags): bitmasks=both
	(GETADDRINFO): typo: value1, not values1

2005-10-20  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:ACCESS-HOSTS, lisp_to_XHostAddress):
	check FamilyInternet6 in addition to HAVE_IPV6

2005-10-20  Sam Steingold  <sds@gnu.org>

	* exporting.lisp (def-c-const): added
	* foreign1.lisp (def-c-const, note-c-const): added
	(ffi-module): added slot CONSTANT-TABLE
	(finalize-coutput-file): output constant map functions
	* modules/bindings/glibc/linux.lisp, modules/readline/readline.lisp:
	* modules/wildcard/wildcard.lisp, modules/pari/pari.lisp:
	use DEF-C-CONST instead of DEFCONSTANT with explicit values

2005-10-20  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (oint_type_len): #error when undefined

2005-10-19  Sam Steingold  <sds@gnu.org>

	* execname.c (MAXPATHLEN): define when it is not defined
	Reported by Soeren D. Schulze <soeren.d.schulze@gmx.de>

2005-10-19  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in (getnameinfo, getaddrinfo)
	(freeaddrinfo): check
	* modules/rawsock/sock.lisp (msghdr): removed
	(getnameinfo, getaddrinfo): export
	(message, addrinfo): added
	(defstruct): import from EXPORTING
	* modules/rawsock/rawsock.c (GETNAMEINFO, GETADDRINFO): implemented
	(RECVMSG, SENDMSG): use MESSAGE instead of MSGHDR

2005-10-19  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.lisp (undefined): do not use package prefix

2005-10-19  Sam Steingold  <sds@gnu.org>

	* foreign.d: uniform use of articles in messages

2005-10-19  Sam Steingold  <sds@gnu.org>

	* m4/test.m4 (CL_TEST_NT): check that test(1) can serve as make(1)
	* configure.in: call CL_TEST_NT
	* makemake.in (anymodule): use "test -nt" only when supported

2005-10-17  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.lisp (DRAW-GLYPH): undefined;
	use MACROLET instead of EVAL-WHEN+DEFMACRO

2005-10-17  Sam Steingold  <sds@gnu.org>

	* modules/readline/readline.lisp (readline-reader): return NIL on EOF
	(resize-terminal, set-screen-size, get-screen-size): added
	(readline-state): new variable together with its constants
	* modules/readline/configure.in: check everything forgotten by Tom

2005-10-17  Sam Steingold  <sds@gnu.org>

	* complete.lisp (completion): define even when not on UNIX

2005-10-11  Tomas Zellerin  <zellerin@gmail.com>

	* modules/readline/readline.lisp: more ffi functions and variables;
	package, some functions and variables documented;
	(*readline-input-stream*): new stream
	* modules/readline/configure.in: all declared functions tested
	* modules/readline/test.tst: added functionality tests

2005-10-17  Sam Steingold  <sds@gnu.org>

	* spvw_sigterm.d (install_sigterm_handler): ignore SIGTTOU to avoid
	being stopped on a terminating signal when running in the background

2005-10-17  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in: check for msghdr.msg_flags when
	sys/socket.h is present
	* modules/rawsock/rawsock.c (RECVMSG, SENDMSG): implement only
	when the system implementation is POSIX, i.e., has msg_flags

2005-10-17  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (STACK_to_mv): export to clisp.h
	* modules/syscalls/calls.c (hostent_to_lisp): new public function
	converted from hostent_to_stack()
	(RESOLVE-HOST-IPADDR): updated to use hostent_to_lisp()
	* modules/clx/new-clx/configure.in: check for socket headers
	* modules/clx/new-clx/clx.lisp (ACCESS-CONTROL): new defsetf
	mark non-implemented functions with compiler macros
	* modules/clx/new-clx/clx.f (POINTER-CONTROL): fixed STACK cleanup
	(check_on_off): YES->ON
	(MODIFIER-MAPPING): C arrays are base 0, not base 1
	(SET-MODIFIER-MAPPING, KEYSYM->KEYCODES, ACCESS-HOSTS)
	(ADD-ACCESS-HOST, REMOVE-ACCESS-HOST): implemented
	(SET-ACCESS-CONTROL): fixed argument order
	* modules/clx/new-clx/test.tst: added

2005-10-16  Sam Steingold  <sds@gnu.org>

	* spvw_sigwinch.d: rl_resize_terminal() should be called only if
	readline has been already initialized
	(sigwinch_handler) [HAVE_READLINE]: call rl_resize_terminal()
	(update_linelength) [HAVE_READLINE]: do not call rl_resize_terminal()

2005-10-16  Sam Steingold  <sds@gnu.org>

	* configure (--version): call src/configure instead of sourcing
	version.sh which is not included in the source distribution
	Reported by T. Kurt Bond <tkb@tkb.mpl.com>

2005-10-14  Sam Steingold  <sds@gnu.org>

	* spvw_sigwinch.d (update_linelength) [HAVE_READLINE]:
	call rl_resize_terminal()

2005-10-15  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (CHANGE-KEYBOARD-CONTROL): implemented

2005-10-14  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1310753 ]: Gray streams ==> stack overflow and segfault
	* stream.d (read_char): fixed recursion: cannot assume that the
	constituent streams of constructed streams are built-in

2005-10-14  Sam Steingold  <sds@gnu.org>

	C-level CLOSE functions accept abort argument to ensure that
	auto-close (in GC and quit) cannot fail
	* lispbibl.d (builtin_stream_close): accept abort
	* stream.d (close_synonym, close_str_in, close_buff_in, close_buff_out)
	(close_generic, strm_channel_extrafields_t.low_close, low_close_handle)
	(close_ichannel, close_ochannel, close_buffered, low_close_console)
	(close_window, term_nlunraw, end_term, low_close_socket)
	(low_close_socket_nop, builtin_stream_close): ditto
	(close_some_files): pass abort=1 to builtin_stream_close()
	(BUILT-IN-STREAM-CLOSE): pass :ABORT to builtin_stream_close()
	(low_flush_buffered_handle, make_buffered_stream, make_file_stream):
	pass abort=0 to builtin_stream_close()
	* debug.d (LOAD): ditto
	* misc.d (MACHINE-TYPE, MACHINE-VERSION): ditto
	* pathname.d (DELETE-FILE): ditto
	* spvw_memfile.d (WRITE, savemem): ditto
	* modules/syscalls/calls.c (copy_attributes_and_close, copy_file_low)
	(copy_one_file): ditto

2005-10-10  Sam Steingold  <sds@gnu.org>

	* m4/termcap.m4 (CL_TERMCAP): accept --with-termcap-prefix
	* makemake.in (INCTERMCAP, LIBTERMCAP): add to XCFLAGS & XLDFLAGS
	allow readline on mingw

2005-10-14  Yaroslav Kavenchuk  <kavenchuk@jenty.by>
	    Sam Steingold  <sds@gnu.org>

	* modules/bindings/win32/win32.lisp (GetConsoleScreenBufferInfo)
	(GetConsoleWindow): added

2005-10-12  T. Kurt Bond  <tkb@tkb.mpl.com>

	* lispbibl.d (PC386): also define on FreeBSD, NetBSD, and OpenBSD

2005-10-12  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (check_socket_protocol): no prefix,
	accept IPPROTO-* in addition to ETH-P-*
	(get_socket_protocol): new function, use getprotobyname() when it
	is available in addition to check_socket_protocol()
	(SOCKET, SOCKETPAIR): use get_socket_protocol()

2005-10-12  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (Atype_T): export to clisp.h
	* modules/rawsock/configure.in: check <sys/uio.h>, readv, writev,
	sizeof ssize_t and size_t
	* modules/rawsock/rawsock.c (SOCK-READ, SOCK-WRITE) [HAVE_SYS_UIO_H]:
	call readv/writev when buffer is a vector of vectors
	(check_iovec_arg, fill_iovec) [HAVE_SYS_UIO_H]: new functions

2005-10-11  Sam Steingold  <sds@gnu.org>

	* error.d (check_vector_replacement): new function
	* encoding.d (CONVERT-STRING-FROM-BYTES):
	use it instead of fehler_vector()
	* array.d (VECTOR-ENDTEST, VECTOR-FE-INIT, VECTOR-LENGTH)
	(VECTOR-INIT-START, VECTOR-FE-INIT-END): ditto
	* lispbibl.d (check_vector_replacement, check_vector): export

2005-10-11  Sam Steingold  <sds@gnu.org>

	* makemake.in (anymodule): call configure not just when config.status
	is not present, but also when configure is newer than config.status
	* modules/dirkey/Makefile.in, modules/i18n/Makefile.in:
	* modules/pari/Makefile.in, modules/pcre/Makefile.in:
	* modules/postgresql/Makefile.in, modules/rawsock/Makefile.in:
	* modules/readline/Makefile.in, modules/regexp/Makefile.in:
	* modules/syscalls/Makefile.in, modules/wildcard/Makefile.in:
	* modules/zlib/Makefile.in, modules/berkeley-db/Makefile.in:
	(config.status, config.h, Makefile): removed targets:
	config.status failed with
	error: `CFLAGS' was not set in the previous run
	This is a partial reversal of the 2005-10-07 patch (dependency of
	C files on on config.h are kept).

2005-10-11  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in: check getnetent*
	* modules/rawsock/rawsock.c (netent_to_network, NETWORK): added
	* modules/rawsock/sock.lisp (network): new defstruct

2005-10-11  Sam Steingold  <sds@gnu.org>

	fixed bug #[ 1323941 ]: when killed, clisp does not execute cleanup forms
	* spvw.d (main): call install_sigterm_handler(), include spvw_sigterm.c
	* spvw_sigterm.c: new file
	* makemake.in (SPVW_INCLUDES): added spvw_sigterm
	* po/Makefile.devel (DSOURCES): ditto

2005-10-11  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/configure.in: check <netdb.h> and getproto*
	do not check poll() and select(), we already have SOCKET-STATUS
	* modules/rawsock/rawsock.c (protoent_to_protocol, PROTOCOL): added
	* modules/rawsock/sock.lisp (protocol): new defstruct

2005-10-10  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (FILE-PROPERTIES): use my_malloc()
	instead of malloc() and add begin_system_call()/end_system_call()

2005-10-10  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (handle_fault_range, PROT_READ_WRITE, PROT_READ):
	exported to clisp.h
	* modules/berkeley-db/bdb.c (fill_dbt, dbt_to_object): call it
	before memcpy() on lisp object data
	* modules/pcre/cpcre.c (fullinfo_firsttable): ditto
	* modules/rawsock/rawsock.c (parse_buffer_arg, check_struct_data): ditto

2005-10-10  Sam Steingold  <sds@gnu.org>

	* stream.d (handle_set): do not call stream_isbuffered on non-streams

2005-10-09  Sam Steingold  <sds@gnu.org>

	* modules/netica/wrap.lisp (*verbose*): init to NIL to avoid
	saving a closed terminal stream into the image (like with *sql-log*)
	(net-info, node-info): accept :OUT

2005-10-09  Sam Steingold  <sds@gnu.org>

	make sure that SOCKET-STATUS handles buffered streams properly
	* stream.d (handle_set): accept non_empty_buffers_p
	(handle_isset): call listen_char() and listen_byte() on buffered
	input streams even when FD_ISSET is false
	(SOCKET-STATUS): pass non_empty_buffers_p to handle_set() and
	reset timeout to 0 when non_empty_buffers_p is true
	(stream_isbuffered_low): derived from stream_isbuffered() to
	return the amount of data available in the input buffer
	(stream_isbuffered): call stream_isbuffered_low()

2005-10-08  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (XLIB:SET-DISPLAY-ERROR-HANDLER):
	fixed argument order
	Reported by Magnus Henoch <mange@freemail.hu>

2005-10-07  Sam Steingold  <sds@gnu.org>

	* modules/dirkey/Makefile.in, modules/i18n/Makefile.in:
	* modules/pari/Makefile.in, modules/pcre/Makefile.in:
	* modules/postgresql/Makefile.in, modules/rawsock/Makefile.in:
	* modules/readline/Makefile.in, modules/regexp/Makefile.in:
	* modules/syscalls/Makefile.in, modules/wildcard/Makefile.in:
	* modules/zlib/Makefile.in, modules/berkeley-db/Makefile.in:
	(config.status, config.h, Makefile): new targets:
	no need to "rm -rf" module dir when configure changes

2005-10-07  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (my_utime): use convert_time_to_universal()
	(my_utime) [WIN32_NATIVE]: a separate implementation to avoid the
	woe32 DST bugs (http://www.codeproject.com/datetime/dstbugs.asp)
	Reported by Yaroslav Kavenchuk <kavenchuk@jenty.by>
	(find_first_file, get_file_time) [WIN32_NATIVE]: new functions
	(SET-FILE-STAT): use get_file_time() and convert_time_to_universal()
	(FILE-INFO): accept an optional argument ALL-P, use find_first_file()

2005-10-06  Sam Steingold  <sds@gnu.org>

	* foreign.d (object_handle, object_address): name is an object
	(update_library, validate_fpointer): reworked to avoid GC safety issues

2005-10-06  Sam Steingold  <sds@gnu.org>

	* modules/postgresql/configure.in: check all functions interfaced to
	do not abort when PQserverVersion() is not found
	* modules/postgresql/postgresql.lisp: include <clisp.h> & <config.h>

2005-10-06  Sam Steingold  <sds@gnu.org>

	* modules/i18n/gettext.c (SET-TEXTDOMAINDIR): fixed a GC-safety bug
	(LOCALE-CONV): p_sep_by_space, n_sep_by_space, p_sign_posn,
	n_sign_posn, int_p_sep_by_space, int_n_sep_by_space,
	int_p_sign_posn, int_n_sign_posn are integers, not booleans

2005-10-06  Sam Steingold  <sds@gnu.org>

	* foreign.d (update_library): fixed a GC-safety bug

2005-10-06  Sam Steingold  <sds@gnu.org>

	* misc.d (MODULE-INFO): fixed a GC-safety bug
	* modules/berkeley-db/test.tst, modules/i18n/test.tst:
	* modules/pcre/test.tst, modules/rawsock/test.tst:
	* modules/regexp/test.tst, modules/syscalls/test.tst: call MODULE-INFO

2005-10-06  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (SOCK-LISTEN): renamed from LISTEN
	* modules/rawsock/sock.lisp (LISTEN): do not shadow the CL symbol
	(SOCK-LISTEN): export

2005-10-05  Sam Steingold  <sds@gnu.org>

	* modules/readline/configure.in: abort when readline is not used
	test for all functions and variables interfaced to
	* modules/readline/test.tst: new file
	* modules/readline/readline.lisp: include config.h
	(*foreign-guard*) [compilation]: set to T
	(add-defun): fixed "name" argument allocation
	(readline-name): fixed :ALLOC
	* modules/postgresql/configure.in: check for PQinitSSL()
	* modules/postgresql/postgresql.lisp: interface to PQinitSSL()
	(*foreign-guard*) [compilation]: set to T
	* modules/bindings/win32/win32.lisp: interface to longhorn
	functions GetProcessId(), GetProcessIdOfThread(), GetThreadId()
	(*foreign-guard*) [compilation]: set to T
	* modules/bindings/win32/test.tst: enabled tests for longhorn functions

2005-10-05  Sam Steingold  <sds@gnu.org>

	* modules/i18n/i18n.lisp (locale-conv-p): export
	* modules/i18n/test.tst: new file

2005-10-05  Sam Steingold  <sds@gnu.org>

	* stream.d (init_streamvars) [HAVE_DECL_RL_READLINE_NAME]:
	init rl_readline_name
	* m4/readline.m4 (CL_READLINE): fixed the rl_readline_name test

2005-10-05  Sam Steingold  <sds@gnu.org>

	FFI modules can now take advantage of autoconf feature detection.
	* foreign.d (LOOKUP-FOREIGN-VARIABLE, LOOKUP-FOREIGN-FUNCTION)
	(object_handle): signal a continuable error when the foreign
	object cannot be found
	(update_library, object_address): updated for the changes in
	object_handle()
	(FOREIGN-LIBRARY-VARIABLE, FOREIGN-LIBRARY-FUNCTION): return NIL when
	the foreign object cannot be found and the CONTINUE restart was invoked
	* foreign1.lisp (*foreign-guard*): new variable
	(finalize-coutput-file): when it is non-NIL, guard the forms with
	CPP #if conditionals
	(def-c-var, def-call-out): do nothing when the foreign object
	cannot be found and the CONTINUE restart was invoked

2005-10-03  Sam Steingold  <sds@gnu.org>

	functions that take a BUFFER, also take :START and :END
	* modules/rawsock/rawsock.c (parse_buffer_arg):
	check STACK_0, STACK_1: START & END
	(RECV, RECVFROM, SOCK-READ, SEND, SENDTO, SOCK-WRITE)
	(IPCSUM, ICMPCSUM, TCPCSUM, UDPCSUM): accept :START & :END

2005-10-03  Sam Steingold  <sds@gnu.org>

	* configure.in: $ac_cv_use_readline is tested in CL_READLINE
	already, do not test it here too
	* m4/readline.m4 (CL_READLINE): check for rl_readline_name

2005-10-02  Sam Steingold  <sds@gnu.org>

	* stream.d (handle_isset): do not call listen_byte() on raw sockets
	Reported by Don Cohen

2005-10-02  Sam Steingold  <sds@gnu.org>

	foreign.d data walkers is now reentrant (no static data)
	* lispbibl.d (converter_malloc_t): typedef & export to clisp.h
	(convert_to_foreign_mallocing, convert_to_foreign_nomalloc):
	removed prototypes
	(convert_to_foreign): prototype
	* foreign.d (foreign_layout): new structure type
	(data_size, data_alignment, data_splittable): removed statics
	(foreign_layout, convert_to_foreign_needs):
	accept a pointer to struct foreign_layout
	(foreign_size): new inline
	(%SIZEOF, %BITSIZEOF, convert_from_foreign, LOOKUP-FOREIGN-VARIABLE)
	(FOREIGN-VARIABLE, SET-FOREIGN-VALUE, SLOT, DEREF, CAST, OFFSET)
	(EXEC-ON-STACK, FOREIGN-ALLOCATE, FOREIGN-CALL-OUT, do_va_arg, callback)
	(FOREIGN-LIBRARY-VARIABLE): updated for the new foreign_layout()
	(walk_foreign): new structure type
	(walk_foreign_null_terminates, walk_foreign_pre_hook)
	(walk_foreign_post_hook, walk_foreign_function_hook): removed statics
	(walk_foreign_pointers, free_walk_pre, free_walk_post)
	(free_walk_function): accept a pointer to struct walk_foreign
	(free_foreign): updated for the new walk_foreign_pointers()
	(walk_lisp): new structure type
	(walk_lisp_nil_terminates, walk_lisp_pre_hook, walk_lisp_post_hook)
	(walk_lisp_function_hook, walk_counter, walk_alignment): removed statics
	(walk_lisp_pointers, count_walk_pre, count_walk_post):
	accept a pointer to struct walk_lisp
	(converter_malloc): removed a static
	(convert_to_foreign): accept a converter_malloc_t
	(convert_to_foreign_allocaing, convert_to_foreign_mallocing)
	(convert_to_foreign_nomalloc): removed
	(libc_handle): removed old unused junk

2005-10-02  Sam Steingold  <sds@gnu.org>

	* pathname.d (PARSE-NAMESTRING) [cygwin]: fixed GC-safety bug

2005-10-01  Sam Steingold  <sds@gnu.org>

	GC-safety bug: validate fpointers lazily, not eagerly
	* foreign.d (foreign_address): fixed GCTRIGGER_IF statement
	(free_foreign_callin): call free_callback() only on valid pointers
	(check_faddress_valid): new function
	(SET-FOREIGN-POINTER, FOREIGN-FUNCTION, convert_to_foreign)
	(LOOKUP-FOREIGN-VARIABLE, FOREIGN-VARIABLE, FOREIGN-VALUE)
	(SET-FOREIGN-VALUE, DEREF, READ-MEMORY-AS, WRITE-MEMORY-AS)
	(FOREIGN-FREE, FOREIGN-CALL-OUT): call it
	(validate_fpointer): local, maygc
	* io.d (pr_orecord): use Faddress_value, not Fpointer_value_no_check
	* lispbibl.d (Fpointer_value, Faddress_value):
	do not validate the argument
	(check_faddress_valid): declare
	* misc.d (CODE-ADDRESS-OF): explicitly validate faddress

2005-10-02  Sam Steingold  <sds@gnu.org>

	* stream.d (SOCKET-STREAM-SHUTDOWN): handle is uint, not uint32
	(SOCKET-CONNECT, sock_opt_int, SOCKET-OPTIONS):
	use check_uint() instead of fehler_uint()

2005-09-30  Sam Steingold  <sds@gnu.org>

	clisp -v -v sets *LOAD-ECHO* to T
	* constsym.d (load_echo): added
	* spvw.d (init_symbol_values): init *load-echo* to NIL
	(main_actions): when argv_verbose > 3, set *load-echo* to T

2005-09-30  Sam Steingold  <sds@gnu.org>

	* foreign.d (open_library): quite a few platforms do not define
	RTLD_DEFAULT, but accept NULL as a library handle to mean the
	same (e.g., WIN32, FreeBSD, MacOSX), so we always accept :DEFAULT

2005-09-29  Sam Steingold  <sds@gnu.org>

	enable saving callbacks into memory images
	* foreign.d (convert_function_to_foreign): when the Ffunction
	found in O(foreign_callin_table) is invalid, renew it
	Reported by Tomas Zellerin <zellerin@gmail.com>

2005-09-30  Sam Steingold  <sds@gnu.org>

	* makemake.in (BASE_MODULES): fixed last patch:
	add "readline" only when libreadline is actually available

2005-09-29  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (MODULES): added readline
	* makemake.in (BASE_MODULES): add readline
	when both readline and FFI are present
	* modules/readline: new module directory

2005-09-29  Sam Steingold  <sds@gnu.org>

	* stream.d (get_standard_output_file_stream)
	(get_standard_error_file_stream): return a synonym stream instead
	of a terminal stream for the benefit of dribble

2005-09-29  Sam Steingold  <sds@gnu.org>

	* spvw_debug.d (nobject_out1): handle Foreign-Address

2005-09-28  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/demos/sokoban.lisp (sokoban-usage): renamed
	from USAGE to avoid a conflict with POSIX
	* modules/clx/new-clx/clx.f (travel_queque): timeout is struct timeval
	(get_timeout): removed
	(PROCESS-EVENT, EVENT-LISTEN): use sec_usec() instead of get_timeout()
	* modules/clx/new-clx/demos/clx-demos.lisp: load "koch"
	* modules/clx/new-clx/demos/koch.lisp: new demo
	* modules/clx/new-clx/clx.lisp (*keyword-package*): removed
	(kintern): do not use it
	(EVENT-COND): removed some gunk

2005-09-27  Sam Steingold  <sds@gnu.org>

	use map_sequence() instead of ELT
	* modules/clx/new-clx/clx.f (get_seq_len, set_seq): new functions
	(struct seq_rectangle, coerce_into_rectangle): MAP infrastructure
	(SET-GCONTEXT-CLIP-MASK, DRAW-RECTANGLES, SHAPE-COMBINE): use it
	(struct seq_point, coerce_into_point): MAP infrastructure
	(DRAW-POINTS): use it
	(struct seq_segment, coerce_into_segment): MAP infrastructure
	(DRAW-SEGMENTS): use it
	(struct seq_arc, coerce_into_arc): MAP infrastructure
	(DRAW-ARCS): use it
	(struct seq_path, coerce_into_path): MAP infrastructure
	(SET-FONT-PATH): use it
	(struct seq_pixel, coerce_into_pixel): MAP infrastructure
	(FREE-COLORS): use it
	(struct seq_color, coerce_into_color): MAP infrastructure
	(QUERY-COLORS): use it
	(struct seq_pixel_color, coerce_into_pixel_color): MAP infrastructure
	(STORE-COLORS): use it
	(struct seq_map, coerce_into_map): MAP infrastructure
	(CHANGE-PROPERTY): use it
	(struct seq_xatom, coerce_into_xatom): MAP infrastructure
	(ROTATE-PROPERTIES): use it
	(struct seq_uint8, coerce_into_uint8): MAP infrastructure
	(SET-POINTER-MAPPING): use it
	* modules/clx/new-clx/demos/sokoban.lisp (find-outers): pass a
	flat list to SHAPE-COMBINE instead of a list of lists

2005-09-27  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (map_sequence_function_t): do not use
	emit_typedef_f() because g++ complains:
	error: invalid application of `sizeof' to a function type

2005-09-27  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (MAKE-SOCKADDR): DATA is optional and
	can be an integer specifying the data size (0 content)

2005-09-26  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (map_sequence_function_t, map_sequence): export to clisp.h
	* modules/rawsock/rawsock.c (MAKE-SOCKADDR): use them to accept
	arbitrary sequences as DATA instead of requiring a byte vector

2005-09-26  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c (check_buffer_arg): removed
	(parse_buffer_arg): accept arbitrary vectors
	(BUFFER, RESIZE-BUFFER): removed
